/* Surface.c generated by valac 0.56.17, the Vala compiler
 * generated from Surface.vala, do not modify */

/**/
/*  Copyright (C) 2011-2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <cairo-gobject.h>
#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <string.h>

#define PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION 16
#define PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION 7
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PLANK_SURFACE_0_PROPERTY,
	PLANK_SURFACE_INTERNAL_PROPERTY,
	PLANK_SURFACE_WIDTH_PROPERTY,
	PLANK_SURFACE_HEIGHT_PROPERTY,
	PLANK_SURFACE_CONTEXT_PROPERTY,
	PLANK_SURFACE_NUM_PROPERTIES
};
static GParamSpec* plank_surface_properties[PLANK_SURFACE_NUM_PROPERTIES];
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
typedef struct _Block6Data Block6Data;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PlankSurfacePrivate {
	cairo_surface_t* _Internal;
	gint _Width;
	gint _Height;
	cairo_t* _Context;
};

struct _Block5Data {
	int _ref_count_;
	PlankSurface* self;
	gint alpha;
	gint height;
	gint width;
	guint8* pixels;
};

struct _Block6Data {
	int _ref_count_;
	PlankSurface* self;
	gint gaussWidth;
	gdouble* kernel;
	gint kernel_length1;
	gint _kernel_size_;
	gint width;
	gint height;
	gdouble* abuffer;
	gint abuffer_length1;
	gint _abuffer_size_;
	gdouble* bbuffer;
	gint bbuffer_length1;
	gint _bbuffer_size_;
	gint* shiftar;
	gint shiftar_length1;
	gint shiftar_length2;
	gint _shiftar_size_;
};

static gint PlankSurface_private_offset;
static gpointer plank_surface_parent_class = NULL;

static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void* __lambda4_ (Block5Data* _data5_);
static void plank_surface_exponential_blur_rows (guint8* pixels,
                                          gint width,
                                          gint height,
                                          gint startRow,
                                          gint endRow,
                                          gint startX,
                                          gint endX,
                                          gint alpha);
static gpointer ___lambda4__gthread_func (gpointer self);
static void* __lambda5_ (Block5Data* _data5_);
static void plank_surface_exponential_blur_columns (guint8* pixels,
                                             gint width,
                                             gint height,
                                             gint startCol,
                                             gint endCol,
                                             gint startY,
                                             gint endY,
                                             gint alpha);
static gpointer ___lambda5__gthread_func (gpointer self);
static inline void plank_surface_exponential_blur_inner (guint8* pixel,
                                           gint* zA,
                                           gint* zR,
                                           gint* zG,
                                           gint* zB,
                                           gint alpha);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static gdouble* plank_surface_build_gaussian_kernel (gint gaussWidth,
                                              gint* result_length1);
static void* __lambda6_ (Block6Data* _data6_);
static void plank_surface_gaussian_blur_horizontal (gdouble* src,
                                             gdouble* dest,
                                             gdouble* kernel,
                                             gint gaussWidth,
                                             gint width,
                                             gint height,
                                             gint startRow,
                                             gint endRow,
                                             gint* shift,
                                             gint shift_length1,
                                             gint shift_length2);
static gpointer ___lambda6__gthread_func (gpointer self);
static void* __lambda7_ (Block6Data* _data6_);
static void plank_surface_gaussian_blur_vertical (gdouble* src,
                                           gdouble* dest,
                                           gdouble* kernel,
                                           gint gaussWidth,
                                           gint width,
                                           gint height,
                                           gint startCol,
                                           gint endCol,
                                           gint* shift,
                                           gint shift_length1,
                                           gint shift_length2);
static gpointer ___lambda7__gthread_func (gpointer self);
static GObject * plank_surface_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void plank_surface_finalize (GObject * obj);
static GType plank_surface_get_type_once (void);
static void _vala_plank_surface_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_plank_surface_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);

static inline gpointer
plank_surface_get_instance_private (PlankSurface* self)
{
	return G_STRUCT_MEMBER_P (self, PlankSurface_private_offset);
}

/**
 * Creates a new surface.
 *
 * @param width width of the new surface
 * @param height height of the new surface
 */
PlankSurface*
plank_surface_construct (GType object_type,
                         gint width,
                         gint height)
{
	PlankSurface * self = NULL;
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp1_;
#line 59 "../lib/Drawing/Surface.vala"
	_tmp0_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, width, height);
#line 59 "../lib/Drawing/Surface.vala"
	_tmp1_ = _tmp0_;
#line 59 "../lib/Drawing/Surface.vala"
	self = (PlankSurface*) g_object_new (object_type, "Width", width, "Height", height, "Internal", _tmp1_, NULL);
#line 59 "../lib/Drawing/Surface.vala"
	_cairo_surface_destroy0 (_tmp1_);
#line 57 "../lib/Drawing/Surface.vala"
	return self;
#line 207 "Surface.c"
}

PlankSurface*
plank_surface_new (gint width,
                   gint height)
{
#line 57 "../lib/Drawing/Surface.vala"
	return plank_surface_construct (PLANK_TYPE_SURFACE, width, height);
#line 216 "Surface.c"
}

/**
 * Creates a new surface compatible with an existing {@link Cairo.Surface}.
 *
 * @param width width of the new surface
 * @param height height of the new surface
 * @param model existing {@link Cairo.Surface} to be similar to
 */
PlankSurface*
plank_surface_construct_with_cairo_surface (GType object_type,
                                            gint width,
                                            gint height,
                                            cairo_surface_t* model)
{
	PlankSurface * self = NULL;
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp1_;
#line 69 "../lib/Drawing/Surface.vala"
	g_return_val_if_fail (model != NULL, NULL);
#line 71 "../lib/Drawing/Surface.vala"
	_tmp0_ = cairo_surface_create_similar (model, CAIRO_CONTENT_COLOR_ALPHA, width, height);
#line 71 "../lib/Drawing/Surface.vala"
	_tmp1_ = _tmp0_;
#line 71 "../lib/Drawing/Surface.vala"
	self = (PlankSurface*) g_object_new (object_type, "Width", width, "Height", height, "Internal", _tmp1_, NULL);
#line 71 "../lib/Drawing/Surface.vala"
	_cairo_surface_destroy0 (_tmp1_);
#line 69 "../lib/Drawing/Surface.vala"
	return self;
#line 247 "Surface.c"
}

PlankSurface*
plank_surface_new_with_cairo_surface (gint width,
                                      gint height,
                                      cairo_surface_t* model)
{
#line 69 "../lib/Drawing/Surface.vala"
	return plank_surface_construct_with_cairo_surface (PLANK_TYPE_SURFACE, width, height, model);
#line 257 "Surface.c"
}

/**
 * Creates a new surface compatible with an existing {@link Surface}.
 *
 * @param width width of the new surface
 * @param height height of the new surface
 * @param model existing {@link Surface} to be similar to
 */
PlankSurface*
plank_surface_construct_with_surface (GType object_type,
                                      gint width,
                                      gint height,
                                      PlankSurface* model)
{
	PlankSurface * self = NULL;
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp1_;
	cairo_surface_t* _tmp2_;
#line 81 "../lib/Drawing/Surface.vala"
	g_return_val_if_fail (model != NULL, NULL);
#line 83 "../lib/Drawing/Surface.vala"
	_tmp0_ = model->priv->_Internal;
#line 83 "../lib/Drawing/Surface.vala"
	_tmp1_ = cairo_surface_create_similar (_tmp0_, CAIRO_CONTENT_COLOR_ALPHA, width, height);
#line 83 "../lib/Drawing/Surface.vala"
	_tmp2_ = _tmp1_;
#line 83 "../lib/Drawing/Surface.vala"
	self = (PlankSurface*) g_object_new (object_type, "Width", width, "Height", height, "Internal", _tmp2_, NULL);
#line 83 "../lib/Drawing/Surface.vala"
	_cairo_surface_destroy0 (_tmp2_);
#line 81 "../lib/Drawing/Surface.vala"
	return self;
#line 291 "Surface.c"
}

PlankSurface*
plank_surface_new_with_surface (gint width,
                                gint height,
                                PlankSurface* model)
{
#line 81 "../lib/Drawing/Surface.vala"
	return plank_surface_construct_with_surface (PLANK_TYPE_SURFACE, width, height, model);
#line 301 "Surface.c"
}

/**
 * Creates a new surface with the given {@link Cairo.ImageSurface} as Internal.
 *
 * @param image existing {@link Cairo.ImageSurface} as Internal
 */
PlankSurface*
plank_surface_construct_with_internal (GType object_type,
                                       cairo_surface_t* image)
{
	PlankSurface * self = NULL;
#line 91 "../lib/Drawing/Surface.vala"
	g_return_val_if_fail (image != NULL, NULL);
#line 93 "../lib/Drawing/Surface.vala"
	self = (PlankSurface*) g_object_new (object_type, "Width", cairo_image_surface_get_width (image), "Height", cairo_image_surface_get_height (image), "Internal", image, NULL);
#line 91 "../lib/Drawing/Surface.vala"
	return self;
#line 320 "Surface.c"
}

PlankSurface*
plank_surface_new_with_internal (cairo_surface_t* image)
{
#line 91 "../lib/Drawing/Surface.vala"
	return plank_surface_construct_with_internal (PLANK_TYPE_SURFACE, image);
#line 328 "Surface.c"
}

/**
 * Clears the entire surface.
 */
void
plank_surface_clear (PlankSurface* self)
{
	cairo_t* cr = NULL;
	cairo_t* _tmp0_;
#line 104 "../lib/Drawing/Surface.vala"
	g_return_if_fail (self != NULL);
#line 106 "../lib/Drawing/Surface.vala"
	_tmp0_ = self->priv->_Context;
#line 106 "../lib/Drawing/Surface.vala"
	cr = _tmp0_;
#line 108 "../lib/Drawing/Surface.vala"
	cairo_save (cr);
#line 109 "../lib/Drawing/Surface.vala"
	cairo_set_operator (cr, CAIRO_OPERATOR_CLEAR);
#line 110 "../lib/Drawing/Surface.vala"
	cairo_paint (cr);
#line 111 "../lib/Drawing/Surface.vala"
	cairo_restore (cr);
#line 353 "Surface.c"
}

/**
 * Create a copy of the surface
 *
 * @return copy of this surface
 */
PlankSurface*
plank_surface_copy (PlankSurface* self)
{
	PlankSurface* copy = NULL;
	gint _tmp0_;
	gint _tmp1_;
	PlankSurface* _tmp2_;
	cairo_t* cr = NULL;
	cairo_t* _tmp3_;
	cairo_surface_t* _tmp4_;
	PlankSurface* result;
#line 119 "../lib/Drawing/Surface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 121 "../lib/Drawing/Surface.vala"
	_tmp0_ = self->priv->_Width;
#line 121 "../lib/Drawing/Surface.vala"
	_tmp1_ = self->priv->_Height;
#line 121 "../lib/Drawing/Surface.vala"
	_tmp2_ = plank_surface_new_with_surface (_tmp0_, _tmp1_, self);
#line 121 "../lib/Drawing/Surface.vala"
	copy = _tmp2_;
#line 122 "../lib/Drawing/Surface.vala"
	_tmp3_ = copy->priv->_Context;
#line 122 "../lib/Drawing/Surface.vala"
	cr = _tmp3_;
#line 124 "../lib/Drawing/Surface.vala"
	_tmp4_ = self->priv->_Internal;
#line 124 "../lib/Drawing/Surface.vala"
	cairo_set_source_surface (cr, _tmp4_, (gdouble) 0, (gdouble) 0);
#line 125 "../lib/Drawing/Surface.vala"
	cairo_paint (cr);
#line 127 "../lib/Drawing/Surface.vala"
	result = copy;
#line 127 "../lib/Drawing/Surface.vala"
	return result;
#line 396 "Surface.c"
}

/**
 * Create a scaled copy of the surface
 *
 * @param width the resulting width
 * @param height the resulting height
 * @return scaled copy of this surface
 */
PlankSurface*
plank_surface_scaled_copy (PlankSurface* self,
                           gint width,
                           gint height)
{
	PlankSurface* _result_ = NULL;
	PlankSurface* _tmp0_;
	cairo_t* cr = NULL;
	cairo_t* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	cairo_surface_t* _tmp4_;
	PlankSurface* result;
#line 137 "../lib/Drawing/Surface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 139 "../lib/Drawing/Surface.vala"
	_tmp0_ = plank_surface_new_with_surface (width, height, self);
#line 139 "../lib/Drawing/Surface.vala"
	_result_ = _tmp0_;
#line 140 "../lib/Drawing/Surface.vala"
	_tmp1_ = _result_->priv->_Context;
#line 140 "../lib/Drawing/Surface.vala"
	cr = _tmp1_;
#line 142 "../lib/Drawing/Surface.vala"
	cairo_save (cr);
#line 143 "../lib/Drawing/Surface.vala"
	_tmp2_ = self->priv->_Width;
#line 143 "../lib/Drawing/Surface.vala"
	_tmp3_ = self->priv->_Height;
#line 143 "../lib/Drawing/Surface.vala"
	cairo_scale (cr, ((gdouble) width) / _tmp2_, ((gdouble) height) / _tmp3_);
#line 144 "../lib/Drawing/Surface.vala"
	_tmp4_ = self->priv->_Internal;
#line 144 "../lib/Drawing/Surface.vala"
	cairo_set_source_surface (cr, _tmp4_, (gdouble) 0, (gdouble) 0);
#line 145 "../lib/Drawing/Surface.vala"
	cairo_paint (cr);
#line 146 "../lib/Drawing/Surface.vala"
	cairo_restore (cr);
#line 148 "../lib/Drawing/Surface.vala"
	result = _result_;
#line 148 "../lib/Drawing/Surface.vala"
	return result;
#line 449 "Surface.c"
}

/**
 * Saves the current surface to a {@link Gdk.Pixbuf}.
 *
 * @return the {@link Gdk.Pixbuf}
 */
GdkPixbuf*
plank_surface_to_pixbuf (PlankSurface* self)
{
	cairo_surface_t* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* result;
#line 156 "../lib/Drawing/Surface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 158 "../lib/Drawing/Surface.vala"
	_tmp0_ = self->priv->_Internal;
#line 158 "../lib/Drawing/Surface.vala"
	_tmp1_ = self->priv->_Width;
#line 158 "../lib/Drawing/Surface.vala"
	_tmp2_ = self->priv->_Height;
#line 158 "../lib/Drawing/Surface.vala"
	_tmp3_ = gdk_pixbuf_get_from_surface (_tmp0_, 0, 0, _tmp1_, _tmp2_);
#line 158 "../lib/Drawing/Surface.vala"
	result = _tmp3_;
#line 158 "../lib/Drawing/Surface.vala"
	return result;
#line 479 "Surface.c"
}

/**
 * Computes the mask of the surface.
 *
 * @param threshold value defining the minimum opacity [0.0 .. 1.0]
 * @param extent bounding box of the found mask
 * @return a new surface containing the mask
 */
PlankSurface*
plank_surface_create_mask (PlankSurface* self,
                           gdouble threshold,
                           GdkRectangle* extent)
{
	GdkRectangle _vala_extent = {0};
	cairo_surface_t* surface = NULL;
	gint _tmp0_;
	gint _tmp1_;
	cairo_surface_t* _tmp2_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp3_;
	cairo_t* _tmp4_;
	cairo_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_surface_t* _tmp7_;
	cairo_t* _tmp8_;
	gint w = 0;
	cairo_surface_t* _tmp9_;
	gint h = 0;
	cairo_surface_t* _tmp10_;
	guint8 slice = 0U;
	gint left = 0;
	gint right = 0;
	gint top = 0;
	gint bottom = 0;
	guint8* data = NULL;
	cairo_surface_t* _tmp11_;
	guchar* _tmp12_;
	gint src = 0;
	gboolean mask = FALSE;
	GdkRectangle _tmp24_ = {0};
	cairo_surface_t* _tmp25_;
	PlankSurface* _tmp26_;
	PlankSurface* result;
#line 168 "../lib/Drawing/Surface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 168 "../lib/Drawing/Surface.vala"
	_vala_return_val_if_fail ((threshold >= 0.0) && (threshold <= 1.0), "threshold >= 0.0 && threshold <= 1.0", NULL);
#line 171 "../lib/Drawing/Surface.vala"
	_tmp0_ = self->priv->_Width;
#line 171 "../lib/Drawing/Surface.vala"
	_tmp1_ = self->priv->_Height;
#line 171 "../lib/Drawing/Surface.vala"
	_tmp2_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp0_, _tmp1_);
#line 171 "../lib/Drawing/Surface.vala"
	surface = _tmp2_;
#line 172 "../lib/Drawing/Surface.vala"
	_tmp3_ = surface;
#line 172 "../lib/Drawing/Surface.vala"
	_tmp4_ = cairo_create (_tmp3_);
#line 172 "../lib/Drawing/Surface.vala"
	cr = _tmp4_;
#line 174 "../lib/Drawing/Surface.vala"
	_tmp5_ = cr;
#line 174 "../lib/Drawing/Surface.vala"
	cairo_set_operator (_tmp5_, CAIRO_OPERATOR_SOURCE);
#line 175 "../lib/Drawing/Surface.vala"
	_tmp6_ = cr;
#line 175 "../lib/Drawing/Surface.vala"
	_tmp7_ = self->priv->_Internal;
#line 175 "../lib/Drawing/Surface.vala"
	cairo_set_source_surface (_tmp6_, _tmp7_, (gdouble) 0, (gdouble) 0);
#line 176 "../lib/Drawing/Surface.vala"
	_tmp8_ = cr;
#line 176 "../lib/Drawing/Surface.vala"
	cairo_paint (_tmp8_);
#line 178 "../lib/Drawing/Surface.vala"
	_tmp9_ = surface;
#line 178 "../lib/Drawing/Surface.vala"
	w = cairo_image_surface_get_width (_tmp9_);
#line 179 "../lib/Drawing/Surface.vala"
	_tmp10_ = surface;
#line 179 "../lib/Drawing/Surface.vala"
	h = cairo_image_surface_get_height (_tmp10_);
#line 180 "../lib/Drawing/Surface.vala"
	slice = (guint8) (G_MAXUINT8 * threshold);
#line 182 "../lib/Drawing/Surface.vala"
	left = w;
#line 183 "../lib/Drawing/Surface.vala"
	right = 0;
#line 184 "../lib/Drawing/Surface.vala"
	top = h;
#line 185 "../lib/Drawing/Surface.vala"
	bottom = 0;
#line 187 "../lib/Drawing/Surface.vala"
	_tmp11_ = surface;
#line 187 "../lib/Drawing/Surface.vala"
	_tmp12_ = cairo_image_surface_get_data (_tmp11_);
#line 187 "../lib/Drawing/Surface.vala"
	data = _tmp12_;
#line 580 "Surface.c"
	{
		gint y = 0;
#line 191 "../lib/Drawing/Surface.vala"
		y = 0;
#line 585 "Surface.c"
		{
			gboolean _tmp13_ = FALSE;
#line 191 "../lib/Drawing/Surface.vala"
			_tmp13_ = TRUE;
#line 191 "../lib/Drawing/Surface.vala"
			while (TRUE) {
#line 191 "../lib/Drawing/Surface.vala"
				if (!_tmp13_) {
#line 594 "Surface.c"
					gint _tmp14_;
#line 191 "../lib/Drawing/Surface.vala"
					_tmp14_ = y;
#line 191 "../lib/Drawing/Surface.vala"
					y = _tmp14_ + 1;
#line 600 "Surface.c"
				}
#line 191 "../lib/Drawing/Surface.vala"
				_tmp13_ = FALSE;
#line 191 "../lib/Drawing/Surface.vala"
				if (!(y < h)) {
#line 191 "../lib/Drawing/Surface.vala"
					break;
#line 608 "Surface.c"
				}
				{
					gint x = 0;
#line 192 "../lib/Drawing/Surface.vala"
					x = 0;
#line 614 "Surface.c"
					{
						gboolean _tmp15_ = FALSE;
#line 192 "../lib/Drawing/Surface.vala"
						_tmp15_ = TRUE;
#line 192 "../lib/Drawing/Surface.vala"
						while (TRUE) {
#line 621 "Surface.c"
							guint8* _tmp17_;
							guint8 _tmp18_;
							guint8* _tmp19_;
							guint8* _tmp20_;
							guint8* _tmp21_;
							guint8 _tmp22_ = 0U;
							guint8* _tmp23_;
#line 192 "../lib/Drawing/Surface.vala"
							if (!_tmp15_) {
#line 631 "Surface.c"
								gint _tmp16_;
#line 192 "../lib/Drawing/Surface.vala"
								_tmp16_ = x;
#line 192 "../lib/Drawing/Surface.vala"
								x = _tmp16_ + 1;
#line 637 "Surface.c"
							}
#line 192 "../lib/Drawing/Surface.vala"
							_tmp15_ = FALSE;
#line 192 "../lib/Drawing/Surface.vala"
							if (!(x < w)) {
#line 192 "../lib/Drawing/Surface.vala"
								break;
#line 645 "Surface.c"
							}
#line 193 "../lib/Drawing/Surface.vala"
							src = ((y * w) + x) * 4;
#line 195 "../lib/Drawing/Surface.vala"
							_tmp17_ = data;
#line 195 "../lib/Drawing/Surface.vala"
							_tmp18_ = _tmp17_[src + 3];
#line 195 "../lib/Drawing/Surface.vala"
							mask = _tmp18_ > slice;
#line 197 "../lib/Drawing/Surface.vala"
							_tmp19_ = data;
#line 197 "../lib/Drawing/Surface.vala"
							_tmp19_[src + 0] = (guint8) 0;
#line 198 "../lib/Drawing/Surface.vala"
							_tmp20_ = data;
#line 198 "../lib/Drawing/Surface.vala"
							_tmp20_[src + 1] = (guint8) 0;
#line 199 "../lib/Drawing/Surface.vala"
							_tmp21_ = data;
#line 199 "../lib/Drawing/Surface.vala"
							_tmp21_[src + 2] = (guint8) 0;
#line 200 "../lib/Drawing/Surface.vala"
							if (mask) {
#line 200 "../lib/Drawing/Surface.vala"
								_tmp22_ = G_MAXUINT8;
#line 671 "Surface.c"
							} else {
#line 200 "../lib/Drawing/Surface.vala"
								_tmp22_ = (guint8) 0;
#line 675 "Surface.c"
							}
#line 200 "../lib/Drawing/Surface.vala"
							_tmp23_ = data;
#line 200 "../lib/Drawing/Surface.vala"
							_tmp23_[src + 3] = _tmp22_;
#line 202 "../lib/Drawing/Surface.vala"
							if (mask) {
#line 203 "../lib/Drawing/Surface.vala"
								if (y < top) {
#line 204 "../lib/Drawing/Surface.vala"
									top = y;
#line 687 "Surface.c"
								}
#line 205 "../lib/Drawing/Surface.vala"
								if (y > bottom) {
#line 206 "../lib/Drawing/Surface.vala"
									bottom = y;
#line 693 "Surface.c"
								}
#line 207 "../lib/Drawing/Surface.vala"
								if (x < left) {
#line 208 "../lib/Drawing/Surface.vala"
									left = x;
#line 699 "Surface.c"
								}
#line 209 "../lib/Drawing/Surface.vala"
								if (x > right) {
#line 210 "../lib/Drawing/Surface.vala"
									right = x;
#line 705 "Surface.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 215 "../lib/Drawing/Surface.vala"
	_tmp24_.x = left;
#line 215 "../lib/Drawing/Surface.vala"
	_tmp24_.y = top;
#line 215 "../lib/Drawing/Surface.vala"
	_tmp24_.width = right - left;
#line 215 "../lib/Drawing/Surface.vala"
	_tmp24_.height = bottom - top;
#line 215 "../lib/Drawing/Surface.vala"
	_vala_extent = _tmp24_;
#line 217 "../lib/Drawing/Surface.vala"
	_tmp25_ = surface;
#line 217 "../lib/Drawing/Surface.vala"
	_tmp26_ = plank_surface_new_with_internal (_tmp25_);
#line 217 "../lib/Drawing/Surface.vala"
	result = _tmp26_;
#line 217 "../lib/Drawing/Surface.vala"
	_cairo_destroy0 (cr);
#line 217 "../lib/Drawing/Surface.vala"
	_cairo_surface_destroy0 (surface);
#line 217 "../lib/Drawing/Surface.vala"
	if (extent) {
#line 217 "../lib/Drawing/Surface.vala"
		*extent = _vala_extent;
#line 738 "Surface.c"
	}
#line 217 "../lib/Drawing/Surface.vala"
	return result;
#line 742 "Surface.c"
}

/**
 * Computes and returns the average color of the surface.
 *
 * @return the average color of the surface
 */
void
plank_surface_average_color (PlankSurface* self,
                             PlankColor* result)
{
	cairo_surface_t* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
	PlankColor _tmp5_ = {0};
	PlankColor _tmp6_;
#line 225 "../lib/Drawing/Surface.vala"
	g_return_if_fail (self != NULL);
#line 227 "../lib/Drawing/Surface.vala"
	_tmp0_ = self->priv->_Internal;
#line 227 "../lib/Drawing/Surface.vala"
	_tmp1_ = self->priv->_Width;
#line 227 "../lib/Drawing/Surface.vala"
	_tmp2_ = self->priv->_Height;
#line 227 "../lib/Drawing/Surface.vala"
	_tmp3_ = gdk_pixbuf_get_from_surface (_tmp0_, 0, 0, _tmp1_, _tmp2_);
#line 227 "../lib/Drawing/Surface.vala"
	_tmp4_ = _tmp3_;
#line 227 "../lib/Drawing/Surface.vala"
	plank_drawing_service_average_color (_tmp4_, &_tmp5_);
#line 227 "../lib/Drawing/Surface.vala"
	_tmp6_ = _tmp5_;
#line 227 "../lib/Drawing/Surface.vala"
	_g_object_unref0 (_tmp4_);
#line 227 "../lib/Drawing/Surface.vala"
	*result = _tmp6_;
#line 227 "../lib/Drawing/Surface.vala"
	return;
#line 783 "Surface.c"
}

/**
 * Performs a fast blur on the surface.
 *
 * @param radius the radius of the blur
 * @param process_count how many iterations to blur
 */
void
plank_surface_fast_blur (PlankSurface* self,
                         gint radius,
                         gint process_count)
{
	gboolean _tmp0_ = FALSE;
	gint w = 0;
	gint _tmp1_;
	gint h = 0;
	gint _tmp2_;
	gint channels = 0;
	gboolean _tmp3_ = FALSE;
	cairo_surface_t* original = NULL;
	cairo_surface_t* _tmp4_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_t* _tmp7_;
	cairo_t* _tmp8_;
	cairo_surface_t* _tmp9_;
	cairo_t* _tmp10_;
	guint8* pixels = NULL;
	cairo_surface_t* _tmp11_;
	guchar* _tmp12_;
	guint8* buffer = NULL;
	guint8* _tmp13_;
	gint buffer_length1;
	gint _buffer_size_;
	gint* vmin = NULL;
	gint* _tmp14_;
	gint vmin_length1;
	gint _vmin_size_;
	gint* vmax = NULL;
	gint* _tmp15_;
	gint vmax_length1;
	gint _vmax_size_;
	gint div = 0;
	guint8* dv = NULL;
	guint8* _tmp16_;
	gint dv_length1;
	gint _dv_size_;
	cairo_surface_t* _tmp138_;
	cairo_t* target_cr = NULL;
	cairo_t* _tmp139_;
	cairo_t* _tmp140_;
	cairo_t* _tmp141_;
	cairo_t* _tmp142_;
	cairo_surface_t* _tmp143_;
	cairo_t* _tmp144_;
	cairo_t* _tmp145_;
#line 236 "../lib/Drawing/Surface.vala"
	g_return_if_fail (self != NULL);
#line 238 "../lib/Drawing/Surface.vala"
	if (radius < 1) {
#line 238 "../lib/Drawing/Surface.vala"
		_tmp0_ = TRUE;
#line 848 "Surface.c"
	} else {
#line 238 "../lib/Drawing/Surface.vala"
		_tmp0_ = process_count < 1;
#line 852 "Surface.c"
	}
#line 238 "../lib/Drawing/Surface.vala"
	if (_tmp0_) {
#line 239 "../lib/Drawing/Surface.vala"
		return;
#line 858 "Surface.c"
	}
#line 241 "../lib/Drawing/Surface.vala"
	_tmp1_ = self->priv->_Width;
#line 241 "../lib/Drawing/Surface.vala"
	w = _tmp1_;
#line 242 "../lib/Drawing/Surface.vala"
	_tmp2_ = self->priv->_Height;
#line 242 "../lib/Drawing/Surface.vala"
	h = _tmp2_;
#line 243 "../lib/Drawing/Surface.vala"
	channels = 4;
#line 245 "../lib/Drawing/Surface.vala"
	if (radius > (w - 1)) {
#line 245 "../lib/Drawing/Surface.vala"
		_tmp3_ = TRUE;
#line 874 "Surface.c"
	} else {
#line 245 "../lib/Drawing/Surface.vala"
		_tmp3_ = radius > (h - 1);
#line 878 "Surface.c"
	}
#line 245 "../lib/Drawing/Surface.vala"
	if (_tmp3_) {
#line 246 "../lib/Drawing/Surface.vala"
		return;
#line 884 "Surface.c"
	}
#line 248 "../lib/Drawing/Surface.vala"
	_tmp4_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, w, h);
#line 248 "../lib/Drawing/Surface.vala"
	original = _tmp4_;
#line 249 "../lib/Drawing/Surface.vala"
	_tmp5_ = original;
#line 249 "../lib/Drawing/Surface.vala"
	_tmp6_ = cairo_create (_tmp5_);
#line 249 "../lib/Drawing/Surface.vala"
	cr = _tmp6_;
#line 251 "../lib/Drawing/Surface.vala"
	_tmp7_ = cr;
#line 251 "../lib/Drawing/Surface.vala"
	cairo_set_operator (_tmp7_, CAIRO_OPERATOR_SOURCE);
#line 252 "../lib/Drawing/Surface.vala"
	_tmp8_ = cr;
#line 252 "../lib/Drawing/Surface.vala"
	_tmp9_ = self->priv->_Internal;
#line 252 "../lib/Drawing/Surface.vala"
	cairo_set_source_surface (_tmp8_, _tmp9_, (gdouble) 0, (gdouble) 0);
#line 253 "../lib/Drawing/Surface.vala"
	_tmp10_ = cr;
#line 253 "../lib/Drawing/Surface.vala"
	cairo_paint (_tmp10_);
#line 255 "../lib/Drawing/Surface.vala"
	_tmp11_ = original;
#line 255 "../lib/Drawing/Surface.vala"
	_tmp12_ = cairo_image_surface_get_data (_tmp11_);
#line 255 "../lib/Drawing/Surface.vala"
	pixels = _tmp12_;
#line 256 "../lib/Drawing/Surface.vala"
	_tmp13_ = g_new0 (guint8, (w * h) * channels);
#line 256 "../lib/Drawing/Surface.vala"
	buffer = _tmp13_;
#line 256 "../lib/Drawing/Surface.vala"
	buffer_length1 = (w * h) * channels;
#line 256 "../lib/Drawing/Surface.vala"
	_buffer_size_ = buffer_length1;
#line 258 "../lib/Drawing/Surface.vala"
	_tmp14_ = g_new0 (gint, MAX (w, h));
#line 258 "../lib/Drawing/Surface.vala"
	vmin = _tmp14_;
#line 258 "../lib/Drawing/Surface.vala"
	vmin_length1 = MAX (w, h);
#line 258 "../lib/Drawing/Surface.vala"
	_vmin_size_ = vmin_length1;
#line 259 "../lib/Drawing/Surface.vala"
	_tmp15_ = g_new0 (gint, MAX (w, h));
#line 259 "../lib/Drawing/Surface.vala"
	vmax = _tmp15_;
#line 259 "../lib/Drawing/Surface.vala"
	vmax_length1 = MAX (w, h);
#line 259 "../lib/Drawing/Surface.vala"
	_vmax_size_ = vmax_length1;
#line 261 "../lib/Drawing/Surface.vala"
	div = (2 * radius) + 1;
#line 262 "../lib/Drawing/Surface.vala"
	_tmp16_ = g_new0 (guint8, 256 * div);
#line 262 "../lib/Drawing/Surface.vala"
	dv = _tmp16_;
#line 262 "../lib/Drawing/Surface.vala"
	dv_length1 = 256 * div;
#line 262 "../lib/Drawing/Surface.vala"
	_dv_size_ = dv_length1;
#line 950 "Surface.c"
	{
		gint i = 0;
#line 263 "../lib/Drawing/Surface.vala"
		i = 0;
#line 955 "Surface.c"
		{
			gboolean _tmp17_ = FALSE;
#line 263 "../lib/Drawing/Surface.vala"
			_tmp17_ = TRUE;
#line 263 "../lib/Drawing/Surface.vala"
			while (TRUE) {
#line 962 "Surface.c"
				guint8* _tmp19_;
				gint _tmp19__length1;
				guint8* _tmp20_;
				gint _tmp20__length1;
#line 263 "../lib/Drawing/Surface.vala"
				if (!_tmp17_) {
#line 969 "Surface.c"
					gint _tmp18_;
#line 263 "../lib/Drawing/Surface.vala"
					_tmp18_ = i;
#line 263 "../lib/Drawing/Surface.vala"
					i = _tmp18_ + 1;
#line 975 "Surface.c"
				}
#line 263 "../lib/Drawing/Surface.vala"
				_tmp17_ = FALSE;
#line 263 "../lib/Drawing/Surface.vala"
				_tmp19_ = dv;
#line 263 "../lib/Drawing/Surface.vala"
				_tmp19__length1 = dv_length1;
#line 263 "../lib/Drawing/Surface.vala"
				if (!(i < _tmp19__length1)) {
#line 263 "../lib/Drawing/Surface.vala"
					break;
#line 987 "Surface.c"
				}
#line 264 "../lib/Drawing/Surface.vala"
				_tmp20_ = dv;
#line 264 "../lib/Drawing/Surface.vala"
				_tmp20__length1 = dv_length1;
#line 264 "../lib/Drawing/Surface.vala"
				_tmp20_[i] = (guint8) (i / div);
#line 995 "Surface.c"
			}
		}
	}
#line 266 "../lib/Drawing/Surface.vala"
	while (TRUE) {
#line 1001 "Surface.c"
		gint _tmp21_;
#line 266 "../lib/Drawing/Surface.vala"
		_tmp21_ = process_count;
#line 266 "../lib/Drawing/Surface.vala"
		process_count = _tmp21_ - 1;
#line 266 "../lib/Drawing/Surface.vala"
		if (!(_tmp21_ > 0)) {
#line 266 "../lib/Drawing/Surface.vala"
			break;
#line 1011 "Surface.c"
		}
		{
			gint x = 0;
#line 267 "../lib/Drawing/Surface.vala"
			x = 0;
#line 1017 "Surface.c"
			{
				gboolean _tmp22_ = FALSE;
#line 267 "../lib/Drawing/Surface.vala"
				_tmp22_ = TRUE;
#line 267 "../lib/Drawing/Surface.vala"
				while (TRUE) {
#line 1024 "Surface.c"
					gint* _tmp24_;
					gint _tmp24__length1;
					gint* _tmp25_;
					gint _tmp25__length1;
#line 267 "../lib/Drawing/Surface.vala"
					if (!_tmp22_) {
#line 1031 "Surface.c"
						gint _tmp23_;
#line 267 "../lib/Drawing/Surface.vala"
						_tmp23_ = x;
#line 267 "../lib/Drawing/Surface.vala"
						x = _tmp23_ + 1;
#line 1037 "Surface.c"
					}
#line 267 "../lib/Drawing/Surface.vala"
					_tmp22_ = FALSE;
#line 267 "../lib/Drawing/Surface.vala"
					if (!(x < w)) {
#line 267 "../lib/Drawing/Surface.vala"
						break;
#line 1045 "Surface.c"
					}
#line 268 "../lib/Drawing/Surface.vala"
					_tmp24_ = vmin;
#line 268 "../lib/Drawing/Surface.vala"
					_tmp24__length1 = vmin_length1;
#line 268 "../lib/Drawing/Surface.vala"
					_tmp24_[x] = MIN ((x + radius) + 1, w - 1);
#line 269 "../lib/Drawing/Surface.vala"
					_tmp25_ = vmax;
#line 269 "../lib/Drawing/Surface.vala"
					_tmp25__length1 = vmax_length1;
#line 269 "../lib/Drawing/Surface.vala"
					_tmp25_[x] = MAX (x - radius, 0);
#line 1059 "Surface.c"
				}
			}
		}
		{
			gint y = 0;
#line 272 "../lib/Drawing/Surface.vala"
			y = 0;
#line 1067 "Surface.c"
			{
				gboolean _tmp26_ = FALSE;
#line 272 "../lib/Drawing/Surface.vala"
				_tmp26_ = TRUE;
#line 272 "../lib/Drawing/Surface.vala"
				while (TRUE) {
#line 1074 "Surface.c"
					gint asum = 0;
					gint rsum = 0;
					gint gsum = 0;
					gint bsum = 0;
					guint32 cur_pixel = 0U;
					guint8* _tmp28_;
					guint8 _tmp29_;
					guint8* _tmp30_;
					guint8 _tmp31_;
					guint8* _tmp32_;
					guint8 _tmp33_;
					guint8* _tmp34_;
					guint8 _tmp35_;
#line 272 "../lib/Drawing/Surface.vala"
					if (!_tmp26_) {
#line 1090 "Surface.c"
						gint _tmp27_;
#line 272 "../lib/Drawing/Surface.vala"
						_tmp27_ = y;
#line 272 "../lib/Drawing/Surface.vala"
						y = _tmp27_ + 1;
#line 1096 "Surface.c"
					}
#line 272 "../lib/Drawing/Surface.vala"
					_tmp26_ = FALSE;
#line 272 "../lib/Drawing/Surface.vala"
					if (!(y < h)) {
#line 272 "../lib/Drawing/Surface.vala"
						break;
#line 1104 "Surface.c"
					}
#line 273 "../lib/Drawing/Surface.vala"
					asum = 0;
#line 273 "../lib/Drawing/Surface.vala"
					rsum = 0;
#line 273 "../lib/Drawing/Surface.vala"
					gsum = 0;
#line 273 "../lib/Drawing/Surface.vala"
					bsum = 0;
#line 275 "../lib/Drawing/Surface.vala"
					cur_pixel = (guint32) ((y * w) * channels);
#line 277 "../lib/Drawing/Surface.vala"
					_tmp28_ = pixels;
#line 277 "../lib/Drawing/Surface.vala"
					_tmp29_ = _tmp28_[cur_pixel + 0];
#line 277 "../lib/Drawing/Surface.vala"
					asum += radius * _tmp29_;
#line 278 "../lib/Drawing/Surface.vala"
					_tmp30_ = pixels;
#line 278 "../lib/Drawing/Surface.vala"
					_tmp31_ = _tmp30_[cur_pixel + 1];
#line 278 "../lib/Drawing/Surface.vala"
					rsum += radius * _tmp31_;
#line 279 "../lib/Drawing/Surface.vala"
					_tmp32_ = pixels;
#line 279 "../lib/Drawing/Surface.vala"
					_tmp33_ = _tmp32_[cur_pixel + 2];
#line 279 "../lib/Drawing/Surface.vala"
					gsum += radius * _tmp33_;
#line 280 "../lib/Drawing/Surface.vala"
					_tmp34_ = pixels;
#line 280 "../lib/Drawing/Surface.vala"
					_tmp35_ = _tmp34_[cur_pixel + 3];
#line 280 "../lib/Drawing/Surface.vala"
					bsum += radius * _tmp35_;
#line 1140 "Surface.c"
					{
						gint i = 0;
#line 282 "../lib/Drawing/Surface.vala"
						i = 0;
#line 1145 "Surface.c"
						{
							gboolean _tmp36_ = FALSE;
#line 282 "../lib/Drawing/Surface.vala"
							_tmp36_ = TRUE;
#line 282 "../lib/Drawing/Surface.vala"
							while (TRUE) {
#line 1152 "Surface.c"
								guint8* _tmp38_;
								guint8 _tmp39_;
								guint8* _tmp40_;
								guint8 _tmp41_;
								guint8* _tmp42_;
								guint8 _tmp43_;
								guint8* _tmp44_;
								guint8 _tmp45_;
#line 282 "../lib/Drawing/Surface.vala"
								if (!_tmp36_) {
#line 1163 "Surface.c"
									gint _tmp37_;
#line 282 "../lib/Drawing/Surface.vala"
									_tmp37_ = i;
#line 282 "../lib/Drawing/Surface.vala"
									i = _tmp37_ + 1;
#line 1169 "Surface.c"
								}
#line 282 "../lib/Drawing/Surface.vala"
								_tmp36_ = FALSE;
#line 282 "../lib/Drawing/Surface.vala"
								if (!(i <= radius)) {
#line 282 "../lib/Drawing/Surface.vala"
									break;
#line 1177 "Surface.c"
								}
#line 283 "../lib/Drawing/Surface.vala"
								_tmp38_ = pixels;
#line 283 "../lib/Drawing/Surface.vala"
								_tmp39_ = _tmp38_[cur_pixel + 0];
#line 283 "../lib/Drawing/Surface.vala"
								asum += (gint) _tmp39_;
#line 284 "../lib/Drawing/Surface.vala"
								_tmp40_ = pixels;
#line 284 "../lib/Drawing/Surface.vala"
								_tmp41_ = _tmp40_[cur_pixel + 1];
#line 284 "../lib/Drawing/Surface.vala"
								rsum += (gint) _tmp41_;
#line 285 "../lib/Drawing/Surface.vala"
								_tmp42_ = pixels;
#line 285 "../lib/Drawing/Surface.vala"
								_tmp43_ = _tmp42_[cur_pixel + 2];
#line 285 "../lib/Drawing/Surface.vala"
								gsum += (gint) _tmp43_;
#line 286 "../lib/Drawing/Surface.vala"
								_tmp44_ = pixels;
#line 286 "../lib/Drawing/Surface.vala"
								_tmp45_ = _tmp44_[cur_pixel + 3];
#line 286 "../lib/Drawing/Surface.vala"
								bsum += (gint) _tmp45_;
#line 288 "../lib/Drawing/Surface.vala"
								cur_pixel += (guint32) channels;
#line 1205 "Surface.c"
							}
						}
					}
#line 291 "../lib/Drawing/Surface.vala"
					cur_pixel = (guint32) ((y * w) * channels);
#line 1211 "Surface.c"
					{
						gint x = 0;
#line 293 "../lib/Drawing/Surface.vala"
						x = 0;
#line 1216 "Surface.c"
						{
							gboolean _tmp46_ = FALSE;
#line 293 "../lib/Drawing/Surface.vala"
							_tmp46_ = TRUE;
#line 293 "../lib/Drawing/Surface.vala"
							while (TRUE) {
#line 1223 "Surface.c"
								guint32 p1 = 0U;
								gint* _tmp48_;
								gint _tmp48__length1;
								gint _tmp49_;
								guint32 p2 = 0U;
								gint* _tmp50_;
								gint _tmp50__length1;
								gint _tmp51_;
								guint8* _tmp52_;
								gint _tmp52__length1;
								guint8* _tmp53_;
								gint _tmp53__length1;
								guint8 _tmp54_;
								guint8* _tmp55_;
								gint _tmp55__length1;
								guint8* _tmp56_;
								gint _tmp56__length1;
								guint8 _tmp57_;
								guint8* _tmp58_;
								gint _tmp58__length1;
								guint8* _tmp59_;
								gint _tmp59__length1;
								guint8 _tmp60_;
								guint8* _tmp61_;
								gint _tmp61__length1;
								guint8* _tmp62_;
								gint _tmp62__length1;
								guint8 _tmp63_;
								guint8* _tmp64_;
								guint8 _tmp65_;
								guint8* _tmp66_;
								guint8 _tmp67_;
								guint8* _tmp68_;
								guint8 _tmp69_;
								guint8* _tmp70_;
								guint8 _tmp71_;
								guint8* _tmp72_;
								guint8 _tmp73_;
								guint8* _tmp74_;
								guint8 _tmp75_;
								guint8* _tmp76_;
								guint8 _tmp77_;
								guint8* _tmp78_;
								guint8 _tmp79_;
#line 293 "../lib/Drawing/Surface.vala"
								if (!_tmp46_) {
#line 1270 "Surface.c"
									gint _tmp47_;
#line 293 "../lib/Drawing/Surface.vala"
									_tmp47_ = x;
#line 293 "../lib/Drawing/Surface.vala"
									x = _tmp47_ + 1;
#line 1276 "Surface.c"
								}
#line 293 "../lib/Drawing/Surface.vala"
								_tmp46_ = FALSE;
#line 293 "../lib/Drawing/Surface.vala"
								if (!(x < w)) {
#line 293 "../lib/Drawing/Surface.vala"
									break;
#line 1284 "Surface.c"
								}
#line 294 "../lib/Drawing/Surface.vala"
								_tmp48_ = vmin;
#line 294 "../lib/Drawing/Surface.vala"
								_tmp48__length1 = vmin_length1;
#line 294 "../lib/Drawing/Surface.vala"
								_tmp49_ = _tmp48_[x];
#line 294 "../lib/Drawing/Surface.vala"
								p1 = (guint32) (((y * w) + _tmp49_) * channels);
#line 295 "../lib/Drawing/Surface.vala"
								_tmp50_ = vmax;
#line 295 "../lib/Drawing/Surface.vala"
								_tmp50__length1 = vmax_length1;
#line 295 "../lib/Drawing/Surface.vala"
								_tmp51_ = _tmp50_[x];
#line 295 "../lib/Drawing/Surface.vala"
								p2 = (guint32) (((y * w) + _tmp51_) * channels);
#line 297 "../lib/Drawing/Surface.vala"
								_tmp52_ = buffer;
#line 297 "../lib/Drawing/Surface.vala"
								_tmp52__length1 = buffer_length1;
#line 297 "../lib/Drawing/Surface.vala"
								_tmp53_ = dv;
#line 297 "../lib/Drawing/Surface.vala"
								_tmp53__length1 = dv_length1;
#line 297 "../lib/Drawing/Surface.vala"
								_tmp54_ = _tmp53_[asum];
#line 297 "../lib/Drawing/Surface.vala"
								_tmp52_[cur_pixel + 0] = _tmp54_;
#line 298 "../lib/Drawing/Surface.vala"
								_tmp55_ = buffer;
#line 298 "../lib/Drawing/Surface.vala"
								_tmp55__length1 = buffer_length1;
#line 298 "../lib/Drawing/Surface.vala"
								_tmp56_ = dv;
#line 298 "../lib/Drawing/Surface.vala"
								_tmp56__length1 = dv_length1;
#line 298 "../lib/Drawing/Surface.vala"
								_tmp57_ = _tmp56_[rsum];
#line 298 "../lib/Drawing/Surface.vala"
								_tmp55_[cur_pixel + 1] = _tmp57_;
#line 299 "../lib/Drawing/Surface.vala"
								_tmp58_ = buffer;
#line 299 "../lib/Drawing/Surface.vala"
								_tmp58__length1 = buffer_length1;
#line 299 "../lib/Drawing/Surface.vala"
								_tmp59_ = dv;
#line 299 "../lib/Drawing/Surface.vala"
								_tmp59__length1 = dv_length1;
#line 299 "../lib/Drawing/Surface.vala"
								_tmp60_ = _tmp59_[gsum];
#line 299 "../lib/Drawing/Surface.vala"
								_tmp58_[cur_pixel + 2] = _tmp60_;
#line 300 "../lib/Drawing/Surface.vala"
								_tmp61_ = buffer;
#line 300 "../lib/Drawing/Surface.vala"
								_tmp61__length1 = buffer_length1;
#line 300 "../lib/Drawing/Surface.vala"
								_tmp62_ = dv;
#line 300 "../lib/Drawing/Surface.vala"
								_tmp62__length1 = dv_length1;
#line 300 "../lib/Drawing/Surface.vala"
								_tmp63_ = _tmp62_[bsum];
#line 300 "../lib/Drawing/Surface.vala"
								_tmp61_[cur_pixel + 3] = _tmp63_;
#line 302 "../lib/Drawing/Surface.vala"
								_tmp64_ = pixels;
#line 302 "../lib/Drawing/Surface.vala"
								_tmp65_ = _tmp64_[p1 + 0];
#line 302 "../lib/Drawing/Surface.vala"
								_tmp66_ = pixels;
#line 302 "../lib/Drawing/Surface.vala"
								_tmp67_ = _tmp66_[p2 + 0];
#line 302 "../lib/Drawing/Surface.vala"
								asum += (gint) (_tmp65_ - _tmp67_);
#line 303 "../lib/Drawing/Surface.vala"
								_tmp68_ = pixels;
#line 303 "../lib/Drawing/Surface.vala"
								_tmp69_ = _tmp68_[p1 + 1];
#line 303 "../lib/Drawing/Surface.vala"
								_tmp70_ = pixels;
#line 303 "../lib/Drawing/Surface.vala"
								_tmp71_ = _tmp70_[p2 + 1];
#line 303 "../lib/Drawing/Surface.vala"
								rsum += (gint) (_tmp69_ - _tmp71_);
#line 304 "../lib/Drawing/Surface.vala"
								_tmp72_ = pixels;
#line 304 "../lib/Drawing/Surface.vala"
								_tmp73_ = _tmp72_[p1 + 2];
#line 304 "../lib/Drawing/Surface.vala"
								_tmp74_ = pixels;
#line 304 "../lib/Drawing/Surface.vala"
								_tmp75_ = _tmp74_[p2 + 2];
#line 304 "../lib/Drawing/Surface.vala"
								gsum += (gint) (_tmp73_ - _tmp75_);
#line 305 "../lib/Drawing/Surface.vala"
								_tmp76_ = pixels;
#line 305 "../lib/Drawing/Surface.vala"
								_tmp77_ = _tmp76_[p1 + 3];
#line 305 "../lib/Drawing/Surface.vala"
								_tmp78_ = pixels;
#line 305 "../lib/Drawing/Surface.vala"
								_tmp79_ = _tmp78_[p2 + 3];
#line 305 "../lib/Drawing/Surface.vala"
								bsum += (gint) (_tmp77_ - _tmp79_);
#line 307 "../lib/Drawing/Surface.vala"
								cur_pixel += (guint32) channels;
#line 1392 "Surface.c"
							}
						}
					}
				}
			}
		}
		{
			gint y = 0;
#line 311 "../lib/Drawing/Surface.vala"
			y = 0;
#line 1403 "Surface.c"
			{
				gboolean _tmp80_ = FALSE;
#line 311 "../lib/Drawing/Surface.vala"
				_tmp80_ = TRUE;
#line 311 "../lib/Drawing/Surface.vala"
				while (TRUE) {
#line 1410 "Surface.c"
					gint* _tmp82_;
					gint _tmp82__length1;
					gint* _tmp83_;
					gint _tmp83__length1;
#line 311 "../lib/Drawing/Surface.vala"
					if (!_tmp80_) {
#line 1417 "Surface.c"
						gint _tmp81_;
#line 311 "../lib/Drawing/Surface.vala"
						_tmp81_ = y;
#line 311 "../lib/Drawing/Surface.vala"
						y = _tmp81_ + 1;
#line 1423 "Surface.c"
					}
#line 311 "../lib/Drawing/Surface.vala"
					_tmp80_ = FALSE;
#line 311 "../lib/Drawing/Surface.vala"
					if (!(y < h)) {
#line 311 "../lib/Drawing/Surface.vala"
						break;
#line 1431 "Surface.c"
					}
#line 312 "../lib/Drawing/Surface.vala"
					_tmp82_ = vmin;
#line 312 "../lib/Drawing/Surface.vala"
					_tmp82__length1 = vmin_length1;
#line 312 "../lib/Drawing/Surface.vala"
					_tmp82_[y] = MIN ((y + radius) + 1, h - 1) * w;
#line 313 "../lib/Drawing/Surface.vala"
					_tmp83_ = vmax;
#line 313 "../lib/Drawing/Surface.vala"
					_tmp83__length1 = vmax_length1;
#line 313 "../lib/Drawing/Surface.vala"
					_tmp83_[y] = MAX (y - radius, 0) * w;
#line 1445 "Surface.c"
				}
			}
		}
		{
			gint x = 0;
#line 316 "../lib/Drawing/Surface.vala"
			x = 0;
#line 1453 "Surface.c"
			{
				gboolean _tmp84_ = FALSE;
#line 316 "../lib/Drawing/Surface.vala"
				_tmp84_ = TRUE;
#line 316 "../lib/Drawing/Surface.vala"
				while (TRUE) {
#line 1460 "Surface.c"
					gint asum = 0;
					gint rsum = 0;
					gint gsum = 0;
					gint bsum = 0;
					guint32 cur_pixel = 0U;
					guint8* _tmp86_;
					gint _tmp86__length1;
					guint8 _tmp87_;
					guint8* _tmp88_;
					gint _tmp88__length1;
					guint8 _tmp89_;
					guint8* _tmp90_;
					gint _tmp90__length1;
					guint8 _tmp91_;
					guint8* _tmp92_;
					gint _tmp92__length1;
					guint8 _tmp93_;
#line 316 "../lib/Drawing/Surface.vala"
					if (!_tmp84_) {
#line 1480 "Surface.c"
						gint _tmp85_;
#line 316 "../lib/Drawing/Surface.vala"
						_tmp85_ = x;
#line 316 "../lib/Drawing/Surface.vala"
						x = _tmp85_ + 1;
#line 1486 "Surface.c"
					}
#line 316 "../lib/Drawing/Surface.vala"
					_tmp84_ = FALSE;
#line 316 "../lib/Drawing/Surface.vala"
					if (!(x < w)) {
#line 316 "../lib/Drawing/Surface.vala"
						break;
#line 1494 "Surface.c"
					}
#line 317 "../lib/Drawing/Surface.vala"
					asum = 0;
#line 317 "../lib/Drawing/Surface.vala"
					rsum = 0;
#line 317 "../lib/Drawing/Surface.vala"
					gsum = 0;
#line 317 "../lib/Drawing/Surface.vala"
					bsum = 0;
#line 319 "../lib/Drawing/Surface.vala"
					cur_pixel = (guint32) (x * channels);
#line 321 "../lib/Drawing/Surface.vala"
					_tmp86_ = buffer;
#line 321 "../lib/Drawing/Surface.vala"
					_tmp86__length1 = buffer_length1;
#line 321 "../lib/Drawing/Surface.vala"
					_tmp87_ = _tmp86_[cur_pixel + 0];
#line 321 "../lib/Drawing/Surface.vala"
					asum += radius * _tmp87_;
#line 322 "../lib/Drawing/Surface.vala"
					_tmp88_ = buffer;
#line 322 "../lib/Drawing/Surface.vala"
					_tmp88__length1 = buffer_length1;
#line 322 "../lib/Drawing/Surface.vala"
					_tmp89_ = _tmp88_[cur_pixel + 1];
#line 322 "../lib/Drawing/Surface.vala"
					rsum += radius * _tmp89_;
#line 323 "../lib/Drawing/Surface.vala"
					_tmp90_ = buffer;
#line 323 "../lib/Drawing/Surface.vala"
					_tmp90__length1 = buffer_length1;
#line 323 "../lib/Drawing/Surface.vala"
					_tmp91_ = _tmp90_[cur_pixel + 2];
#line 323 "../lib/Drawing/Surface.vala"
					gsum += radius * _tmp91_;
#line 324 "../lib/Drawing/Surface.vala"
					_tmp92_ = buffer;
#line 324 "../lib/Drawing/Surface.vala"
					_tmp92__length1 = buffer_length1;
#line 324 "../lib/Drawing/Surface.vala"
					_tmp93_ = _tmp92_[cur_pixel + 3];
#line 324 "../lib/Drawing/Surface.vala"
					bsum += radius * _tmp93_;
#line 1538 "Surface.c"
					{
						gint i = 0;
#line 326 "../lib/Drawing/Surface.vala"
						i = 0;
#line 1543 "Surface.c"
						{
							gboolean _tmp94_ = FALSE;
#line 326 "../lib/Drawing/Surface.vala"
							_tmp94_ = TRUE;
#line 326 "../lib/Drawing/Surface.vala"
							while (TRUE) {
#line 1550 "Surface.c"
								guint8* _tmp96_;
								gint _tmp96__length1;
								guint8 _tmp97_;
								guint8* _tmp98_;
								gint _tmp98__length1;
								guint8 _tmp99_;
								guint8* _tmp100_;
								gint _tmp100__length1;
								guint8 _tmp101_;
								guint8* _tmp102_;
								gint _tmp102__length1;
								guint8 _tmp103_;
#line 326 "../lib/Drawing/Surface.vala"
								if (!_tmp94_) {
#line 1565 "Surface.c"
									gint _tmp95_;
#line 326 "../lib/Drawing/Surface.vala"
									_tmp95_ = i;
#line 326 "../lib/Drawing/Surface.vala"
									i = _tmp95_ + 1;
#line 1571 "Surface.c"
								}
#line 326 "../lib/Drawing/Surface.vala"
								_tmp94_ = FALSE;
#line 326 "../lib/Drawing/Surface.vala"
								if (!(i <= radius)) {
#line 326 "../lib/Drawing/Surface.vala"
									break;
#line 1579 "Surface.c"
								}
#line 327 "../lib/Drawing/Surface.vala"
								_tmp96_ = buffer;
#line 327 "../lib/Drawing/Surface.vala"
								_tmp96__length1 = buffer_length1;
#line 327 "../lib/Drawing/Surface.vala"
								_tmp97_ = _tmp96_[cur_pixel + 0];
#line 327 "../lib/Drawing/Surface.vala"
								asum += (gint) _tmp97_;
#line 328 "../lib/Drawing/Surface.vala"
								_tmp98_ = buffer;
#line 328 "../lib/Drawing/Surface.vala"
								_tmp98__length1 = buffer_length1;
#line 328 "../lib/Drawing/Surface.vala"
								_tmp99_ = _tmp98_[cur_pixel + 1];
#line 328 "../lib/Drawing/Surface.vala"
								rsum += (gint) _tmp99_;
#line 329 "../lib/Drawing/Surface.vala"
								_tmp100_ = buffer;
#line 329 "../lib/Drawing/Surface.vala"
								_tmp100__length1 = buffer_length1;
#line 329 "../lib/Drawing/Surface.vala"
								_tmp101_ = _tmp100_[cur_pixel + 2];
#line 329 "../lib/Drawing/Surface.vala"
								gsum += (gint) _tmp101_;
#line 330 "../lib/Drawing/Surface.vala"
								_tmp102_ = buffer;
#line 330 "../lib/Drawing/Surface.vala"
								_tmp102__length1 = buffer_length1;
#line 330 "../lib/Drawing/Surface.vala"
								_tmp103_ = _tmp102_[cur_pixel + 3];
#line 330 "../lib/Drawing/Surface.vala"
								bsum += (gint) _tmp103_;
#line 332 "../lib/Drawing/Surface.vala"
								cur_pixel += (guint32) (w * channels);
#line 1615 "Surface.c"
							}
						}
					}
#line 335 "../lib/Drawing/Surface.vala"
					cur_pixel = (guint32) (x * channels);
#line 1621 "Surface.c"
					{
						gint y = 0;
#line 337 "../lib/Drawing/Surface.vala"
						y = 0;
#line 1626 "Surface.c"
						{
							gboolean _tmp104_ = FALSE;
#line 337 "../lib/Drawing/Surface.vala"
							_tmp104_ = TRUE;
#line 337 "../lib/Drawing/Surface.vala"
							while (TRUE) {
#line 1633 "Surface.c"
								guint32 p1 = 0U;
								gint* _tmp106_;
								gint _tmp106__length1;
								gint _tmp107_;
								guint32 p2 = 0U;
								gint* _tmp108_;
								gint _tmp108__length1;
								gint _tmp109_;
								guint8* _tmp110_;
								guint8* _tmp111_;
								gint _tmp111__length1;
								guint8 _tmp112_;
								guint8* _tmp113_;
								guint8* _tmp114_;
								gint _tmp114__length1;
								guint8 _tmp115_;
								guint8* _tmp116_;
								guint8* _tmp117_;
								gint _tmp117__length1;
								guint8 _tmp118_;
								guint8* _tmp119_;
								guint8* _tmp120_;
								gint _tmp120__length1;
								guint8 _tmp121_;
								guint8* _tmp122_;
								gint _tmp122__length1;
								guint8 _tmp123_;
								guint8* _tmp124_;
								gint _tmp124__length1;
								guint8 _tmp125_;
								guint8* _tmp126_;
								gint _tmp126__length1;
								guint8 _tmp127_;
								guint8* _tmp128_;
								gint _tmp128__length1;
								guint8 _tmp129_;
								guint8* _tmp130_;
								gint _tmp130__length1;
								guint8 _tmp131_;
								guint8* _tmp132_;
								gint _tmp132__length1;
								guint8 _tmp133_;
								guint8* _tmp134_;
								gint _tmp134__length1;
								guint8 _tmp135_;
								guint8* _tmp136_;
								gint _tmp136__length1;
								guint8 _tmp137_;
#line 337 "../lib/Drawing/Surface.vala"
								if (!_tmp104_) {
#line 1684 "Surface.c"
									gint _tmp105_;
#line 337 "../lib/Drawing/Surface.vala"
									_tmp105_ = y;
#line 337 "../lib/Drawing/Surface.vala"
									y = _tmp105_ + 1;
#line 1690 "Surface.c"
								}
#line 337 "../lib/Drawing/Surface.vala"
								_tmp104_ = FALSE;
#line 337 "../lib/Drawing/Surface.vala"
								if (!(y < h)) {
#line 337 "../lib/Drawing/Surface.vala"
									break;
#line 1698 "Surface.c"
								}
#line 338 "../lib/Drawing/Surface.vala"
								_tmp106_ = vmin;
#line 338 "../lib/Drawing/Surface.vala"
								_tmp106__length1 = vmin_length1;
#line 338 "../lib/Drawing/Surface.vala"
								_tmp107_ = _tmp106_[y];
#line 338 "../lib/Drawing/Surface.vala"
								p1 = (guint32) ((x + _tmp107_) * channels);
#line 339 "../lib/Drawing/Surface.vala"
								_tmp108_ = vmax;
#line 339 "../lib/Drawing/Surface.vala"
								_tmp108__length1 = vmax_length1;
#line 339 "../lib/Drawing/Surface.vala"
								_tmp109_ = _tmp108_[y];
#line 339 "../lib/Drawing/Surface.vala"
								p2 = (guint32) ((x + _tmp109_) * channels);
#line 341 "../lib/Drawing/Surface.vala"
								_tmp110_ = pixels;
#line 341 "../lib/Drawing/Surface.vala"
								_tmp111_ = dv;
#line 341 "../lib/Drawing/Surface.vala"
								_tmp111__length1 = dv_length1;
#line 341 "../lib/Drawing/Surface.vala"
								_tmp112_ = _tmp111_[asum];
#line 341 "../lib/Drawing/Surface.vala"
								_tmp110_[cur_pixel + 0] = _tmp112_;
#line 342 "../lib/Drawing/Surface.vala"
								_tmp113_ = pixels;
#line 342 "../lib/Drawing/Surface.vala"
								_tmp114_ = dv;
#line 342 "../lib/Drawing/Surface.vala"
								_tmp114__length1 = dv_length1;
#line 342 "../lib/Drawing/Surface.vala"
								_tmp115_ = _tmp114_[rsum];
#line 342 "../lib/Drawing/Surface.vala"
								_tmp113_[cur_pixel + 1] = _tmp115_;
#line 343 "../lib/Drawing/Surface.vala"
								_tmp116_ = pixels;
#line 343 "../lib/Drawing/Surface.vala"
								_tmp117_ = dv;
#line 343 "../lib/Drawing/Surface.vala"
								_tmp117__length1 = dv_length1;
#line 343 "../lib/Drawing/Surface.vala"
								_tmp118_ = _tmp117_[gsum];
#line 343 "../lib/Drawing/Surface.vala"
								_tmp116_[cur_pixel + 2] = _tmp118_;
#line 344 "../lib/Drawing/Surface.vala"
								_tmp119_ = pixels;
#line 344 "../lib/Drawing/Surface.vala"
								_tmp120_ = dv;
#line 344 "../lib/Drawing/Surface.vala"
								_tmp120__length1 = dv_length1;
#line 344 "../lib/Drawing/Surface.vala"
								_tmp121_ = _tmp120_[bsum];
#line 344 "../lib/Drawing/Surface.vala"
								_tmp119_[cur_pixel + 3] = _tmp121_;
#line 346 "../lib/Drawing/Surface.vala"
								_tmp122_ = buffer;
#line 346 "../lib/Drawing/Surface.vala"
								_tmp122__length1 = buffer_length1;
#line 346 "../lib/Drawing/Surface.vala"
								_tmp123_ = _tmp122_[p1 + 0];
#line 346 "../lib/Drawing/Surface.vala"
								_tmp124_ = buffer;
#line 346 "../lib/Drawing/Surface.vala"
								_tmp124__length1 = buffer_length1;
#line 346 "../lib/Drawing/Surface.vala"
								_tmp125_ = _tmp124_[p2 + 0];
#line 346 "../lib/Drawing/Surface.vala"
								asum += (gint) (_tmp123_ - _tmp125_);
#line 347 "../lib/Drawing/Surface.vala"
								_tmp126_ = buffer;
#line 347 "../lib/Drawing/Surface.vala"
								_tmp126__length1 = buffer_length1;
#line 347 "../lib/Drawing/Surface.vala"
								_tmp127_ = _tmp126_[p1 + 1];
#line 347 "../lib/Drawing/Surface.vala"
								_tmp128_ = buffer;
#line 347 "../lib/Drawing/Surface.vala"
								_tmp128__length1 = buffer_length1;
#line 347 "../lib/Drawing/Surface.vala"
								_tmp129_ = _tmp128_[p2 + 1];
#line 347 "../lib/Drawing/Surface.vala"
								rsum += (gint) (_tmp127_ - _tmp129_);
#line 348 "../lib/Drawing/Surface.vala"
								_tmp130_ = buffer;
#line 348 "../lib/Drawing/Surface.vala"
								_tmp130__length1 = buffer_length1;
#line 348 "../lib/Drawing/Surface.vala"
								_tmp131_ = _tmp130_[p1 + 2];
#line 348 "../lib/Drawing/Surface.vala"
								_tmp132_ = buffer;
#line 348 "../lib/Drawing/Surface.vala"
								_tmp132__length1 = buffer_length1;
#line 348 "../lib/Drawing/Surface.vala"
								_tmp133_ = _tmp132_[p2 + 2];
#line 348 "../lib/Drawing/Surface.vala"
								gsum += (gint) (_tmp131_ - _tmp133_);
#line 349 "../lib/Drawing/Surface.vala"
								_tmp134_ = buffer;
#line 349 "../lib/Drawing/Surface.vala"
								_tmp134__length1 = buffer_length1;
#line 349 "../lib/Drawing/Surface.vala"
								_tmp135_ = _tmp134_[p1 + 3];
#line 349 "../lib/Drawing/Surface.vala"
								_tmp136_ = buffer;
#line 349 "../lib/Drawing/Surface.vala"
								_tmp136__length1 = buffer_length1;
#line 349 "../lib/Drawing/Surface.vala"
								_tmp137_ = _tmp136_[p2 + 3];
#line 349 "../lib/Drawing/Surface.vala"
								bsum += (gint) (_tmp135_ - _tmp137_);
#line 351 "../lib/Drawing/Surface.vala"
								cur_pixel += (guint32) (w * channels);
#line 1814 "Surface.c"
							}
						}
					}
				}
			}
		}
	}
#line 356 "../lib/Drawing/Surface.vala"
	_tmp138_ = original;
#line 356 "../lib/Drawing/Surface.vala"
	cairo_surface_mark_dirty (_tmp138_);
#line 358 "../lib/Drawing/Surface.vala"
	_tmp139_ = self->priv->_Context;
#line 358 "../lib/Drawing/Surface.vala"
	target_cr = _tmp139_;
#line 359 "../lib/Drawing/Surface.vala"
	_tmp140_ = target_cr;
#line 359 "../lib/Drawing/Surface.vala"
	cairo_save (_tmp140_);
#line 360 "../lib/Drawing/Surface.vala"
	_tmp141_ = target_cr;
#line 360 "../lib/Drawing/Surface.vala"
	cairo_set_operator (_tmp141_, CAIRO_OPERATOR_SOURCE);
#line 361 "../lib/Drawing/Surface.vala"
	_tmp142_ = target_cr;
#line 361 "../lib/Drawing/Surface.vala"
	_tmp143_ = original;
#line 361 "../lib/Drawing/Surface.vala"
	cairo_set_source_surface (_tmp142_, _tmp143_, (gdouble) 0, (gdouble) 0);
#line 362 "../lib/Drawing/Surface.vala"
	_tmp144_ = target_cr;
#line 362 "../lib/Drawing/Surface.vala"
	cairo_paint (_tmp144_);
#line 363 "../lib/Drawing/Surface.vala"
	_tmp145_ = target_cr;
#line 363 "../lib/Drawing/Surface.vala"
	cairo_restore (_tmp145_);
#line 236 "../lib/Drawing/Surface.vala"
	dv = (g_free (dv), NULL);
#line 236 "../lib/Drawing/Surface.vala"
	vmax = (g_free (vmax), NULL);
#line 236 "../lib/Drawing/Surface.vala"
	vmin = (g_free (vmin), NULL);
#line 236 "../lib/Drawing/Surface.vala"
	buffer = (g_free (buffer), NULL);
#line 236 "../lib/Drawing/Surface.vala"
	_cairo_destroy0 (cr);
#line 236 "../lib/Drawing/Surface.vala"
	_cairo_surface_destroy0 (original);
#line 1864 "Surface.c"
}

/**
 * Performs an exponential blur on the surface.
 *
 * @param radius the radius of the blur
 */
static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 371 "../lib/Drawing/Surface.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 371 "../lib/Drawing/Surface.vala"
	return _data5_;
#line 1879 "Surface.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 371 "../lib/Drawing/Surface.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 1889 "Surface.c"
		PlankSurface* self;
#line 371 "../lib/Drawing/Surface.vala"
		self = _data5_->self;
#line 371 "../lib/Drawing/Surface.vala"
		_g_object_unref0 (self);
#line 371 "../lib/Drawing/Surface.vala"
		g_slice_free (Block5Data, _data5_);
#line 1897 "Surface.c"
	}
}

static void*
__lambda4_ (Block5Data* _data5_)
{
	PlankSurface* self;
	guint8* _tmp0_;
	void* result;
#line 389 "../lib/Drawing/Surface.vala"
	self = _data5_->self;
#line 390 "../lib/Drawing/Surface.vala"
	_tmp0_ = _data5_->pixels;
#line 390 "../lib/Drawing/Surface.vala"
	plank_surface_exponential_blur_rows (_tmp0_, _data5_->width, _data5_->height, 0, _data5_->height / 2, 0, _data5_->width, _data5_->alpha);
#line 391 "../lib/Drawing/Surface.vala"
	result = NULL;
#line 391 "../lib/Drawing/Surface.vala"
	return result;
#line 1917 "Surface.c"
}

static gpointer
___lambda4__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda4_ (self);
#line 389 "../lib/Drawing/Surface.vala"
	block5_data_unref (self);
#line 389 "../lib/Drawing/Surface.vala"
	return result;
#line 1929 "Surface.c"
}

static void*
__lambda5_ (Block5Data* _data5_)
{
	PlankSurface* self;
	guint8* _tmp0_;
	void* result;
#line 398 "../lib/Drawing/Surface.vala"
	self = _data5_->self;
#line 399 "../lib/Drawing/Surface.vala"
	_tmp0_ = _data5_->pixels;
#line 399 "../lib/Drawing/Surface.vala"
	plank_surface_exponential_blur_columns (_tmp0_, _data5_->width, _data5_->height, 0, _data5_->width / 2, 0, _data5_->height, _data5_->alpha);
#line 400 "../lib/Drawing/Surface.vala"
	result = NULL;
#line 400 "../lib/Drawing/Surface.vala"
	return result;
#line 1948 "Surface.c"
}

static gpointer
___lambda5__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda5_ (self);
#line 398 "../lib/Drawing/Surface.vala"
	block5_data_unref (self);
#line 398 "../lib/Drawing/Surface.vala"
	return result;
#line 1960 "Surface.c"
}

void
plank_surface_exponential_blur (PlankSurface* self,
                                gint radius)
{
	Block5Data* _data5_;
	gint _tmp0_;
	gint _tmp1_;
	cairo_surface_t* original = NULL;
	cairo_surface_t* _tmp2_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp3_;
	cairo_t* _tmp4_;
	cairo_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_surface_t* _tmp7_;
	cairo_t* _tmp8_;
	cairo_surface_t* _tmp9_;
	guchar* _tmp10_;
	GThread* th = NULL;
	GThread* _tmp11_;
	guint8* _tmp12_;
	GThread* _tmp13_;
	GThread* th2 = NULL;
	GThread* _tmp14_;
	guint8* _tmp15_;
	GThread* _tmp16_;
	cairo_surface_t* _tmp17_;
	cairo_t* target_cr = NULL;
	cairo_t* _tmp18_;
	cairo_t* _tmp19_;
	cairo_t* _tmp20_;
	cairo_t* _tmp21_;
	cairo_surface_t* _tmp22_;
	cairo_t* _tmp23_;
	cairo_t* _tmp24_;
#line 371 "../lib/Drawing/Surface.vala"
	g_return_if_fail (self != NULL);
#line 371 "../lib/Drawing/Surface.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 371 "../lib/Drawing/Surface.vala"
	_data5_->_ref_count_ = 1;
#line 371 "../lib/Drawing/Surface.vala"
	_data5_->self = g_object_ref (self);
#line 373 "../lib/Drawing/Surface.vala"
	if (radius < 1) {
#line 374 "../lib/Drawing/Surface.vala"
		block5_data_unref (_data5_);
#line 374 "../lib/Drawing/Surface.vala"
		_data5_ = NULL;
#line 374 "../lib/Drawing/Surface.vala"
		return;
#line 2014 "Surface.c"
	}
#line 376 "../lib/Drawing/Surface.vala"
	_data5_->alpha = (gint) ((1 << PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION) * (1.0 - exp ((-2.3) / (radius + 1.0))));
#line 377 "../lib/Drawing/Surface.vala"
	_tmp0_ = self->priv->_Height;
#line 377 "../lib/Drawing/Surface.vala"
	_data5_->height = _tmp0_;
#line 378 "../lib/Drawing/Surface.vala"
	_tmp1_ = self->priv->_Width;
#line 378 "../lib/Drawing/Surface.vala"
	_data5_->width = _tmp1_;
#line 380 "../lib/Drawing/Surface.vala"
	_tmp2_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _data5_->width, _data5_->height);
#line 380 "../lib/Drawing/Surface.vala"
	original = _tmp2_;
#line 381 "../lib/Drawing/Surface.vala"
	_tmp3_ = original;
#line 381 "../lib/Drawing/Surface.vala"
	_tmp4_ = cairo_create (_tmp3_);
#line 381 "../lib/Drawing/Surface.vala"
	cr = _tmp4_;
#line 383 "../lib/Drawing/Surface.vala"
	_tmp5_ = cr;
#line 383 "../lib/Drawing/Surface.vala"
	cairo_set_operator (_tmp5_, CAIRO_OPERATOR_SOURCE);
#line 384 "../lib/Drawing/Surface.vala"
	_tmp6_ = cr;
#line 384 "../lib/Drawing/Surface.vala"
	_tmp7_ = self->priv->_Internal;
#line 384 "../lib/Drawing/Surface.vala"
	cairo_set_source_surface (_tmp6_, _tmp7_, (gdouble) 0, (gdouble) 0);
#line 385 "../lib/Drawing/Surface.vala"
	_tmp8_ = cr;
#line 385 "../lib/Drawing/Surface.vala"
	cairo_paint (_tmp8_);
#line 387 "../lib/Drawing/Surface.vala"
	_tmp9_ = original;
#line 387 "../lib/Drawing/Surface.vala"
	_tmp10_ = cairo_image_surface_get_data (_tmp9_);
#line 387 "../lib/Drawing/Surface.vala"
	_data5_->pixels = _tmp10_;
#line 389 "../lib/Drawing/Surface.vala"
	_tmp11_ = g_thread_new (NULL, ___lambda4__gthread_func, block5_data_ref (_data5_));
#line 389 "../lib/Drawing/Surface.vala"
	th = _tmp11_;
#line 394 "../lib/Drawing/Surface.vala"
	_tmp12_ = _data5_->pixels;
#line 394 "../lib/Drawing/Surface.vala"
	plank_surface_exponential_blur_rows (_tmp12_, _data5_->width, _data5_->height, _data5_->height / 2, _data5_->height, 0, _data5_->width, _data5_->alpha);
#line 395 "../lib/Drawing/Surface.vala"
	_tmp13_ = th;
#line 395 "../lib/Drawing/Surface.vala"
	th = NULL;
#line 395 "../lib/Drawing/Surface.vala"
	g_thread_join (_tmp13_);
#line 398 "../lib/Drawing/Surface.vala"
	_tmp14_ = g_thread_new (NULL, ___lambda5__gthread_func, block5_data_ref (_data5_));
#line 398 "../lib/Drawing/Surface.vala"
	th2 = _tmp14_;
#line 403 "../lib/Drawing/Surface.vala"
	_tmp15_ = _data5_->pixels;
#line 403 "../lib/Drawing/Surface.vala"
	plank_surface_exponential_blur_columns (_tmp15_, _data5_->width, _data5_->height, _data5_->width / 2, _data5_->width, 0, _data5_->height, _data5_->alpha);
#line 404 "../lib/Drawing/Surface.vala"
	_tmp16_ = th2;
#line 404 "../lib/Drawing/Surface.vala"
	th2 = NULL;
#line 404 "../lib/Drawing/Surface.vala"
	g_thread_join (_tmp16_);
#line 406 "../lib/Drawing/Surface.vala"
	_tmp17_ = original;
#line 406 "../lib/Drawing/Surface.vala"
	cairo_surface_mark_dirty (_tmp17_);
#line 408 "../lib/Drawing/Surface.vala"
	_tmp18_ = self->priv->_Context;
#line 408 "../lib/Drawing/Surface.vala"
	target_cr = _tmp18_;
#line 409 "../lib/Drawing/Surface.vala"
	_tmp19_ = target_cr;
#line 409 "../lib/Drawing/Surface.vala"
	cairo_save (_tmp19_);
#line 410 "../lib/Drawing/Surface.vala"
	_tmp20_ = target_cr;
#line 410 "../lib/Drawing/Surface.vala"
	cairo_set_operator (_tmp20_, CAIRO_OPERATOR_SOURCE);
#line 411 "../lib/Drawing/Surface.vala"
	_tmp21_ = target_cr;
#line 411 "../lib/Drawing/Surface.vala"
	_tmp22_ = original;
#line 411 "../lib/Drawing/Surface.vala"
	cairo_set_source_surface (_tmp21_, _tmp22_, (gdouble) 0, (gdouble) 0);
#line 412 "../lib/Drawing/Surface.vala"
	_tmp23_ = target_cr;
#line 412 "../lib/Drawing/Surface.vala"
	cairo_paint (_tmp23_);
#line 413 "../lib/Drawing/Surface.vala"
	_tmp24_ = target_cr;
#line 413 "../lib/Drawing/Surface.vala"
	cairo_restore (_tmp24_);
#line 371 "../lib/Drawing/Surface.vala"
	_g_thread_unref0 (th2);
#line 371 "../lib/Drawing/Surface.vala"
	_g_thread_unref0 (th);
#line 371 "../lib/Drawing/Surface.vala"
	_cairo_destroy0 (cr);
#line 371 "../lib/Drawing/Surface.vala"
	_cairo_surface_destroy0 (original);
#line 371 "../lib/Drawing/Surface.vala"
	block5_data_unref (_data5_);
#line 371 "../lib/Drawing/Surface.vala"
	_data5_ = NULL;
#line 2126 "Surface.c"
}

static void
plank_surface_exponential_blur_columns (guint8* pixels,
                                        gint width,
                                        gint height,
                                        gint startCol,
                                        gint endCol,
                                        gint startY,
                                        gint endY,
                                        gint alpha)
{
	{
		gint columnIndex = 0;
#line 418 "../lib/Drawing/Surface.vala"
		columnIndex = startCol;
#line 2143 "Surface.c"
		{
			gboolean _tmp0_ = FALSE;
#line 418 "../lib/Drawing/Surface.vala"
			_tmp0_ = TRUE;
#line 418 "../lib/Drawing/Surface.vala"
			while (TRUE) {
#line 2150 "Surface.c"
				guint8* column = NULL;
				gint zA = 0;
				guint8* _tmp2_;
				guint8 _tmp3_;
				gint zR = 0;
				guint8* _tmp4_;
				guint8 _tmp5_;
				gint zG = 0;
				guint8* _tmp6_;
				guint8 _tmp7_;
				gint zB = 0;
				guint8* _tmp8_;
				guint8 _tmp9_;
#line 418 "../lib/Drawing/Surface.vala"
				if (!_tmp0_) {
#line 2166 "Surface.c"
					gint _tmp1_;
#line 418 "../lib/Drawing/Surface.vala"
					_tmp1_ = columnIndex;
#line 418 "../lib/Drawing/Surface.vala"
					columnIndex = _tmp1_ + 1;
#line 2172 "Surface.c"
				}
#line 418 "../lib/Drawing/Surface.vala"
				_tmp0_ = FALSE;
#line 418 "../lib/Drawing/Surface.vala"
				if (!(columnIndex < endCol)) {
#line 418 "../lib/Drawing/Surface.vala"
					break;
#line 2180 "Surface.c"
				}
#line 420 "../lib/Drawing/Surface.vala"
				column = pixels + (columnIndex * 4);
#line 422 "../lib/Drawing/Surface.vala"
				_tmp2_ = column;
#line 422 "../lib/Drawing/Surface.vala"
				_tmp3_ = _tmp2_[0];
#line 422 "../lib/Drawing/Surface.vala"
				zA = _tmp3_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
#line 423 "../lib/Drawing/Surface.vala"
				_tmp4_ = column;
#line 423 "../lib/Drawing/Surface.vala"
				_tmp5_ = _tmp4_[1];
#line 423 "../lib/Drawing/Surface.vala"
				zR = _tmp5_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
#line 424 "../lib/Drawing/Surface.vala"
				_tmp6_ = column;
#line 424 "../lib/Drawing/Surface.vala"
				_tmp7_ = _tmp6_[2];
#line 424 "../lib/Drawing/Surface.vala"
				zG = _tmp7_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
#line 425 "../lib/Drawing/Surface.vala"
				_tmp8_ = column;
#line 425 "../lib/Drawing/Surface.vala"
				_tmp9_ = _tmp8_[3];
#line 425 "../lib/Drawing/Surface.vala"
				zB = _tmp9_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
#line 2208 "Surface.c"
				{
					gint index = 0;
#line 428 "../lib/Drawing/Surface.vala"
					index = width * (startY + 1);
#line 2213 "Surface.c"
					{
						gboolean _tmp10_ = FALSE;
#line 428 "../lib/Drawing/Surface.vala"
						_tmp10_ = TRUE;
#line 428 "../lib/Drawing/Surface.vala"
						while (TRUE) {
#line 2220 "Surface.c"
							guint8* _tmp11_;
#line 428 "../lib/Drawing/Surface.vala"
							if (!_tmp10_) {
#line 428 "../lib/Drawing/Surface.vala"
								index += width;
#line 2226 "Surface.c"
							}
#line 428 "../lib/Drawing/Surface.vala"
							_tmp10_ = FALSE;
#line 428 "../lib/Drawing/Surface.vala"
							if (!(index < ((endY - 1) * width))) {
#line 428 "../lib/Drawing/Surface.vala"
								break;
#line 2234 "Surface.c"
							}
#line 429 "../lib/Drawing/Surface.vala"
							_tmp11_ = column;
#line 429 "../lib/Drawing/Surface.vala"
							plank_surface_exponential_blur_inner (&_tmp11_[index * 4], &zA, &zR, &zG, &zB, alpha);
#line 2240 "Surface.c"
						}
					}
				}
				{
					gint index = 0;
#line 432 "../lib/Drawing/Surface.vala"
					index = (endY - 2) * width;
#line 2248 "Surface.c"
					{
						gboolean _tmp12_ = FALSE;
#line 432 "../lib/Drawing/Surface.vala"
						_tmp12_ = TRUE;
#line 432 "../lib/Drawing/Surface.vala"
						while (TRUE) {
#line 2255 "Surface.c"
							guint8* _tmp13_;
#line 432 "../lib/Drawing/Surface.vala"
							if (!_tmp12_) {
#line 432 "../lib/Drawing/Surface.vala"
								index -= width;
#line 2261 "Surface.c"
							}
#line 432 "../lib/Drawing/Surface.vala"
							_tmp12_ = FALSE;
#line 432 "../lib/Drawing/Surface.vala"
							if (!(index >= startY)) {
#line 432 "../lib/Drawing/Surface.vala"
								break;
#line 2269 "Surface.c"
							}
#line 433 "../lib/Drawing/Surface.vala"
							_tmp13_ = column;
#line 433 "../lib/Drawing/Surface.vala"
							plank_surface_exponential_blur_inner (&_tmp13_[index * 4], &zA, &zR, &zG, &zB, alpha);
#line 2275 "Surface.c"
						}
					}
				}
			}
		}
	}
}

static void
plank_surface_exponential_blur_rows (guint8* pixels,
                                     gint width,
                                     gint height,
                                     gint startRow,
                                     gint endRow,
                                     gint startX,
                                     gint endX,
                                     gint alpha)
{
	{
		gint rowIndex = 0;
#line 439 "../lib/Drawing/Surface.vala"
		rowIndex = startRow;
#line 2298 "Surface.c"
		{
			gboolean _tmp0_ = FALSE;
#line 439 "../lib/Drawing/Surface.vala"
			_tmp0_ = TRUE;
#line 439 "../lib/Drawing/Surface.vala"
			while (TRUE) {
#line 2305 "Surface.c"
				guint8* row = NULL;
				gint zA = 0;
				guint8* _tmp2_;
				guint8 _tmp3_;
				gint zR = 0;
				guint8* _tmp4_;
				guint8 _tmp5_;
				gint zG = 0;
				guint8* _tmp6_;
				guint8 _tmp7_;
				gint zB = 0;
				guint8* _tmp8_;
				guint8 _tmp9_;
#line 439 "../lib/Drawing/Surface.vala"
				if (!_tmp0_) {
#line 2321 "Surface.c"
					gint _tmp1_;
#line 439 "../lib/Drawing/Surface.vala"
					_tmp1_ = rowIndex;
#line 439 "../lib/Drawing/Surface.vala"
					rowIndex = _tmp1_ + 1;
#line 2327 "Surface.c"
				}
#line 439 "../lib/Drawing/Surface.vala"
				_tmp0_ = FALSE;
#line 439 "../lib/Drawing/Surface.vala"
				if (!(rowIndex < endRow)) {
#line 439 "../lib/Drawing/Surface.vala"
					break;
#line 2335 "Surface.c"
				}
#line 441 "../lib/Drawing/Surface.vala"
				row = pixels + ((rowIndex * width) * 4);
#line 443 "../lib/Drawing/Surface.vala"
				_tmp2_ = row;
#line 443 "../lib/Drawing/Surface.vala"
				_tmp3_ = _tmp2_[startX + 0];
#line 443 "../lib/Drawing/Surface.vala"
				zA = _tmp3_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
#line 444 "../lib/Drawing/Surface.vala"
				_tmp4_ = row;
#line 444 "../lib/Drawing/Surface.vala"
				_tmp5_ = _tmp4_[startX + 1];
#line 444 "../lib/Drawing/Surface.vala"
				zR = _tmp5_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
#line 445 "../lib/Drawing/Surface.vala"
				_tmp6_ = row;
#line 445 "../lib/Drawing/Surface.vala"
				_tmp7_ = _tmp6_[startX + 2];
#line 445 "../lib/Drawing/Surface.vala"
				zG = _tmp7_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
#line 446 "../lib/Drawing/Surface.vala"
				_tmp8_ = row;
#line 446 "../lib/Drawing/Surface.vala"
				_tmp9_ = _tmp8_[startX + 3];
#line 446 "../lib/Drawing/Surface.vala"
				zB = _tmp9_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION;
#line 2363 "Surface.c"
				{
					gint index = 0;
#line 449 "../lib/Drawing/Surface.vala"
					index = startX + 1;
#line 2368 "Surface.c"
					{
						gboolean _tmp10_ = FALSE;
#line 449 "../lib/Drawing/Surface.vala"
						_tmp10_ = TRUE;
#line 449 "../lib/Drawing/Surface.vala"
						while (TRUE) {
#line 2375 "Surface.c"
							guint8* _tmp12_;
#line 449 "../lib/Drawing/Surface.vala"
							if (!_tmp10_) {
#line 2379 "Surface.c"
								gint _tmp11_;
#line 449 "../lib/Drawing/Surface.vala"
								_tmp11_ = index;
#line 449 "../lib/Drawing/Surface.vala"
								index = _tmp11_ + 1;
#line 2385 "Surface.c"
							}
#line 449 "../lib/Drawing/Surface.vala"
							_tmp10_ = FALSE;
#line 449 "../lib/Drawing/Surface.vala"
							if (!(index < endX)) {
#line 449 "../lib/Drawing/Surface.vala"
								break;
#line 2393 "Surface.c"
							}
#line 450 "../lib/Drawing/Surface.vala"
							_tmp12_ = row;
#line 450 "../lib/Drawing/Surface.vala"
							plank_surface_exponential_blur_inner (&_tmp12_[index * 4], &zA, &zR, &zG, &zB, alpha);
#line 2399 "Surface.c"
						}
					}
				}
				{
					gint index = 0;
#line 453 "../lib/Drawing/Surface.vala"
					index = endX - 2;
#line 2407 "Surface.c"
					{
						gboolean _tmp13_ = FALSE;
#line 453 "../lib/Drawing/Surface.vala"
						_tmp13_ = TRUE;
#line 453 "../lib/Drawing/Surface.vala"
						while (TRUE) {
#line 2414 "Surface.c"
							guint8* _tmp15_;
#line 453 "../lib/Drawing/Surface.vala"
							if (!_tmp13_) {
#line 2418 "Surface.c"
								gint _tmp14_;
#line 453 "../lib/Drawing/Surface.vala"
								_tmp14_ = index;
#line 453 "../lib/Drawing/Surface.vala"
								index = _tmp14_ - 1;
#line 2424 "Surface.c"
							}
#line 453 "../lib/Drawing/Surface.vala"
							_tmp13_ = FALSE;
#line 453 "../lib/Drawing/Surface.vala"
							if (!(index >= startX)) {
#line 453 "../lib/Drawing/Surface.vala"
								break;
#line 2432 "Surface.c"
							}
#line 454 "../lib/Drawing/Surface.vala"
							_tmp15_ = row;
#line 454 "../lib/Drawing/Surface.vala"
							plank_surface_exponential_blur_inner (&_tmp15_[index * 4], &zA, &zR, &zG, &zB, alpha);
#line 2438 "Surface.c"
						}
					}
				}
			}
		}
	}
}

static inline void
plank_surface_exponential_blur_inner (guint8* pixel,
                                      gint* zA,
                                      gint* zR,
                                      gint* zG,
                                      gint* zB,
                                      gint alpha)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
#line 460 "../lib/Drawing/Surface.vala"
	_tmp0_ = pixel[0];
#line 460 "../lib/Drawing/Surface.vala"
	*zA = (*zA) + ((alpha * ((_tmp0_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION) - (*zA))) >> PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION);
#line 461 "../lib/Drawing/Surface.vala"
	_tmp1_ = pixel[1];
#line 461 "../lib/Drawing/Surface.vala"
	*zR = (*zR) + ((alpha * ((_tmp1_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION) - (*zR))) >> PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION);
#line 462 "../lib/Drawing/Surface.vala"
	_tmp2_ = pixel[2];
#line 462 "../lib/Drawing/Surface.vala"
	*zG = (*zG) + ((alpha * ((_tmp2_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION) - (*zG))) >> PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION);
#line 463 "../lib/Drawing/Surface.vala"
	_tmp3_ = pixel[3];
#line 463 "../lib/Drawing/Surface.vala"
	*zB = (*zB) + ((alpha * ((_tmp3_ << PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION) - (*zB))) >> PLANK_SURFACE_EXP_BLUR_ALPHA_PRECISION);
#line 465 "../lib/Drawing/Surface.vala"
	pixel[0] = (guint8) ((*zA) >> PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION);
#line 466 "../lib/Drawing/Surface.vala"
	pixel[1] = (guint8) ((*zR) >> PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION);
#line 467 "../lib/Drawing/Surface.vala"
	pixel[2] = (guint8) ((*zG) >> PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION);
#line 468 "../lib/Drawing/Surface.vala"
	pixel[3] = (guint8) ((*zB) >> PLANK_SURFACE_EXP_BLUR_PARAM_PRECISION);
#line 2483 "Surface.c"
}

/**
 * Performs a gaussian blur on the surface.
 * ''Note: This method is wickedly slow''
 *
 * @param radius the radius of the blur
 */
static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 477 "../lib/Drawing/Surface.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 477 "../lib/Drawing/Surface.vala"
	return _data6_;
#line 2499 "Surface.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 477 "../lib/Drawing/Surface.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 2509 "Surface.c"
		PlankSurface* self;
#line 477 "../lib/Drawing/Surface.vala"
		self = _data6_->self;
#line 477 "../lib/Drawing/Surface.vala"
		_data6_->shiftar = (g_free (_data6_->shiftar), NULL);
#line 477 "../lib/Drawing/Surface.vala"
		_data6_->bbuffer = (g_free (_data6_->bbuffer), NULL);
#line 477 "../lib/Drawing/Surface.vala"
		_data6_->abuffer = (g_free (_data6_->abuffer), NULL);
#line 477 "../lib/Drawing/Surface.vala"
		_data6_->kernel = (g_free (_data6_->kernel), NULL);
#line 477 "../lib/Drawing/Surface.vala"
		_g_object_unref0 (self);
#line 477 "../lib/Drawing/Surface.vala"
		g_slice_free (Block6Data, _data6_);
#line 2525 "Surface.c"
	}
}

static void*
__lambda6_ (Block6Data* _data6_)
{
	PlankSurface* self;
	gdouble* _tmp0_;
	gint _tmp0__length1;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gdouble* _tmp2_;
	gint _tmp2__length1;
	gint* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	void* result;
#line 517 "../lib/Drawing/Surface.vala"
	self = _data6_->self;
#line 518 "../lib/Drawing/Surface.vala"
	_tmp0_ = _data6_->abuffer;
#line 518 "../lib/Drawing/Surface.vala"
	_tmp0__length1 = _data6_->abuffer_length1;
#line 518 "../lib/Drawing/Surface.vala"
	_tmp1_ = _data6_->bbuffer;
#line 518 "../lib/Drawing/Surface.vala"
	_tmp1__length1 = _data6_->bbuffer_length1;
#line 518 "../lib/Drawing/Surface.vala"
	_tmp2_ = _data6_->kernel;
#line 518 "../lib/Drawing/Surface.vala"
	_tmp2__length1 = _data6_->kernel_length1;
#line 518 "../lib/Drawing/Surface.vala"
	_tmp3_ = _data6_->shiftar;
#line 518 "../lib/Drawing/Surface.vala"
	_tmp3__length1 = _data6_->shiftar_length1;
#line 518 "../lib/Drawing/Surface.vala"
	_tmp3__length2 = _data6_->shiftar_length2;
#line 518 "../lib/Drawing/Surface.vala"
	plank_surface_gaussian_blur_horizontal (_tmp0_, _tmp1_, _tmp2_, _data6_->gaussWidth, _data6_->width, _data6_->height, 0, _data6_->height / 2, _tmp3_, (gint) _tmp3__length1, (gint) _tmp3__length2);
#line 519 "../lib/Drawing/Surface.vala"
	result = NULL;
#line 519 "../lib/Drawing/Surface.vala"
	return result;
#line 2569 "Surface.c"
}

static gpointer
___lambda6__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda6_ (self);
#line 517 "../lib/Drawing/Surface.vala"
	block6_data_unref (self);
#line 517 "../lib/Drawing/Surface.vala"
	return result;
#line 2581 "Surface.c"
}

static void*
__lambda7_ (Block6Data* _data6_)
{
	PlankSurface* self;
	gdouble* _tmp0_;
	gint _tmp0__length1;
	gdouble* _tmp1_;
	gint _tmp1__length1;
	gdouble* _tmp2_;
	gint _tmp2__length1;
	gint* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	void* result;
#line 540 "../lib/Drawing/Surface.vala"
	self = _data6_->self;
#line 541 "../lib/Drawing/Surface.vala"
	_tmp0_ = _data6_->bbuffer;
#line 541 "../lib/Drawing/Surface.vala"
	_tmp0__length1 = _data6_->bbuffer_length1;
#line 541 "../lib/Drawing/Surface.vala"
	_tmp1_ = _data6_->abuffer;
#line 541 "../lib/Drawing/Surface.vala"
	_tmp1__length1 = _data6_->abuffer_length1;
#line 541 "../lib/Drawing/Surface.vala"
	_tmp2_ = _data6_->kernel;
#line 541 "../lib/Drawing/Surface.vala"
	_tmp2__length1 = _data6_->kernel_length1;
#line 541 "../lib/Drawing/Surface.vala"
	_tmp3_ = _data6_->shiftar;
#line 541 "../lib/Drawing/Surface.vala"
	_tmp3__length1 = _data6_->shiftar_length1;
#line 541 "../lib/Drawing/Surface.vala"
	_tmp3__length2 = _data6_->shiftar_length2;
#line 541 "../lib/Drawing/Surface.vala"
	plank_surface_gaussian_blur_vertical (_tmp0_, _tmp1_, _tmp2_, _data6_->gaussWidth, _data6_->width, _data6_->height, 0, _data6_->width / 2, _tmp3_, (gint) _tmp3__length1, (gint) _tmp3__length2);
#line 542 "../lib/Drawing/Surface.vala"
	result = NULL;
#line 542 "../lib/Drawing/Surface.vala"
	return result;
#line 2624 "Surface.c"
}

static gpointer
___lambda7__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda7_ (self);
#line 540 "../lib/Drawing/Surface.vala"
	block6_data_unref (self);
#line 540 "../lib/Drawing/Surface.vala"
	return result;
#line 2636 "Surface.c"
}

void
plank_surface_gaussian_blur (PlankSurface* self,
                             gint radius)
{
	Block6Data* _data6_;
	gint _tmp0_ = 0;
	gdouble* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	cairo_surface_t* original = NULL;
	cairo_surface_t* _tmp4_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_t* _tmp7_;
	cairo_t* _tmp8_;
	cairo_surface_t* _tmp9_;
	cairo_t* _tmp10_;
	guint8* src = NULL;
	cairo_surface_t* _tmp11_;
	guchar* _tmp12_;
	gint size = 0;
	cairo_surface_t* _tmp13_;
	gdouble* _tmp14_;
	gdouble* _tmp15_;
	gint* _tmp21_;
	GThread* th = NULL;
	GThread* _tmp29_;
	gdouble* _tmp30_;
	gint _tmp30__length1;
	gdouble* _tmp31_;
	gint _tmp31__length1;
	gdouble* _tmp32_;
	gint _tmp32__length1;
	gint* _tmp33_;
	gint _tmp33__length1;
	gint _tmp33__length2;
	GThread* _tmp34_;
	gdouble* _tmp35_;
	gint _tmp35__length1;
	gint* _tmp36_;
	GThread* th2 = NULL;
	GThread* _tmp44_;
	gdouble* _tmp45_;
	gint _tmp45__length1;
	gdouble* _tmp46_;
	gint _tmp46__length1;
	gdouble* _tmp47_;
	gint _tmp47__length1;
	gint* _tmp48_;
	gint _tmp48__length1;
	gint _tmp48__length2;
	GThread* _tmp49_;
	cairo_surface_t* _tmp55_;
	cairo_t* target_cr = NULL;
	cairo_t* _tmp56_;
	cairo_t* _tmp57_;
	cairo_t* _tmp58_;
	cairo_t* _tmp59_;
	cairo_surface_t* _tmp60_;
	cairo_t* _tmp61_;
	cairo_t* _tmp62_;
#line 477 "../lib/Drawing/Surface.vala"
	g_return_if_fail (self != NULL);
#line 477 "../lib/Drawing/Surface.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 477 "../lib/Drawing/Surface.vala"
	_data6_->_ref_count_ = 1;
#line 477 "../lib/Drawing/Surface.vala"
	_data6_->self = g_object_ref (self);
#line 479 "../lib/Drawing/Surface.vala"
	if (radius < 1) {
#line 480 "../lib/Drawing/Surface.vala"
		block6_data_unref (_data6_);
#line 480 "../lib/Drawing/Surface.vala"
		_data6_ = NULL;
#line 480 "../lib/Drawing/Surface.vala"
		return;
#line 2717 "Surface.c"
	}
#line 482 "../lib/Drawing/Surface.vala"
	_data6_->gaussWidth = (radius * 2) + 1;
#line 483 "../lib/Drawing/Surface.vala"
	_tmp1_ = plank_surface_build_gaussian_kernel (_data6_->gaussWidth, &_tmp0_);
#line 483 "../lib/Drawing/Surface.vala"
	_data6_->kernel = _tmp1_;
#line 483 "../lib/Drawing/Surface.vala"
	_data6_->kernel_length1 = _tmp0_;
#line 483 "../lib/Drawing/Surface.vala"
	_data6_->_kernel_size_ = _data6_->kernel_length1;
#line 485 "../lib/Drawing/Surface.vala"
	_tmp2_ = self->priv->_Width;
#line 485 "../lib/Drawing/Surface.vala"
	_data6_->width = _tmp2_;
#line 486 "../lib/Drawing/Surface.vala"
	_tmp3_ = self->priv->_Height;
#line 486 "../lib/Drawing/Surface.vala"
	_data6_->height = _tmp3_;
#line 488 "../lib/Drawing/Surface.vala"
	_tmp4_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _data6_->width, _data6_->height);
#line 488 "../lib/Drawing/Surface.vala"
	original = _tmp4_;
#line 489 "../lib/Drawing/Surface.vala"
	_tmp5_ = original;
#line 489 "../lib/Drawing/Surface.vala"
	_tmp6_ = cairo_create (_tmp5_);
#line 489 "../lib/Drawing/Surface.vala"
	cr = _tmp6_;
#line 491 "../lib/Drawing/Surface.vala"
	_tmp7_ = cr;
#line 491 "../lib/Drawing/Surface.vala"
	cairo_set_operator (_tmp7_, CAIRO_OPERATOR_SOURCE);
#line 492 "../lib/Drawing/Surface.vala"
	_tmp8_ = cr;
#line 492 "../lib/Drawing/Surface.vala"
	_tmp9_ = self->priv->_Internal;
#line 492 "../lib/Drawing/Surface.vala"
	cairo_set_source_surface (_tmp8_, _tmp9_, (gdouble) 0, (gdouble) 0);
#line 493 "../lib/Drawing/Surface.vala"
	_tmp10_ = cr;
#line 493 "../lib/Drawing/Surface.vala"
	cairo_paint (_tmp10_);
#line 495 "../lib/Drawing/Surface.vala"
	_tmp11_ = original;
#line 495 "../lib/Drawing/Surface.vala"
	_tmp12_ = cairo_image_surface_get_data (_tmp11_);
#line 495 "../lib/Drawing/Surface.vala"
	src = _tmp12_;
#line 497 "../lib/Drawing/Surface.vala"
	_tmp13_ = original;
#line 497 "../lib/Drawing/Surface.vala"
	size = _data6_->height * cairo_image_surface_get_stride (_tmp13_);
#line 499 "../lib/Drawing/Surface.vala"
	_tmp14_ = g_new0 (gdouble, size);
#line 499 "../lib/Drawing/Surface.vala"
	_data6_->abuffer = _tmp14_;
#line 499 "../lib/Drawing/Surface.vala"
	_data6_->abuffer_length1 = size;
#line 499 "../lib/Drawing/Surface.vala"
	_data6_->_abuffer_size_ = _data6_->abuffer_length1;
#line 500 "../lib/Drawing/Surface.vala"
	_tmp15_ = g_new0 (gdouble, size);
#line 500 "../lib/Drawing/Surface.vala"
	_data6_->bbuffer = _tmp15_;
#line 500 "../lib/Drawing/Surface.vala"
	_data6_->bbuffer_length1 = size;
#line 500 "../lib/Drawing/Surface.vala"
	_data6_->_bbuffer_size_ = _data6_->bbuffer_length1;
#line 2787 "Surface.c"
	{
		gint i = 0;
#line 503 "../lib/Drawing/Surface.vala"
		i = 0;
#line 2792 "Surface.c"
		{
			gboolean _tmp16_ = FALSE;
#line 503 "../lib/Drawing/Surface.vala"
			_tmp16_ = TRUE;
#line 503 "../lib/Drawing/Surface.vala"
			while (TRUE) {
#line 2799 "Surface.c"
				gdouble* _tmp18_;
				gint _tmp18__length1;
				guint8* _tmp19_;
				guint8 _tmp20_;
#line 503 "../lib/Drawing/Surface.vala"
				if (!_tmp16_) {
#line 2806 "Surface.c"
					gint _tmp17_;
#line 503 "../lib/Drawing/Surface.vala"
					_tmp17_ = i;
#line 503 "../lib/Drawing/Surface.vala"
					i = _tmp17_ + 1;
#line 2812 "Surface.c"
				}
#line 503 "../lib/Drawing/Surface.vala"
				_tmp16_ = FALSE;
#line 503 "../lib/Drawing/Surface.vala"
				if (!(i < size)) {
#line 503 "../lib/Drawing/Surface.vala"
					break;
#line 2820 "Surface.c"
				}
#line 504 "../lib/Drawing/Surface.vala"
				_tmp18_ = _data6_->abuffer;
#line 504 "../lib/Drawing/Surface.vala"
				_tmp18__length1 = _data6_->abuffer_length1;
#line 504 "../lib/Drawing/Surface.vala"
				_tmp19_ = src;
#line 504 "../lib/Drawing/Surface.vala"
				_tmp20_ = _tmp19_[i];
#line 504 "../lib/Drawing/Surface.vala"
				_tmp18_[i] = (gdouble) _tmp20_;
#line 2832 "Surface.c"
			}
		}
	}
#line 507 "../lib/Drawing/Surface.vala"
	_tmp21_ = g_new0 (gint, MAX (_data6_->width, _data6_->height) * _data6_->gaussWidth);
#line 507 "../lib/Drawing/Surface.vala"
	_data6_->shiftar = _tmp21_;
#line 507 "../lib/Drawing/Surface.vala"
	_data6_->shiftar_length1 = MAX (_data6_->width, _data6_->height);
#line 507 "../lib/Drawing/Surface.vala"
	_data6_->shiftar_length2 = _data6_->gaussWidth;
#line 2844 "Surface.c"
	{
		gint x = 0;
#line 508 "../lib/Drawing/Surface.vala"
		x = 0;
#line 2849 "Surface.c"
		{
			gboolean _tmp22_ = FALSE;
#line 508 "../lib/Drawing/Surface.vala"
			_tmp22_ = TRUE;
#line 508 "../lib/Drawing/Surface.vala"
			while (TRUE) {
#line 508 "../lib/Drawing/Surface.vala"
				if (!_tmp22_) {
#line 2858 "Surface.c"
					gint _tmp23_;
#line 508 "../lib/Drawing/Surface.vala"
					_tmp23_ = x;
#line 508 "../lib/Drawing/Surface.vala"
					x = _tmp23_ + 1;
#line 2864 "Surface.c"
				}
#line 508 "../lib/Drawing/Surface.vala"
				_tmp22_ = FALSE;
#line 508 "../lib/Drawing/Surface.vala"
				if (!(x < _data6_->width)) {
#line 508 "../lib/Drawing/Surface.vala"
					break;
#line 2872 "Surface.c"
				}
				{
					gint k = 0;
#line 509 "../lib/Drawing/Surface.vala"
					k = 0;
#line 2878 "Surface.c"
					{
						gboolean _tmp24_ = FALSE;
#line 509 "../lib/Drawing/Surface.vala"
						_tmp24_ = TRUE;
#line 509 "../lib/Drawing/Surface.vala"
						while (TRUE) {
#line 2885 "Surface.c"
							gint shift = 0;
							gboolean _tmp26_ = FALSE;
#line 509 "../lib/Drawing/Surface.vala"
							if (!_tmp24_) {
#line 2890 "Surface.c"
								gint _tmp25_;
#line 509 "../lib/Drawing/Surface.vala"
								_tmp25_ = k;
#line 509 "../lib/Drawing/Surface.vala"
								k = _tmp25_ + 1;
#line 2896 "Surface.c"
							}
#line 509 "../lib/Drawing/Surface.vala"
							_tmp24_ = FALSE;
#line 509 "../lib/Drawing/Surface.vala"
							if (!(k < _data6_->gaussWidth)) {
#line 509 "../lib/Drawing/Surface.vala"
								break;
#line 2904 "Surface.c"
							}
#line 510 "../lib/Drawing/Surface.vala"
							shift = k - radius;
#line 511 "../lib/Drawing/Surface.vala"
							if ((x + shift) <= 0) {
#line 511 "../lib/Drawing/Surface.vala"
								_tmp26_ = TRUE;
#line 2912 "Surface.c"
							} else {
#line 511 "../lib/Drawing/Surface.vala"
								_tmp26_ = (x + shift) >= _data6_->width;
#line 2916 "Surface.c"
							}
#line 511 "../lib/Drawing/Surface.vala"
							if (_tmp26_) {
#line 2920 "Surface.c"
								gint* _tmp27_;
								gint _tmp27__length1;
								gint _tmp27__length2;
#line 512 "../lib/Drawing/Surface.vala"
								_tmp27_ = _data6_->shiftar;
#line 512 "../lib/Drawing/Surface.vala"
								_tmp27__length1 = _data6_->shiftar_length1;
#line 512 "../lib/Drawing/Surface.vala"
								_tmp27__length2 = _data6_->shiftar_length2;
#line 512 "../lib/Drawing/Surface.vala"
								_tmp27_[(x * _tmp27__length2) + k] = 0;
#line 2932 "Surface.c"
							} else {
								gint* _tmp28_;
								gint _tmp28__length1;
								gint _tmp28__length2;
#line 514 "../lib/Drawing/Surface.vala"
								_tmp28_ = _data6_->shiftar;
#line 514 "../lib/Drawing/Surface.vala"
								_tmp28__length1 = _data6_->shiftar_length1;
#line 514 "../lib/Drawing/Surface.vala"
								_tmp28__length2 = _data6_->shiftar_length2;
#line 514 "../lib/Drawing/Surface.vala"
								_tmp28_[(x * _tmp28__length2) + k] = shift * 4;
#line 2945 "Surface.c"
							}
						}
					}
				}
			}
		}
	}
#line 517 "../lib/Drawing/Surface.vala"
	_tmp29_ = g_thread_new (NULL, ___lambda6__gthread_func, block6_data_ref (_data6_));
#line 517 "../lib/Drawing/Surface.vala"
	th = _tmp29_;
#line 522 "../lib/Drawing/Surface.vala"
	_tmp30_ = _data6_->abuffer;
#line 522 "../lib/Drawing/Surface.vala"
	_tmp30__length1 = _data6_->abuffer_length1;
#line 522 "../lib/Drawing/Surface.vala"
	_tmp31_ = _data6_->bbuffer;
#line 522 "../lib/Drawing/Surface.vala"
	_tmp31__length1 = _data6_->bbuffer_length1;
#line 522 "../lib/Drawing/Surface.vala"
	_tmp32_ = _data6_->kernel;
#line 522 "../lib/Drawing/Surface.vala"
	_tmp32__length1 = _data6_->kernel_length1;
#line 522 "../lib/Drawing/Surface.vala"
	_tmp33_ = _data6_->shiftar;
#line 522 "../lib/Drawing/Surface.vala"
	_tmp33__length1 = _data6_->shiftar_length1;
#line 522 "../lib/Drawing/Surface.vala"
	_tmp33__length2 = _data6_->shiftar_length2;
#line 522 "../lib/Drawing/Surface.vala"
	plank_surface_gaussian_blur_horizontal (_tmp30_, _tmp31_, _tmp32_, _data6_->gaussWidth, _data6_->width, _data6_->height, _data6_->height / 2, _data6_->height, _tmp33_, (gint) _tmp33__length1, (gint) _tmp33__length2);
#line 523 "../lib/Drawing/Surface.vala"
	_tmp34_ = th;
#line 523 "../lib/Drawing/Surface.vala"
	th = NULL;
#line 523 "../lib/Drawing/Surface.vala"
	g_thread_join (_tmp34_);
#line 526 "../lib/Drawing/Surface.vala"
	_tmp35_ = _data6_->abuffer;
#line 526 "../lib/Drawing/Surface.vala"
	_tmp35__length1 = _data6_->abuffer_length1;
#line 526 "../lib/Drawing/Surface.vala"
	memset (_tmp35_, 0, (gsize) (sizeof (gdouble) * size));
#line 529 "../lib/Drawing/Surface.vala"
	_tmp36_ = g_new0 (gint, MAX (_data6_->width, _data6_->height) * _data6_->gaussWidth);
#line 529 "../lib/Drawing/Surface.vala"
	_data6_->shiftar = (g_free (_data6_->shiftar), NULL);
#line 529 "../lib/Drawing/Surface.vala"
	_data6_->shiftar = _tmp36_;
#line 529 "../lib/Drawing/Surface.vala"
	_data6_->shiftar_length1 = MAX (_data6_->width, _data6_->height);
#line 529 "../lib/Drawing/Surface.vala"
	_data6_->shiftar_length2 = _data6_->gaussWidth;
#line 2999 "Surface.c"
	{
		gint y = 0;
#line 530 "../lib/Drawing/Surface.vala"
		y = 0;
#line 3004 "Surface.c"
		{
			gboolean _tmp37_ = FALSE;
#line 530 "../lib/Drawing/Surface.vala"
			_tmp37_ = TRUE;
#line 530 "../lib/Drawing/Surface.vala"
			while (TRUE) {
#line 530 "../lib/Drawing/Surface.vala"
				if (!_tmp37_) {
#line 3013 "Surface.c"
					gint _tmp38_;
#line 530 "../lib/Drawing/Surface.vala"
					_tmp38_ = y;
#line 530 "../lib/Drawing/Surface.vala"
					y = _tmp38_ + 1;
#line 3019 "Surface.c"
				}
#line 530 "../lib/Drawing/Surface.vala"
				_tmp37_ = FALSE;
#line 530 "../lib/Drawing/Surface.vala"
				if (!(y < _data6_->height)) {
#line 530 "../lib/Drawing/Surface.vala"
					break;
#line 3027 "Surface.c"
				}
				{
					gint k = 0;
#line 531 "../lib/Drawing/Surface.vala"
					k = 0;
#line 3033 "Surface.c"
					{
						gboolean _tmp39_ = FALSE;
#line 531 "../lib/Drawing/Surface.vala"
						_tmp39_ = TRUE;
#line 531 "../lib/Drawing/Surface.vala"
						while (TRUE) {
#line 3040 "Surface.c"
							gint shift = 0;
							gboolean _tmp41_ = FALSE;
#line 531 "../lib/Drawing/Surface.vala"
							if (!_tmp39_) {
#line 3045 "Surface.c"
								gint _tmp40_;
#line 531 "../lib/Drawing/Surface.vala"
								_tmp40_ = k;
#line 531 "../lib/Drawing/Surface.vala"
								k = _tmp40_ + 1;
#line 3051 "Surface.c"
							}
#line 531 "../lib/Drawing/Surface.vala"
							_tmp39_ = FALSE;
#line 531 "../lib/Drawing/Surface.vala"
							if (!(k < _data6_->gaussWidth)) {
#line 531 "../lib/Drawing/Surface.vala"
								break;
#line 3059 "Surface.c"
							}
#line 532 "../lib/Drawing/Surface.vala"
							shift = k - radius;
#line 533 "../lib/Drawing/Surface.vala"
							if ((y + shift) <= 0) {
#line 533 "../lib/Drawing/Surface.vala"
								_tmp41_ = TRUE;
#line 3067 "Surface.c"
							} else {
#line 533 "../lib/Drawing/Surface.vala"
								_tmp41_ = (y + shift) >= _data6_->height;
#line 3071 "Surface.c"
							}
#line 533 "../lib/Drawing/Surface.vala"
							if (_tmp41_) {
#line 3075 "Surface.c"
								gint* _tmp42_;
								gint _tmp42__length1;
								gint _tmp42__length2;
#line 534 "../lib/Drawing/Surface.vala"
								_tmp42_ = _data6_->shiftar;
#line 534 "../lib/Drawing/Surface.vala"
								_tmp42__length1 = _data6_->shiftar_length1;
#line 534 "../lib/Drawing/Surface.vala"
								_tmp42__length2 = _data6_->shiftar_length2;
#line 534 "../lib/Drawing/Surface.vala"
								_tmp42_[(y * _tmp42__length2) + k] = 0;
#line 3087 "Surface.c"
							} else {
								gint* _tmp43_;
								gint _tmp43__length1;
								gint _tmp43__length2;
#line 536 "../lib/Drawing/Surface.vala"
								_tmp43_ = _data6_->shiftar;
#line 536 "../lib/Drawing/Surface.vala"
								_tmp43__length1 = _data6_->shiftar_length1;
#line 536 "../lib/Drawing/Surface.vala"
								_tmp43__length2 = _data6_->shiftar_length2;
#line 536 "../lib/Drawing/Surface.vala"
								_tmp43_[(y * _tmp43__length2) + k] = (shift * _data6_->width) * 4;
#line 3100 "Surface.c"
							}
						}
					}
				}
			}
		}
	}
#line 540 "../lib/Drawing/Surface.vala"
	_tmp44_ = g_thread_new (NULL, ___lambda7__gthread_func, block6_data_ref (_data6_));
#line 540 "../lib/Drawing/Surface.vala"
	th2 = _tmp44_;
#line 545 "../lib/Drawing/Surface.vala"
	_tmp45_ = _data6_->bbuffer;
#line 545 "../lib/Drawing/Surface.vala"
	_tmp45__length1 = _data6_->bbuffer_length1;
#line 545 "../lib/Drawing/Surface.vala"
	_tmp46_ = _data6_->abuffer;
#line 545 "../lib/Drawing/Surface.vala"
	_tmp46__length1 = _data6_->abuffer_length1;
#line 545 "../lib/Drawing/Surface.vala"
	_tmp47_ = _data6_->kernel;
#line 545 "../lib/Drawing/Surface.vala"
	_tmp47__length1 = _data6_->kernel_length1;
#line 545 "../lib/Drawing/Surface.vala"
	_tmp48_ = _data6_->shiftar;
#line 545 "../lib/Drawing/Surface.vala"
	_tmp48__length1 = _data6_->shiftar_length1;
#line 545 "../lib/Drawing/Surface.vala"
	_tmp48__length2 = _data6_->shiftar_length2;
#line 545 "../lib/Drawing/Surface.vala"
	plank_surface_gaussian_blur_vertical (_tmp45_, _tmp46_, _tmp47_, _data6_->gaussWidth, _data6_->width, _data6_->height, _data6_->width / 2, _data6_->width, _tmp48_, (gint) _tmp48__length1, (gint) _tmp48__length2);
#line 546 "../lib/Drawing/Surface.vala"
	_tmp49_ = th2;
#line 546 "../lib/Drawing/Surface.vala"
	th2 = NULL;
#line 546 "../lib/Drawing/Surface.vala"
	g_thread_join (_tmp49_);
#line 3138 "Surface.c"
	{
		gint i = 0;
#line 549 "../lib/Drawing/Surface.vala"
		i = 0;
#line 3143 "Surface.c"
		{
			gboolean _tmp50_ = FALSE;
#line 549 "../lib/Drawing/Surface.vala"
			_tmp50_ = TRUE;
#line 549 "../lib/Drawing/Surface.vala"
			while (TRUE) {
#line 3150 "Surface.c"
				guint8* _tmp52_;
				gdouble* _tmp53_;
				gint _tmp53__length1;
				gdouble _tmp54_;
#line 549 "../lib/Drawing/Surface.vala"
				if (!_tmp50_) {
#line 3157 "Surface.c"
					gint _tmp51_;
#line 549 "../lib/Drawing/Surface.vala"
					_tmp51_ = i;
#line 549 "../lib/Drawing/Surface.vala"
					i = _tmp51_ + 1;
#line 3163 "Surface.c"
				}
#line 549 "../lib/Drawing/Surface.vala"
				_tmp50_ = FALSE;
#line 549 "../lib/Drawing/Surface.vala"
				if (!(i < size)) {
#line 549 "../lib/Drawing/Surface.vala"
					break;
#line 3171 "Surface.c"
				}
#line 550 "../lib/Drawing/Surface.vala"
				_tmp52_ = src;
#line 550 "../lib/Drawing/Surface.vala"
				_tmp53_ = _data6_->abuffer;
#line 550 "../lib/Drawing/Surface.vala"
				_tmp53__length1 = _data6_->abuffer_length1;
#line 550 "../lib/Drawing/Surface.vala"
				_tmp54_ = _tmp53_[i];
#line 550 "../lib/Drawing/Surface.vala"
				_tmp52_[i] = (guint8) _tmp54_;
#line 3183 "Surface.c"
			}
		}
	}
#line 552 "../lib/Drawing/Surface.vala"
	_tmp55_ = original;
#line 552 "../lib/Drawing/Surface.vala"
	cairo_surface_mark_dirty (_tmp55_);
#line 554 "../lib/Drawing/Surface.vala"
	_tmp56_ = self->priv->_Context;
#line 554 "../lib/Drawing/Surface.vala"
	target_cr = _tmp56_;
#line 555 "../lib/Drawing/Surface.vala"
	_tmp57_ = target_cr;
#line 555 "../lib/Drawing/Surface.vala"
	cairo_save (_tmp57_);
#line 556 "../lib/Drawing/Surface.vala"
	_tmp58_ = target_cr;
#line 556 "../lib/Drawing/Surface.vala"
	cairo_set_operator (_tmp58_, CAIRO_OPERATOR_SOURCE);
#line 557 "../lib/Drawing/Surface.vala"
	_tmp59_ = target_cr;
#line 557 "../lib/Drawing/Surface.vala"
	_tmp60_ = original;
#line 557 "../lib/Drawing/Surface.vala"
	cairo_set_source_surface (_tmp59_, _tmp60_, (gdouble) 0, (gdouble) 0);
#line 558 "../lib/Drawing/Surface.vala"
	_tmp61_ = target_cr;
#line 558 "../lib/Drawing/Surface.vala"
	cairo_paint (_tmp61_);
#line 559 "../lib/Drawing/Surface.vala"
	_tmp62_ = target_cr;
#line 559 "../lib/Drawing/Surface.vala"
	cairo_restore (_tmp62_);
#line 477 "../lib/Drawing/Surface.vala"
	_g_thread_unref0 (th2);
#line 477 "../lib/Drawing/Surface.vala"
	_g_thread_unref0 (th);
#line 477 "../lib/Drawing/Surface.vala"
	_cairo_destroy0 (cr);
#line 477 "../lib/Drawing/Surface.vala"
	_cairo_surface_destroy0 (original);
#line 477 "../lib/Drawing/Surface.vala"
	block6_data_unref (_data6_);
#line 477 "../lib/Drawing/Surface.vala"
	_data6_ = NULL;
#line 3229 "Surface.c"
}

static void
plank_surface_gaussian_blur_horizontal (gdouble* src,
                                        gdouble* dest,
                                        gdouble* kernel,
                                        gint gaussWidth,
                                        gint width,
                                        gint height,
                                        gint startRow,
                                        gint endRow,
                                        gint* shift,
                                        gint shift_length1,
                                        gint shift_length2)
{
	guint32 cur_pixel = 0U;
#line 565 "../lib/Drawing/Surface.vala"
	cur_pixel = (guint32) ((startRow * width) * 4);
#line 3248 "Surface.c"
	{
		gint y = 0;
#line 567 "../lib/Drawing/Surface.vala"
		y = startRow;
#line 3253 "Surface.c"
		{
			gboolean _tmp0_ = FALSE;
#line 567 "../lib/Drawing/Surface.vala"
			_tmp0_ = TRUE;
#line 567 "../lib/Drawing/Surface.vala"
			while (TRUE) {
#line 567 "../lib/Drawing/Surface.vala"
				if (!_tmp0_) {
#line 3262 "Surface.c"
					gint _tmp1_;
#line 567 "../lib/Drawing/Surface.vala"
					_tmp1_ = y;
#line 567 "../lib/Drawing/Surface.vala"
					y = _tmp1_ + 1;
#line 3268 "Surface.c"
				}
#line 567 "../lib/Drawing/Surface.vala"
				_tmp0_ = FALSE;
#line 567 "../lib/Drawing/Surface.vala"
				if (!(y < endRow)) {
#line 567 "../lib/Drawing/Surface.vala"
					break;
#line 3276 "Surface.c"
				}
				{
					gint x = 0;
#line 568 "../lib/Drawing/Surface.vala"
					x = 0;
#line 3282 "Surface.c"
					{
						gboolean _tmp2_ = FALSE;
#line 568 "../lib/Drawing/Surface.vala"
						_tmp2_ = TRUE;
#line 568 "../lib/Drawing/Surface.vala"
						while (TRUE) {
#line 568 "../lib/Drawing/Surface.vala"
							if (!_tmp2_) {
#line 3291 "Surface.c"
								gint _tmp3_;
#line 568 "../lib/Drawing/Surface.vala"
								_tmp3_ = x;
#line 568 "../lib/Drawing/Surface.vala"
								x = _tmp3_ + 1;
#line 3297 "Surface.c"
							}
#line 568 "../lib/Drawing/Surface.vala"
							_tmp2_ = FALSE;
#line 568 "../lib/Drawing/Surface.vala"
							if (!(x < width)) {
#line 568 "../lib/Drawing/Surface.vala"
								break;
#line 3305 "Surface.c"
							}
							{
								gint k = 0;
#line 569 "../lib/Drawing/Surface.vala"
								k = 0;
#line 3311 "Surface.c"
								{
									gboolean _tmp4_ = FALSE;
#line 569 "../lib/Drawing/Surface.vala"
									_tmp4_ = TRUE;
#line 569 "../lib/Drawing/Surface.vala"
									while (TRUE) {
#line 3318 "Surface.c"
										guint32 source = 0U;
										gint _tmp6_;
										gdouble kernel_k = 0.0;
										gdouble _tmp7_;
										gdouble _tmp8_;
										gdouble _tmp9_;
										gdouble _tmp10_;
										gdouble _tmp11_;
#line 569 "../lib/Drawing/Surface.vala"
										if (!_tmp4_) {
#line 3329 "Surface.c"
											gint _tmp5_;
#line 569 "../lib/Drawing/Surface.vala"
											_tmp5_ = k;
#line 569 "../lib/Drawing/Surface.vala"
											k = _tmp5_ + 1;
#line 3335 "Surface.c"
										}
#line 569 "../lib/Drawing/Surface.vala"
										_tmp4_ = FALSE;
#line 569 "../lib/Drawing/Surface.vala"
										if (!(k < gaussWidth)) {
#line 569 "../lib/Drawing/Surface.vala"
											break;
#line 3343 "Surface.c"
										}
#line 570 "../lib/Drawing/Surface.vala"
										_tmp6_ = shift[(x * shift_length2) + k];
#line 570 "../lib/Drawing/Surface.vala"
										source = cur_pixel + _tmp6_;
#line 571 "../lib/Drawing/Surface.vala"
										_tmp7_ = kernel[k];
#line 571 "../lib/Drawing/Surface.vala"
										kernel_k = _tmp7_;
#line 573 "../lib/Drawing/Surface.vala"
										_tmp8_ = src[source + 0];
#line 573 "../lib/Drawing/Surface.vala"
										dest[cur_pixel + 0] += _tmp8_ * kernel_k;
#line 574 "../lib/Drawing/Surface.vala"
										_tmp9_ = src[source + 1];
#line 574 "../lib/Drawing/Surface.vala"
										dest[cur_pixel + 1] += _tmp9_ * kernel_k;
#line 575 "../lib/Drawing/Surface.vala"
										_tmp10_ = src[source + 2];
#line 575 "../lib/Drawing/Surface.vala"
										dest[cur_pixel + 2] += _tmp10_ * kernel_k;
#line 576 "../lib/Drawing/Surface.vala"
										_tmp11_ = src[source + 3];
#line 576 "../lib/Drawing/Surface.vala"
										dest[cur_pixel + 3] += _tmp11_ * kernel_k;
#line 3369 "Surface.c"
									}
								}
							}
#line 579 "../lib/Drawing/Surface.vala"
							cur_pixel += (guint32) 4;
#line 3375 "Surface.c"
						}
					}
				}
			}
		}
	}
}

static void
plank_surface_gaussian_blur_vertical (gdouble* src,
                                      gdouble* dest,
                                      gdouble* kernel,
                                      gint gaussWidth,
                                      gint width,
                                      gint height,
                                      gint startCol,
                                      gint endCol,
                                      gint* shift,
                                      gint shift_length1,
                                      gint shift_length2)
{
	guint32 cur_pixel = 0U;
#line 587 "../lib/Drawing/Surface.vala"
	cur_pixel = (guint32) (startCol * 4);
#line 3400 "Surface.c"
	{
		gint y = 0;
#line 589 "../lib/Drawing/Surface.vala"
		y = 0;
#line 3405 "Surface.c"
		{
			gboolean _tmp0_ = FALSE;
#line 589 "../lib/Drawing/Surface.vala"
			_tmp0_ = TRUE;
#line 589 "../lib/Drawing/Surface.vala"
			while (TRUE) {
#line 589 "../lib/Drawing/Surface.vala"
				if (!_tmp0_) {
#line 3414 "Surface.c"
					gint _tmp1_;
#line 589 "../lib/Drawing/Surface.vala"
					_tmp1_ = y;
#line 589 "../lib/Drawing/Surface.vala"
					y = _tmp1_ + 1;
#line 3420 "Surface.c"
				}
#line 589 "../lib/Drawing/Surface.vala"
				_tmp0_ = FALSE;
#line 589 "../lib/Drawing/Surface.vala"
				if (!(y < height)) {
#line 589 "../lib/Drawing/Surface.vala"
					break;
#line 3428 "Surface.c"
				}
				{
					gint x = 0;
#line 590 "../lib/Drawing/Surface.vala"
					x = startCol;
#line 3434 "Surface.c"
					{
						gboolean _tmp2_ = FALSE;
#line 590 "../lib/Drawing/Surface.vala"
						_tmp2_ = TRUE;
#line 590 "../lib/Drawing/Surface.vala"
						while (TRUE) {
#line 590 "../lib/Drawing/Surface.vala"
							if (!_tmp2_) {
#line 3443 "Surface.c"
								gint _tmp3_;
#line 590 "../lib/Drawing/Surface.vala"
								_tmp3_ = x;
#line 590 "../lib/Drawing/Surface.vala"
								x = _tmp3_ + 1;
#line 3449 "Surface.c"
							}
#line 590 "../lib/Drawing/Surface.vala"
							_tmp2_ = FALSE;
#line 590 "../lib/Drawing/Surface.vala"
							if (!(x < endCol)) {
#line 590 "../lib/Drawing/Surface.vala"
								break;
#line 3457 "Surface.c"
							}
							{
								gint k = 0;
#line 591 "../lib/Drawing/Surface.vala"
								k = 0;
#line 3463 "Surface.c"
								{
									gboolean _tmp4_ = FALSE;
#line 591 "../lib/Drawing/Surface.vala"
									_tmp4_ = TRUE;
#line 591 "../lib/Drawing/Surface.vala"
									while (TRUE) {
#line 3470 "Surface.c"
										guint32 source = 0U;
										gint _tmp6_;
										gdouble kernel_k = 0.0;
										gdouble _tmp7_;
										gdouble _tmp8_;
										gdouble _tmp9_;
										gdouble _tmp10_;
										gdouble _tmp11_;
#line 591 "../lib/Drawing/Surface.vala"
										if (!_tmp4_) {
#line 3481 "Surface.c"
											gint _tmp5_;
#line 591 "../lib/Drawing/Surface.vala"
											_tmp5_ = k;
#line 591 "../lib/Drawing/Surface.vala"
											k = _tmp5_ + 1;
#line 3487 "Surface.c"
										}
#line 591 "../lib/Drawing/Surface.vala"
										_tmp4_ = FALSE;
#line 591 "../lib/Drawing/Surface.vala"
										if (!(k < gaussWidth)) {
#line 591 "../lib/Drawing/Surface.vala"
											break;
#line 3495 "Surface.c"
										}
#line 592 "../lib/Drawing/Surface.vala"
										_tmp6_ = shift[(y * shift_length2) + k];
#line 592 "../lib/Drawing/Surface.vala"
										source = cur_pixel + _tmp6_;
#line 593 "../lib/Drawing/Surface.vala"
										_tmp7_ = kernel[k];
#line 593 "../lib/Drawing/Surface.vala"
										kernel_k = _tmp7_;
#line 595 "../lib/Drawing/Surface.vala"
										_tmp8_ = src[source + 0];
#line 595 "../lib/Drawing/Surface.vala"
										dest[cur_pixel + 0] += _tmp8_ * kernel_k;
#line 596 "../lib/Drawing/Surface.vala"
										_tmp9_ = src[source + 1];
#line 596 "../lib/Drawing/Surface.vala"
										dest[cur_pixel + 1] += _tmp9_ * kernel_k;
#line 597 "../lib/Drawing/Surface.vala"
										_tmp10_ = src[source + 2];
#line 597 "../lib/Drawing/Surface.vala"
										dest[cur_pixel + 2] += _tmp10_ * kernel_k;
#line 598 "../lib/Drawing/Surface.vala"
										_tmp11_ = src[source + 3];
#line 598 "../lib/Drawing/Surface.vala"
										dest[cur_pixel + 3] += _tmp11_ * kernel_k;
#line 3521 "Surface.c"
									}
								}
							}
#line 601 "../lib/Drawing/Surface.vala"
							cur_pixel += (guint32) 4;
#line 3527 "Surface.c"
						}
					}
				}
#line 603 "../lib/Drawing/Surface.vala"
				cur_pixel += (guint32) (((width - endCol) + startCol) * 4);
#line 3533 "Surface.c"
			}
		}
	}
}

static gdouble*
plank_surface_build_gaussian_kernel (gint gaussWidth,
                                     gint* result_length1)
{
	gdouble* kernel = NULL;
	gdouble* _tmp0_;
	gint kernel_length1;
	gint _kernel_size_;
	gdouble sd = 0.0;
	gint range = 0;
	gdouble mean = 0.0;
	gdouble gaussSum = 0.0;
	gdouble* _tmp5_;
	gint _tmp5__length1;
	gdouble* _tmp12_;
	gint _tmp12__length1;
	gdouble* result;
#line 607 "../lib/Drawing/Surface.vala"
	_vala_return_val_if_fail ((gaussWidth % 2) == 1, "gaussWidth % 2 == 1", NULL);
#line 610 "../lib/Drawing/Surface.vala"
	_tmp0_ = g_new0 (gdouble, gaussWidth);
#line 610 "../lib/Drawing/Surface.vala"
	kernel = _tmp0_;
#line 610 "../lib/Drawing/Surface.vala"
	kernel_length1 = gaussWidth;
#line 610 "../lib/Drawing/Surface.vala"
	_kernel_size_ = kernel_length1;
#line 613 "../lib/Drawing/Surface.vala"
	sd = 255.0;
#line 616 "../lib/Drawing/Surface.vala"
	range = gaussWidth;
#line 619 "../lib/Drawing/Surface.vala"
	mean = range / sd;
#line 3572 "Surface.c"
	{
		gint i = 0;
#line 621 "../lib/Drawing/Surface.vala"
		i = 0;
#line 3577 "Surface.c"
		{
			gboolean _tmp1_ = FALSE;
#line 621 "../lib/Drawing/Surface.vala"
			_tmp1_ = TRUE;
#line 621 "../lib/Drawing/Surface.vala"
			while (TRUE) {
#line 3584 "Surface.c"
				gdouble* _tmp3_;
				gint _tmp3__length1;
				gdouble* _tmp4_;
				gint _tmp4__length1;
#line 621 "../lib/Drawing/Surface.vala"
				if (!_tmp1_) {
#line 3591 "Surface.c"
					gint _tmp2_;
#line 621 "../lib/Drawing/Surface.vala"
					_tmp2_ = i;
#line 621 "../lib/Drawing/Surface.vala"
					i = _tmp2_ + 1;
#line 3597 "Surface.c"
				}
#line 621 "../lib/Drawing/Surface.vala"
				_tmp1_ = FALSE;
#line 621 "../lib/Drawing/Surface.vala"
				if (!(i < ((gaussWidth / 2) + 1))) {
#line 621 "../lib/Drawing/Surface.vala"
					break;
#line 3605 "Surface.c"
				}
#line 622 "../lib/Drawing/Surface.vala"
				_tmp3_ = kernel;
#line 622 "../lib/Drawing/Surface.vala"
				_tmp3__length1 = kernel_length1;
#line 622 "../lib/Drawing/Surface.vala"
				_tmp4_ = kernel;
#line 622 "../lib/Drawing/Surface.vala"
				_tmp4__length1 = kernel_length1;
#line 622 "../lib/Drawing/Surface.vala"
				_tmp4_[i] = pow (sin ((((i + 1) * G_PI_2) - mean) / range), (gdouble) 2) * sd;
#line 622 "../lib/Drawing/Surface.vala"
				_tmp3_[(gaussWidth - i) - 1] = _tmp4_[i];
#line 3619 "Surface.c"
			}
		}
	}
#line 625 "../lib/Drawing/Surface.vala"
	gaussSum = 0.0;
#line 626 "../lib/Drawing/Surface.vala"
	_tmp5_ = kernel;
#line 626 "../lib/Drawing/Surface.vala"
	_tmp5__length1 = kernel_length1;
#line 3629 "Surface.c"
	{
		gdouble* d_collection = NULL;
		gint d_collection_length1 = 0;
		gint _d_collection_size_ = 0;
		gint d_it = 0;
#line 626 "../lib/Drawing/Surface.vala"
		d_collection = _tmp5_;
#line 626 "../lib/Drawing/Surface.vala"
		d_collection_length1 = _tmp5__length1;
#line 626 "../lib/Drawing/Surface.vala"
		for (d_it = 0; d_it < d_collection_length1; d_it = d_it + 1) {
#line 3641 "Surface.c"
			gdouble d = 0.0;
#line 626 "../lib/Drawing/Surface.vala"
			d = d_collection[d_it];
#line 3645 "Surface.c"
			{
#line 627 "../lib/Drawing/Surface.vala"
				gaussSum += d;
#line 3649 "Surface.c"
			}
		}
	}
	{
		gint i = 0;
#line 629 "../lib/Drawing/Surface.vala"
		i = 0;
#line 3657 "Surface.c"
		{
			gboolean _tmp6_ = FALSE;
#line 629 "../lib/Drawing/Surface.vala"
			_tmp6_ = TRUE;
#line 629 "../lib/Drawing/Surface.vala"
			while (TRUE) {
#line 3664 "Surface.c"
				gdouble* _tmp8_;
				gint _tmp8__length1;
				gdouble* _tmp9_;
				gint _tmp9__length1;
				gdouble* _tmp10_;
				gint _tmp10__length1;
				gdouble _tmp11_;
#line 629 "../lib/Drawing/Surface.vala"
				if (!_tmp6_) {
#line 3674 "Surface.c"
					gint _tmp7_;
#line 629 "../lib/Drawing/Surface.vala"
					_tmp7_ = i;
#line 629 "../lib/Drawing/Surface.vala"
					i = _tmp7_ + 1;
#line 3680 "Surface.c"
				}
#line 629 "../lib/Drawing/Surface.vala"
				_tmp6_ = FALSE;
#line 629 "../lib/Drawing/Surface.vala"
				_tmp8_ = kernel;
#line 629 "../lib/Drawing/Surface.vala"
				_tmp8__length1 = kernel_length1;
#line 629 "../lib/Drawing/Surface.vala"
				if (!(i < _tmp8__length1)) {
#line 629 "../lib/Drawing/Surface.vala"
					break;
#line 3692 "Surface.c"
				}
#line 630 "../lib/Drawing/Surface.vala"
				_tmp9_ = kernel;
#line 630 "../lib/Drawing/Surface.vala"
				_tmp9__length1 = kernel_length1;
#line 630 "../lib/Drawing/Surface.vala"
				_tmp10_ = kernel;
#line 630 "../lib/Drawing/Surface.vala"
				_tmp10__length1 = kernel_length1;
#line 630 "../lib/Drawing/Surface.vala"
				_tmp11_ = _tmp10_[i];
#line 630 "../lib/Drawing/Surface.vala"
				_tmp9_[i] = _tmp11_ / gaussSum;
#line 3706 "Surface.c"
			}
		}
	}
#line 632 "../lib/Drawing/Surface.vala"
	_tmp12_ = kernel;
#line 632 "../lib/Drawing/Surface.vala"
	_tmp12__length1 = kernel_length1;
#line 632 "../lib/Drawing/Surface.vala"
	if (result_length1) {
#line 632 "../lib/Drawing/Surface.vala"
		*result_length1 = _tmp12__length1;
#line 3718 "Surface.c"
	}
#line 632 "../lib/Drawing/Surface.vala"
	result = _tmp12_;
#line 632 "../lib/Drawing/Surface.vala"
	return result;
#line 3724 "Surface.c"
}

cairo_surface_t*
plank_surface_get_Internal (PlankSurface* self)
{
	cairo_surface_t* result;
	cairo_surface_t* _tmp0_;
#line 34 "../lib/Drawing/Surface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../lib/Drawing/Surface.vala"
	_tmp0_ = self->priv->_Internal;
#line 34 "../lib/Drawing/Surface.vala"
	result = _tmp0_;
#line 34 "../lib/Drawing/Surface.vala"
	return result;
#line 3740 "Surface.c"
}

static gpointer
_cairo_surface_reference0 (gpointer self)
{
#line 34 "../lib/Drawing/Surface.vala"
	return self ? cairo_surface_reference (self) : NULL;
#line 3748 "Surface.c"
}

static void
plank_surface_set_Internal (PlankSurface* self,
                            cairo_surface_t* value)
{
	cairo_surface_t* old_value;
#line 34 "../lib/Drawing/Surface.vala"
	g_return_if_fail (self != NULL);
#line 34 "../lib/Drawing/Surface.vala"
	old_value = plank_surface_get_Internal (self);
#line 34 "../lib/Drawing/Surface.vala"
	if (old_value != value) {
#line 3762 "Surface.c"
		cairo_surface_t* _tmp0_;
#line 34 "../lib/Drawing/Surface.vala"
		_tmp0_ = _cairo_surface_reference0 (value);
#line 34 "../lib/Drawing/Surface.vala"
		_cairo_surface_destroy0 (self->priv->_Internal);
#line 34 "../lib/Drawing/Surface.vala"
		self->priv->_Internal = _tmp0_;
#line 34 "../lib/Drawing/Surface.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_surface_properties[PLANK_SURFACE_INTERNAL_PROPERTY]);
#line 3772 "Surface.c"
	}
}

gint
plank_surface_get_Width (PlankSurface* self)
{
	gint result;
#line 39 "../lib/Drawing/Surface.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 39 "../lib/Drawing/Surface.vala"
	result = self->priv->_Width;
#line 39 "../lib/Drawing/Surface.vala"
	return result;
#line 3786 "Surface.c"
}

static void
plank_surface_set_Width (PlankSurface* self,
                         gint value)
{
	gint old_value;
#line 39 "../lib/Drawing/Surface.vala"
	g_return_if_fail (self != NULL);
#line 39 "../lib/Drawing/Surface.vala"
	old_value = plank_surface_get_Width (self);
#line 39 "../lib/Drawing/Surface.vala"
	if (old_value != value) {
#line 39 "../lib/Drawing/Surface.vala"
		self->priv->_Width = value;
#line 39 "../lib/Drawing/Surface.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_surface_properties[PLANK_SURFACE_WIDTH_PROPERTY]);
#line 3804 "Surface.c"
	}
}

gint
plank_surface_get_Height (PlankSurface* self)
{
	gint result;
#line 44 "../lib/Drawing/Surface.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 44 "../lib/Drawing/Surface.vala"
	result = self->priv->_Height;
#line 44 "../lib/Drawing/Surface.vala"
	return result;
#line 3818 "Surface.c"
}

static void
plank_surface_set_Height (PlankSurface* self,
                          gint value)
{
	gint old_value;
#line 44 "../lib/Drawing/Surface.vala"
	g_return_if_fail (self != NULL);
#line 44 "../lib/Drawing/Surface.vala"
	old_value = plank_surface_get_Height (self);
#line 44 "../lib/Drawing/Surface.vala"
	if (old_value != value) {
#line 44 "../lib/Drawing/Surface.vala"
		self->priv->_Height = value;
#line 44 "../lib/Drawing/Surface.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_surface_properties[PLANK_SURFACE_HEIGHT_PROPERTY]);
#line 3836 "Surface.c"
	}
}

cairo_t*
plank_surface_get_Context (PlankSurface* self)
{
	cairo_t* result;
	cairo_t* _tmp0_;
#line 49 "../lib/Drawing/Surface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../lib/Drawing/Surface.vala"
	_tmp0_ = self->priv->_Context;
#line 49 "../lib/Drawing/Surface.vala"
	result = _tmp0_;
#line 49 "../lib/Drawing/Surface.vala"
	return result;
#line 3853 "Surface.c"
}

static gpointer
_cairo_reference0 (gpointer self)
{
#line 49 "../lib/Drawing/Surface.vala"
	return self ? cairo_reference (self) : NULL;
#line 3861 "Surface.c"
}

static void
plank_surface_set_Context (PlankSurface* self,
                           cairo_t* value)
{
	cairo_t* old_value;
#line 49 "../lib/Drawing/Surface.vala"
	g_return_if_fail (self != NULL);
#line 49 "../lib/Drawing/Surface.vala"
	old_value = plank_surface_get_Context (self);
#line 49 "../lib/Drawing/Surface.vala"
	if (old_value != value) {
#line 3875 "Surface.c"
		cairo_t* _tmp0_;
#line 49 "../lib/Drawing/Surface.vala"
		_tmp0_ = _cairo_reference0 (value);
#line 49 "../lib/Drawing/Surface.vala"
		_cairo_destroy0 (self->priv->_Context);
#line 49 "../lib/Drawing/Surface.vala"
		self->priv->_Context = _tmp0_;
#line 49 "../lib/Drawing/Surface.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_surface_properties[PLANK_SURFACE_CONTEXT_PROPERTY]);
#line 3885 "Surface.c"
	}
}

static GObject *
plank_surface_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankSurface * self;
	cairo_surface_t* _tmp0_;
	cairo_t* _tmp1_;
	cairo_t* _tmp2_;
#line 96 "../lib/Drawing/Surface.vala"
	parent_class = G_OBJECT_CLASS (plank_surface_parent_class);
#line 96 "../lib/Drawing/Surface.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 96 "../lib/Drawing/Surface.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_SURFACE, PlankSurface);
#line 98 "../lib/Drawing/Surface.vala"
	_tmp0_ = self->priv->_Internal;
#line 98 "../lib/Drawing/Surface.vala"
	_tmp1_ = cairo_create (_tmp0_);
#line 98 "../lib/Drawing/Surface.vala"
	_tmp2_ = _tmp1_;
#line 98 "../lib/Drawing/Surface.vala"
	plank_surface_set_Context (self, _tmp2_);
#line 98 "../lib/Drawing/Surface.vala"
	_cairo_destroy0 (_tmp2_);
#line 96 "../lib/Drawing/Surface.vala"
	return obj;
#line 3918 "Surface.c"
}

static void
plank_surface_class_init (PlankSurfaceClass * klass,
                          gpointer klass_data)
{
#line 26 "../lib/Drawing/Surface.vala"
	plank_surface_parent_class = g_type_class_peek_parent (klass);
#line 26 "../lib/Drawing/Surface.vala"
	g_type_class_adjust_private_offset (klass, &PlankSurface_private_offset);
#line 26 "../lib/Drawing/Surface.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_surface_get_property;
#line 26 "../lib/Drawing/Surface.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_surface_set_property;
#line 26 "../lib/Drawing/Surface.vala"
	G_OBJECT_CLASS (klass)->constructor = plank_surface_constructor;
#line 26 "../lib/Drawing/Surface.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_surface_finalize;
#line 3937 "Surface.c"
	/**
	 * The internal {@link Cairo.Surface} backing the surface.
	 */
#line 26 "../lib/Drawing/Surface.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_SURFACE_INTERNAL_PROPERTY, plank_surface_properties[PLANK_SURFACE_INTERNAL_PROPERTY] = g_param_spec_boxed ("Internal", "Internal", "Internal", cairo_gobject_surface_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 3943 "Surface.c"
	/**
	 * The width of the surface.
	 */
#line 26 "../lib/Drawing/Surface.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_SURFACE_WIDTH_PROPERTY, plank_surface_properties[PLANK_SURFACE_WIDTH_PROPERTY] = g_param_spec_int ("Width", "Width", "Width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 3949 "Surface.c"
	/**
	 * The height of the surface.
	 */
#line 26 "../lib/Drawing/Surface.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_SURFACE_HEIGHT_PROPERTY, plank_surface_properties[PLANK_SURFACE_HEIGHT_PROPERTY] = g_param_spec_int ("Height", "Height", "Height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 3955 "Surface.c"
	/**
	 * A {@link Cairo.Context} for the surface.
	 */
#line 26 "../lib/Drawing/Surface.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_SURFACE_CONTEXT_PROPERTY, plank_surface_properties[PLANK_SURFACE_CONTEXT_PROPERTY] = g_param_spec_boxed ("Context", "Context", "Context", cairo_gobject_context_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 3961 "Surface.c"
}

static void
plank_surface_instance_init (PlankSurface * self,
                             gpointer klass)
{
#line 26 "../lib/Drawing/Surface.vala"
	self->priv = plank_surface_get_instance_private (self);
#line 3970 "Surface.c"
}

static void
plank_surface_finalize (GObject * obj)
{
	PlankSurface * self;
#line 26 "../lib/Drawing/Surface.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_SURFACE, PlankSurface);
#line 34 "../lib/Drawing/Surface.vala"
	_cairo_surface_destroy0 (self->priv->_Internal);
#line 49 "../lib/Drawing/Surface.vala"
	_cairo_destroy0 (self->priv->_Context);
#line 26 "../lib/Drawing/Surface.vala"
	G_OBJECT_CLASS (plank_surface_parent_class)->finalize (obj);
#line 3985 "Surface.c"
}

/**
 * A surface is a wrapper class for a {@link Cairo.Surface}.
 * It encapsulates a surface/context and provides utility methods.
 */
static GType
plank_surface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankSurfaceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_surface_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankSurface), 0, (GInstanceInitFunc) plank_surface_instance_init, NULL };
	GType plank_surface_type_id;
	plank_surface_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankSurface", &g_define_type_info, 0);
	PlankSurface_private_offset = g_type_add_instance_private (plank_surface_type_id, sizeof (PlankSurfacePrivate));
	return plank_surface_type_id;
}

GType
plank_surface_get_type (void)
{
	static volatile gsize plank_surface_type_id__once = 0;
	if (g_once_init_enter (&plank_surface_type_id__once)) {
		GType plank_surface_type_id;
		plank_surface_type_id = plank_surface_get_type_once ();
		g_once_init_leave (&plank_surface_type_id__once, plank_surface_type_id);
	}
	return plank_surface_type_id__once;
}

static void
_vala_plank_surface_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	PlankSurface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_SURFACE, PlankSurface);
#line 26 "../lib/Drawing/Surface.vala"
	switch (property_id) {
#line 26 "../lib/Drawing/Surface.vala"
		case PLANK_SURFACE_INTERNAL_PROPERTY:
#line 26 "../lib/Drawing/Surface.vala"
		g_value_set_boxed (value, plank_surface_get_Internal (self));
#line 26 "../lib/Drawing/Surface.vala"
		break;
#line 26 "../lib/Drawing/Surface.vala"
		case PLANK_SURFACE_WIDTH_PROPERTY:
#line 26 "../lib/Drawing/Surface.vala"
		g_value_set_int (value, plank_surface_get_Width (self));
#line 26 "../lib/Drawing/Surface.vala"
		break;
#line 26 "../lib/Drawing/Surface.vala"
		case PLANK_SURFACE_HEIGHT_PROPERTY:
#line 26 "../lib/Drawing/Surface.vala"
		g_value_set_int (value, plank_surface_get_Height (self));
#line 26 "../lib/Drawing/Surface.vala"
		break;
#line 26 "../lib/Drawing/Surface.vala"
		case PLANK_SURFACE_CONTEXT_PROPERTY:
#line 26 "../lib/Drawing/Surface.vala"
		g_value_set_boxed (value, plank_surface_get_Context (self));
#line 26 "../lib/Drawing/Surface.vala"
		break;
#line 4048 "Surface.c"
		default:
#line 26 "../lib/Drawing/Surface.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../lib/Drawing/Surface.vala"
		break;
#line 4054 "Surface.c"
	}
}

static void
_vala_plank_surface_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	PlankSurface * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_SURFACE, PlankSurface);
#line 26 "../lib/Drawing/Surface.vala"
	switch (property_id) {
#line 26 "../lib/Drawing/Surface.vala"
		case PLANK_SURFACE_INTERNAL_PROPERTY:
#line 26 "../lib/Drawing/Surface.vala"
		plank_surface_set_Internal (self, g_value_get_boxed (value));
#line 26 "../lib/Drawing/Surface.vala"
		break;
#line 26 "../lib/Drawing/Surface.vala"
		case PLANK_SURFACE_WIDTH_PROPERTY:
#line 26 "../lib/Drawing/Surface.vala"
		plank_surface_set_Width (self, g_value_get_int (value));
#line 26 "../lib/Drawing/Surface.vala"
		break;
#line 26 "../lib/Drawing/Surface.vala"
		case PLANK_SURFACE_HEIGHT_PROPERTY:
#line 26 "../lib/Drawing/Surface.vala"
		plank_surface_set_Height (self, g_value_get_int (value));
#line 26 "../lib/Drawing/Surface.vala"
		break;
#line 26 "../lib/Drawing/Surface.vala"
		case PLANK_SURFACE_CONTEXT_PROPERTY:
#line 26 "../lib/Drawing/Surface.vala"
		plank_surface_set_Context (self, g_value_get_boxed (value));
#line 26 "../lib/Drawing/Surface.vala"
		break;
#line 4092 "Surface.c"
		default:
#line 26 "../lib/Drawing/Surface.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../lib/Drawing/Surface.vala"
		break;
#line 4098 "Surface.c"
	}
}

