/* DockContainer.c generated by valac 0.56.17, the Vala compiler
 * generated from DockContainer.vala, do not modify */

/**/
/*  Copyright (C) 2011-2013 Robert Dyer, Rico Tzschichholz*/
/*                2014 Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PLANK_DOCK_CONTAINER_0_PROPERTY,
	PLANK_DOCK_CONTAINER_VISIBLE_ELEMENTS_PROPERTY,
	PLANK_DOCK_CONTAINER_ELEMENTS_PROPERTY,
	PLANK_DOCK_CONTAINER_NUM_PROPERTIES
};
static GParamSpec* plank_dock_container_properties[PLANK_DOCK_CONTAINER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	PLANK_DOCK_CONTAINER_ELEMENTS_CHANGED_SIGNAL,
	PLANK_DOCK_CONTAINER_STATES_CHANGED_SIGNAL,
	PLANK_DOCK_CONTAINER_POSITIONS_CHANGED_SIGNAL,
	PLANK_DOCK_CONTAINER_NUM_SIGNALS
};
static guint plank_dock_container_signals[PLANK_DOCK_CONTAINER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

static gpointer plank_dock_container_parent_class = NULL;
PlankPlaceholderDockItem* plank_dock_container_placeholder_item = NULL;

static void plank_dock_container_remove_without_signaling (PlankDockContainer* self,
                                                    PlankDockElement* element);
static void plank_dock_container_real_prepare (PlankDockContainer* self);
static void plank_dock_container_add_without_signaling (PlankDockContainer* self,
                                                 PlankDockElement* element);
static void plank_dock_container_real_update_visible_elements (PlankDockContainer* self);
static gboolean plank_dock_container_real_move_to (PlankDockContainer* self,
                                            PlankDockElement* move,
                                            PlankDockElement* target);
static void plank_dock_container_real_reset_buffers (PlankDockElement* base);
static gboolean plank_dock_container_real_replace (PlankDockContainer* self,
                                            PlankDockElement* new_element,
                                            PlankDockElement* old_element);
static void plank_dock_container_real_connect_element (PlankDockContainer* self,
                                                PlankDockElement* element);
static void plank_dock_container_real_disconnect_element (PlankDockContainer* self,
                                                   PlankDockElement* element);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static GObject * plank_dock_container_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void plank_dock_container_finalize (GObject * obj);
static GType plank_dock_container_get_type_once (void);
static void _vala_plank_dock_container_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);

/**
 * Creates a new container for dock elements.
 */
PlankDockContainer*
plank_dock_container_construct (GType object_type)
{
	PlankDockContainer * self = NULL;
#line 81 "../lib/Items/DockContainer.vala"
	self = (PlankDockContainer*) g_object_new (object_type, NULL);
#line 79 "../lib/Items/DockContainer.vala"
	return self;
#line 108 "DockContainer.c"
}

/**
 * Do some special implementation specific preparation
 *
 * This is meant to called after the initial batch of items was added
 * and the provider is about to be added to the dock.
 */
static void
plank_dock_container_real_prepare (PlankDockContainer* self)
{
}

void
plank_dock_container_prepare (PlankDockContainer* self)
{
	PlankDockContainerClass* _klass_;
#line 113 "../lib/Items/DockContainer.vala"
	g_return_if_fail (self != NULL);
#line 113 "../lib/Items/DockContainer.vala"
	_klass_ = PLANK_DOCK_CONTAINER_GET_CLASS (self);
#line 113 "../lib/Items/DockContainer.vala"
	if (_klass_->prepare) {
#line 113 "../lib/Items/DockContainer.vala"
		_klass_->prepare (self);
#line 134 "DockContainer.c"
	}
}

/**
 * Adds a dock-element to the collection.
 *
 * @param element the dock-element to add
 * @param target an existing item where to put this new one at
 * @return whether adding the item was successful
 */
gboolean
plank_dock_container_add (PlankDockContainer* self,
                          PlankDockElement* element,
                          PlankDockElement* target)
{
	GeeArrayList* _tmp0_;
	PlankDockContainer* _tmp3_;
	PlankDockContainer* _tmp4_;
	gboolean _tmp7_ = FALSE;
	gboolean result;
#line 124 "../lib/Items/DockContainer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 124 "../lib/Items/DockContainer.vala"
	g_return_val_if_fail (element != NULL, FALSE);
#line 126 "../lib/Items/DockContainer.vala"
	_tmp0_ = self->internal_elements;
#line 126 "../lib/Items/DockContainer.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, element)) {
#line 163 "DockContainer.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 127 "../lib/Items/DockContainer.vala"
		_tmp1_ = plank_dock_element_get_Text (element);
#line 127 "../lib/Items/DockContainer.vala"
		_tmp2_ = _tmp1_;
#line 127 "../lib/Items/DockContainer.vala"
		g_critical ("DockContainer.vala:127: Element '%s' already exists in this DockContai" \
"ner.", _tmp2_);
#line 128 "../lib/Items/DockContainer.vala"
		result = FALSE;
#line 128 "../lib/Items/DockContainer.vala"
		return result;
#line 176 "DockContainer.c"
	}
#line 131 "../lib/Items/DockContainer.vala"
	_tmp3_ = plank_dock_element_get_Container (element);
#line 131 "../lib/Items/DockContainer.vala"
	_tmp4_ = _tmp3_;
#line 131 "../lib/Items/DockContainer.vala"
	if (_tmp4_ != NULL) {
#line 184 "DockContainer.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 132 "../lib/Items/DockContainer.vala"
		_tmp5_ = plank_dock_element_get_Text (element);
#line 132 "../lib/Items/DockContainer.vala"
		_tmp6_ = _tmp5_;
#line 132 "../lib/Items/DockContainer.vala"
		g_critical ("DockContainer.vala:132: Element '%s' should be removed from its old Do" \
"ckContainer first.", _tmp6_);
#line 133 "../lib/Items/DockContainer.vala"
		result = FALSE;
#line 133 "../lib/Items/DockContainer.vala"
		return result;
#line 197 "DockContainer.c"
	}
#line 136 "../lib/Items/DockContainer.vala"
	plank_dock_container_add_without_signaling (self, element);
#line 138 "../lib/Items/DockContainer.vala"
	if (target != NULL) {
#line 203 "DockContainer.c"
		PlankPlaceholderDockItem* _tmp8_;
#line 138 "../lib/Items/DockContainer.vala"
		_tmp8_ = plank_dock_container_placeholder_item;
#line 138 "../lib/Items/DockContainer.vala"
		_tmp7_ = target != G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, PLANK_TYPE_DOCK_ELEMENT, PlankDockElement);
#line 209 "DockContainer.c"
	} else {
#line 138 "../lib/Items/DockContainer.vala"
		_tmp7_ = FALSE;
#line 213 "DockContainer.c"
	}
#line 138 "../lib/Items/DockContainer.vala"
	if (_tmp7_) {
#line 139 "../lib/Items/DockContainer.vala"
		plank_dock_container_move_to (self, element, target);
#line 219 "DockContainer.c"
	} else {
#line 141 "../lib/Items/DockContainer.vala"
		plank_dock_container_update_visible_elements (self);
#line 223 "DockContainer.c"
	}
#line 143 "../lib/Items/DockContainer.vala"
	result = TRUE;
#line 143 "../lib/Items/DockContainer.vala"
	return result;
#line 229 "DockContainer.c"
}

/**
 * Prepends a dock-element to the collection.
 * So the dock-element will appear at the first position.
 *
 * @param element the dock-element to add
 */
void
plank_dock_container_prepend (PlankDockContainer* self,
                              PlankDockElement* element)
{
	GeeArrayList* _tmp0_;
	PlankDockContainer* _tmp3_;
	PlankDockContainer* _tmp4_;
	PlankDockContainer* container = NULL;
	PlankDockContainer* _tmp7_;
	PlankDockElement* target = NULL;
	GeeArrayList* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gboolean _tmp14_ = FALSE;
	PlankDockElement* _tmp15_;
#line 152 "../lib/Items/DockContainer.vala"
	g_return_if_fail (self != NULL);
#line 152 "../lib/Items/DockContainer.vala"
	g_return_if_fail (element != NULL);
#line 154 "../lib/Items/DockContainer.vala"
	_tmp0_ = self->internal_elements;
#line 154 "../lib/Items/DockContainer.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, element)) {
#line 261 "DockContainer.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 155 "../lib/Items/DockContainer.vala"
		_tmp1_ = plank_dock_element_get_Text (element);
#line 155 "../lib/Items/DockContainer.vala"
		_tmp2_ = _tmp1_;
#line 155 "../lib/Items/DockContainer.vala"
		g_critical ("DockContainer.vala:155: Element '%s' already exists in this DockContai" \
"ner.", _tmp2_);
#line 156 "../lib/Items/DockContainer.vala"
		return;
#line 272 "DockContainer.c"
	}
#line 159 "../lib/Items/DockContainer.vala"
	_tmp3_ = plank_dock_element_get_Container (element);
#line 159 "../lib/Items/DockContainer.vala"
	_tmp4_ = _tmp3_;
#line 159 "../lib/Items/DockContainer.vala"
	if (_tmp4_ != NULL) {
#line 280 "DockContainer.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 160 "../lib/Items/DockContainer.vala"
		_tmp5_ = plank_dock_element_get_Text (element);
#line 160 "../lib/Items/DockContainer.vala"
		_tmp6_ = _tmp5_;
#line 160 "../lib/Items/DockContainer.vala"
		g_critical ("DockContainer.vala:160: Element '%s' should be removed from its old Do" \
"ckContainer first.", _tmp6_);
#line 161 "../lib/Items/DockContainer.vala"
		return;
#line 291 "DockContainer.c"
	}
#line 164 "../lib/Items/DockContainer.vala"
	container = PLANK_IS_DOCK_CONTAINER (element) ? ((PlankDockContainer*) element) : NULL;
#line 165 "../lib/Items/DockContainer.vala"
	_tmp7_ = container;
#line 165 "../lib/Items/DockContainer.vala"
	if (_tmp7_ != NULL) {
#line 299 "DockContainer.c"
		PlankDockContainer* _tmp8_;
#line 166 "../lib/Items/DockContainer.vala"
		_tmp8_ = container;
#line 166 "../lib/Items/DockContainer.vala"
		plank_dock_container_prepare (_tmp8_);
#line 305 "DockContainer.c"
	}
#line 167 "../lib/Items/DockContainer.vala"
	plank_dock_container_add_without_signaling (self, element);
#line 169 "../lib/Items/DockContainer.vala"
	target = NULL;
#line 170 "../lib/Items/DockContainer.vala"
	_tmp9_ = self->internal_elements;
#line 170 "../lib/Items/DockContainer.vala"
	_tmp10_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp9_);
#line 170 "../lib/Items/DockContainer.vala"
	_tmp11_ = _tmp10_;
#line 170 "../lib/Items/DockContainer.vala"
	if (_tmp11_ > 1) {
#line 319 "DockContainer.c"
		GeeArrayList* _tmp12_;
		gpointer _tmp13_;
#line 171 "../lib/Items/DockContainer.vala"
		_tmp12_ = self->internal_elements;
#line 171 "../lib/Items/DockContainer.vala"
		_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, 0);
#line 171 "../lib/Items/DockContainer.vala"
		_g_object_unref0 (target);
#line 171 "../lib/Items/DockContainer.vala"
		target = (PlankDockElement*) _tmp13_;
#line 330 "DockContainer.c"
	}
#line 173 "../lib/Items/DockContainer.vala"
	_tmp15_ = target;
#line 173 "../lib/Items/DockContainer.vala"
	if (_tmp15_ != NULL) {
#line 336 "DockContainer.c"
		PlankDockElement* _tmp16_;
#line 173 "../lib/Items/DockContainer.vala"
		_tmp16_ = target;
#line 173 "../lib/Items/DockContainer.vala"
		_tmp14_ = _tmp16_ != element;
#line 342 "DockContainer.c"
	} else {
#line 173 "../lib/Items/DockContainer.vala"
		_tmp14_ = FALSE;
#line 346 "DockContainer.c"
	}
#line 173 "../lib/Items/DockContainer.vala"
	if (_tmp14_) {
#line 350 "DockContainer.c"
		GeeArrayList* _tmp17_;
		GeeArrayList* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
#line 174 "../lib/Items/DockContainer.vala"
		_tmp17_ = self->internal_elements;
#line 174 "../lib/Items/DockContainer.vala"
		_tmp18_ = self->internal_elements;
#line 174 "../lib/Items/DockContainer.vala"
		_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp18_);
#line 174 "../lib/Items/DockContainer.vala"
		_tmp20_ = _tmp19_;
#line 174 "../lib/Items/DockContainer.vala"
		plank_dock_container_move_element ((GeeList*) _tmp17_, _tmp20_ - 1, 0, NULL);
#line 365 "DockContainer.c"
	}
#line 176 "../lib/Items/DockContainer.vala"
	plank_dock_container_update_visible_elements (self);
#line 152 "../lib/Items/DockContainer.vala"
	_g_object_unref0 (target);
#line 371 "DockContainer.c"
}

/**
 * Adds a ordered list of dock-elements to the collection.
 *
 * @param elements the dock-elements to add
 * @return whether all elements were added successfully
 */
gboolean
plank_dock_container_add_all (PlankDockContainer* self,
                              GeeArrayList* elements)
{
	gboolean _result_ = FALSE;
	gboolean result;
#line 185 "../lib/Items/DockContainer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 185 "../lib/Items/DockContainer.vala"
	g_return_val_if_fail (elements != NULL, FALSE);
#line 187 "../lib/Items/DockContainer.vala"
	_result_ = TRUE;
#line 392 "DockContainer.c"
	{
		GeeArrayList* _element_list = NULL;
		gint _element_size = 0;
		GeeArrayList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _element_index = 0;
#line 189 "../lib/Items/DockContainer.vala"
		_element_list = elements;
#line 189 "../lib/Items/DockContainer.vala"
		_tmp0_ = _element_list;
#line 189 "../lib/Items/DockContainer.vala"
		_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 189 "../lib/Items/DockContainer.vala"
		_tmp2_ = _tmp1_;
#line 189 "../lib/Items/DockContainer.vala"
		_element_size = _tmp2_;
#line 189 "../lib/Items/DockContainer.vala"
		_element_index = -1;
#line 189 "../lib/Items/DockContainer.vala"
		while (TRUE) {
#line 414 "DockContainer.c"
			gint _tmp3_;
			gint _tmp4_;
			PlankDockElement* element = NULL;
			GeeArrayList* _tmp5_;
			gpointer _tmp6_;
			GeeArrayList* _tmp7_;
			PlankDockElement* _tmp8_;
			PlankDockElement* _tmp12_;
			PlankDockContainer* _tmp13_;
			PlankDockContainer* _tmp14_;
			PlankDockElement* _tmp18_;
#line 189 "../lib/Items/DockContainer.vala"
			_element_index = _element_index + 1;
#line 189 "../lib/Items/DockContainer.vala"
			_tmp3_ = _element_index;
#line 189 "../lib/Items/DockContainer.vala"
			_tmp4_ = _element_size;
#line 189 "../lib/Items/DockContainer.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 189 "../lib/Items/DockContainer.vala"
				break;
#line 436 "DockContainer.c"
			}
#line 189 "../lib/Items/DockContainer.vala"
			_tmp5_ = _element_list;
#line 189 "../lib/Items/DockContainer.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _element_index);
#line 189 "../lib/Items/DockContainer.vala"
			element = (PlankDockElement*) _tmp6_;
#line 190 "../lib/Items/DockContainer.vala"
			_tmp7_ = self->internal_elements;
#line 190 "../lib/Items/DockContainer.vala"
			_tmp8_ = element;
#line 190 "../lib/Items/DockContainer.vala"
			if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp7_, _tmp8_)) {
#line 450 "DockContainer.c"
				PlankDockElement* _tmp9_;
				const gchar* _tmp10_;
				const gchar* _tmp11_;
#line 191 "../lib/Items/DockContainer.vala"
				_tmp9_ = element;
#line 191 "../lib/Items/DockContainer.vala"
				_tmp10_ = plank_dock_element_get_Text (_tmp9_);
#line 191 "../lib/Items/DockContainer.vala"
				_tmp11_ = _tmp10_;
#line 191 "../lib/Items/DockContainer.vala"
				g_critical ("DockContainer.vala:191: Element '%s' already exists in this DockContai" \
"ner.", _tmp11_);
#line 192 "../lib/Items/DockContainer.vala"
				_result_ = FALSE;
#line 193 "../lib/Items/DockContainer.vala"
				_g_object_unref0 (element);
#line 193 "../lib/Items/DockContainer.vala"
				continue;
#line 468 "DockContainer.c"
			}
#line 196 "../lib/Items/DockContainer.vala"
			_tmp12_ = element;
#line 196 "../lib/Items/DockContainer.vala"
			_tmp13_ = plank_dock_element_get_Container (_tmp12_);
#line 196 "../lib/Items/DockContainer.vala"
			_tmp14_ = _tmp13_;
#line 196 "../lib/Items/DockContainer.vala"
			if (_tmp14_ != NULL) {
#line 478 "DockContainer.c"
				PlankDockElement* _tmp15_;
				const gchar* _tmp16_;
				const gchar* _tmp17_;
#line 197 "../lib/Items/DockContainer.vala"
				_tmp15_ = element;
#line 197 "../lib/Items/DockContainer.vala"
				_tmp16_ = plank_dock_element_get_Text (_tmp15_);
#line 197 "../lib/Items/DockContainer.vala"
				_tmp17_ = _tmp16_;
#line 197 "../lib/Items/DockContainer.vala"
				g_critical ("DockContainer.vala:197: Element '%s' should be removed from its old Do" \
"ckContainer first.", _tmp17_);
#line 198 "../lib/Items/DockContainer.vala"
				_result_ = FALSE;
#line 199 "../lib/Items/DockContainer.vala"
				_g_object_unref0 (element);
#line 199 "../lib/Items/DockContainer.vala"
				continue;
#line 496 "DockContainer.c"
			}
#line 202 "../lib/Items/DockContainer.vala"
			_tmp18_ = element;
#line 202 "../lib/Items/DockContainer.vala"
			plank_dock_container_add_without_signaling (self, _tmp18_);
#line 189 "../lib/Items/DockContainer.vala"
			_g_object_unref0 (element);
#line 504 "DockContainer.c"
		}
	}
#line 205 "../lib/Items/DockContainer.vala"
	plank_dock_container_update_visible_elements (self);
#line 207 "../lib/Items/DockContainer.vala"
	result = _result_;
#line 207 "../lib/Items/DockContainer.vala"
	return result;
#line 513 "DockContainer.c"
}

/**
 * Removes a dock-element from the collection.
 *
 * @param element the dock-element to remove
 * @return whether removing the element was successful
 */
gboolean
plank_dock_container_remove (PlankDockContainer* self,
                             PlankDockElement* element)
{
	GeeArrayList* _tmp0_;
	gboolean result;
#line 216 "../lib/Items/DockContainer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 216 "../lib/Items/DockContainer.vala"
	g_return_val_if_fail (element != NULL, FALSE);
#line 218 "../lib/Items/DockContainer.vala"
	_tmp0_ = self->internal_elements;
#line 218 "../lib/Items/DockContainer.vala"
	if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, element)) {
#line 536 "DockContainer.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 219 "../lib/Items/DockContainer.vala"
		_tmp1_ = plank_dock_element_get_Text (element);
#line 219 "../lib/Items/DockContainer.vala"
		_tmp2_ = _tmp1_;
#line 219 "../lib/Items/DockContainer.vala"
		g_critical ("DockContainer.vala:219: Element '%s' does not exist in this DockContai" \
"ner.", _tmp2_);
#line 220 "../lib/Items/DockContainer.vala"
		result = FALSE;
#line 220 "../lib/Items/DockContainer.vala"
		return result;
#line 549 "DockContainer.c"
	}
#line 223 "../lib/Items/DockContainer.vala"
	plank_dock_container_remove_without_signaling (self, element);
#line 225 "../lib/Items/DockContainer.vala"
	plank_dock_container_update_visible_elements (self);
#line 227 "../lib/Items/DockContainer.vala"
	result = TRUE;
#line 227 "../lib/Items/DockContainer.vala"
	return result;
#line 559 "DockContainer.c"
}

/**
 * Removes all given dock-elements from the collection.
 *
 * @param elements the dock-elements to remove
 * @return whether removing the elements was successful
 */
gboolean
plank_dock_container_remove_all (PlankDockContainer* self,
                                 GeeArrayList* elements)
{
	gboolean _result_ = FALSE;
	gboolean result;
#line 236 "../lib/Items/DockContainer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 236 "../lib/Items/DockContainer.vala"
	g_return_val_if_fail (elements != NULL, FALSE);
#line 238 "../lib/Items/DockContainer.vala"
	_result_ = TRUE;
#line 580 "DockContainer.c"
	{
		GeeArrayList* _element_list = NULL;
		gint _element_size = 0;
		GeeArrayList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _element_index = 0;
#line 240 "../lib/Items/DockContainer.vala"
		_element_list = elements;
#line 240 "../lib/Items/DockContainer.vala"
		_tmp0_ = _element_list;
#line 240 "../lib/Items/DockContainer.vala"
		_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 240 "../lib/Items/DockContainer.vala"
		_tmp2_ = _tmp1_;
#line 240 "../lib/Items/DockContainer.vala"
		_element_size = _tmp2_;
#line 240 "../lib/Items/DockContainer.vala"
		_element_index = -1;
#line 240 "../lib/Items/DockContainer.vala"
		while (TRUE) {
#line 602 "DockContainer.c"
			gint _tmp3_;
			gint _tmp4_;
			PlankDockElement* element = NULL;
			GeeArrayList* _tmp5_;
			gpointer _tmp6_;
			GeeArrayList* _tmp7_;
			PlankDockElement* _tmp8_;
			PlankDockElement* _tmp12_;
#line 240 "../lib/Items/DockContainer.vala"
			_element_index = _element_index + 1;
#line 240 "../lib/Items/DockContainer.vala"
			_tmp3_ = _element_index;
#line 240 "../lib/Items/DockContainer.vala"
			_tmp4_ = _element_size;
#line 240 "../lib/Items/DockContainer.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 240 "../lib/Items/DockContainer.vala"
				break;
#line 621 "DockContainer.c"
			}
#line 240 "../lib/Items/DockContainer.vala"
			_tmp5_ = _element_list;
#line 240 "../lib/Items/DockContainer.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _element_index);
#line 240 "../lib/Items/DockContainer.vala"
			element = (PlankDockElement*) _tmp6_;
#line 241 "../lib/Items/DockContainer.vala"
			_tmp7_ = self->internal_elements;
#line 241 "../lib/Items/DockContainer.vala"
			_tmp8_ = element;
#line 241 "../lib/Items/DockContainer.vala"
			if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp7_, _tmp8_)) {
#line 635 "DockContainer.c"
				PlankDockElement* _tmp9_;
				const gchar* _tmp10_;
				const gchar* _tmp11_;
#line 242 "../lib/Items/DockContainer.vala"
				_tmp9_ = element;
#line 242 "../lib/Items/DockContainer.vala"
				_tmp10_ = plank_dock_element_get_Text (_tmp9_);
#line 242 "../lib/Items/DockContainer.vala"
				_tmp11_ = _tmp10_;
#line 242 "../lib/Items/DockContainer.vala"
				g_critical ("DockContainer.vala:242: Element '%s' does not exist in this DockContai" \
"ner.", _tmp11_);
#line 243 "../lib/Items/DockContainer.vala"
				_result_ = FALSE;
#line 244 "../lib/Items/DockContainer.vala"
				_g_object_unref0 (element);
#line 244 "../lib/Items/DockContainer.vala"
				continue;
#line 653 "DockContainer.c"
			}
#line 247 "../lib/Items/DockContainer.vala"
			_tmp12_ = element;
#line 247 "../lib/Items/DockContainer.vala"
			plank_dock_container_remove_without_signaling (self, _tmp12_);
#line 240 "../lib/Items/DockContainer.vala"
			_g_object_unref0 (element);
#line 661 "DockContainer.c"
		}
	}
#line 250 "../lib/Items/DockContainer.vala"
	plank_dock_container_update_visible_elements (self);
#line 252 "../lib/Items/DockContainer.vala"
	result = _result_;
#line 252 "../lib/Items/DockContainer.vala"
	return result;
#line 670 "DockContainer.c"
}

/**
 * Clears and therefore removes all dock-elements from the collection.
 *
 * @return whether removing the elements was successful
 */
gboolean
plank_dock_container_clear (PlankDockContainer* self)
{
	GeeHashSet* elements = NULL;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp10_;
	gboolean result;
#line 260 "../lib/Items/DockContainer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 262 "../lib/Items/DockContainer.vala"
	_tmp0_ = gee_hash_set_new (PLANK_TYPE_DOCK_ELEMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 262 "../lib/Items/DockContainer.vala"
	elements = _tmp0_;
#line 263 "../lib/Items/DockContainer.vala"
	_tmp1_ = elements;
#line 263 "../lib/Items/DockContainer.vala"
	_tmp2_ = self->internal_elements;
#line 263 "../lib/Items/DockContainer.vala"
	gee_collection_add_all ((GeeCollection*) _tmp1_, (GeeCollection*) _tmp2_);
#line 699 "DockContainer.c"
	{
		GeeIterator* _element_it = NULL;
		GeeHashSet* _tmp3_;
		GeeIterator* _tmp4_;
#line 264 "../lib/Items/DockContainer.vala"
		_tmp3_ = elements;
#line 264 "../lib/Items/DockContainer.vala"
		_tmp4_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp3_);
#line 264 "../lib/Items/DockContainer.vala"
		_element_it = _tmp4_;
#line 264 "../lib/Items/DockContainer.vala"
		while (TRUE) {
#line 712 "DockContainer.c"
			GeeIterator* _tmp5_;
			PlankDockElement* element = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			PlankDockElement* _tmp8_;
			PlankDockElement* _tmp9_;
#line 264 "../lib/Items/DockContainer.vala"
			_tmp5_ = _element_it;
#line 264 "../lib/Items/DockContainer.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 264 "../lib/Items/DockContainer.vala"
				break;
#line 725 "DockContainer.c"
			}
#line 264 "../lib/Items/DockContainer.vala"
			_tmp6_ = _element_it;
#line 264 "../lib/Items/DockContainer.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 264 "../lib/Items/DockContainer.vala"
			element = (PlankDockElement*) _tmp7_;
#line 265 "../lib/Items/DockContainer.vala"
			_tmp8_ = element;
#line 265 "../lib/Items/DockContainer.vala"
			plank_dock_container_remove_without_signaling (self, _tmp8_);
#line 266 "../lib/Items/DockContainer.vala"
			_tmp9_ = element;
#line 266 "../lib/Items/DockContainer.vala"
			plank_dock_element_set_Container (_tmp9_, NULL);
#line 264 "../lib/Items/DockContainer.vala"
			_g_object_unref0 (element);
#line 743 "DockContainer.c"
		}
#line 264 "../lib/Items/DockContainer.vala"
		_g_object_unref0 (_element_it);
#line 747 "DockContainer.c"
	}
#line 268 "../lib/Items/DockContainer.vala"
	_tmp10_ = self->internal_elements;
#line 268 "../lib/Items/DockContainer.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp10_);
#line 270 "../lib/Items/DockContainer.vala"
	plank_dock_container_update_visible_elements (self);
#line 272 "../lib/Items/DockContainer.vala"
	result = TRUE;
#line 272 "../lib/Items/DockContainer.vala"
	_g_object_unref0 (elements);
#line 272 "../lib/Items/DockContainer.vala"
	return result;
#line 761 "DockContainer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 292 "../lib/Items/DockContainer.vala"
	return self ? g_object_ref (self) : NULL;
#line 769 "DockContainer.c"
}

static void
plank_dock_container_real_update_visible_elements (PlankDockContainer* self)
{
	GeeArrayList* old_items = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* added_items = NULL;
	GeeArrayList* _tmp17_;
	GeeArrayList* _tmp18_;
	GeeArrayList* _tmp19_;
	GeeArrayList* _tmp20_;
	GeeArrayList* _tmp21_;
	GeeArrayList* removed_items = NULL;
	GeeArrayList* _tmp22_;
	GeeArrayList* _tmp23_;
	GeeArrayList* _tmp24_;
	GeeArrayList* _tmp25_;
	GeeArrayList* _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	gboolean _tmp31_ = FALSE;
	GeeArrayList* _tmp32_;
	gint _tmp33_;
	gint _tmp34_;
#line 277 "../lib/Items/DockContainer.vala"
	plank_logger_verbose ("DockContainer.update_visible_elements ()", NULL);
#line 279 "../lib/Items/DockContainer.vala"
	_tmp0_ = gee_array_list_new (PLANK_TYPE_DOCK_ELEMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 279 "../lib/Items/DockContainer.vala"
	old_items = _tmp0_;
#line 280 "../lib/Items/DockContainer.vala"
	_tmp1_ = old_items;
#line 280 "../lib/Items/DockContainer.vala"
	_tmp2_ = self->visible_elements;
#line 280 "../lib/Items/DockContainer.vala"
	gee_array_list_add_all (_tmp1_, (GeeCollection*) _tmp2_);
#line 282 "../lib/Items/DockContainer.vala"
	_tmp3_ = self->visible_elements;
#line 282 "../lib/Items/DockContainer.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp3_);
#line 814 "DockContainer.c"
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp4_;
		gint _item_size = 0;
		GeeArrayList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _item_index = 0;
#line 284 "../lib/Items/DockContainer.vala"
		_tmp4_ = self->internal_elements;
#line 284 "../lib/Items/DockContainer.vala"
		_item_list = _tmp4_;
#line 284 "../lib/Items/DockContainer.vala"
		_tmp5_ = _item_list;
#line 284 "../lib/Items/DockContainer.vala"
		_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 284 "../lib/Items/DockContainer.vala"
		_tmp7_ = _tmp6_;
#line 284 "../lib/Items/DockContainer.vala"
		_item_size = _tmp7_;
#line 284 "../lib/Items/DockContainer.vala"
		_item_index = -1;
#line 284 "../lib/Items/DockContainer.vala"
		while (TRUE) {
#line 839 "DockContainer.c"
			gint _tmp8_;
			gint _tmp9_;
			PlankDockElement* item = NULL;
			GeeArrayList* _tmp10_;
			gpointer _tmp11_;
			PlankDockElement* _tmp12_;
			gboolean _tmp13_;
			gboolean _tmp14_;
#line 284 "../lib/Items/DockContainer.vala"
			_item_index = _item_index + 1;
#line 284 "../lib/Items/DockContainer.vala"
			_tmp8_ = _item_index;
#line 284 "../lib/Items/DockContainer.vala"
			_tmp9_ = _item_size;
#line 284 "../lib/Items/DockContainer.vala"
			if (!(_tmp8_ < _tmp9_)) {
#line 284 "../lib/Items/DockContainer.vala"
				break;
#line 858 "DockContainer.c"
			}
#line 284 "../lib/Items/DockContainer.vala"
			_tmp10_ = _item_list;
#line 284 "../lib/Items/DockContainer.vala"
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _item_index);
#line 284 "../lib/Items/DockContainer.vala"
			item = (PlankDockElement*) _tmp11_;
#line 285 "../lib/Items/DockContainer.vala"
			_tmp12_ = item;
#line 285 "../lib/Items/DockContainer.vala"
			_tmp13_ = plank_dock_element_get_IsAttached (_tmp12_);
#line 285 "../lib/Items/DockContainer.vala"
			_tmp14_ = _tmp13_;
#line 285 "../lib/Items/DockContainer.vala"
			if (_tmp14_) {
#line 874 "DockContainer.c"
				GeeArrayList* _tmp15_;
				PlankDockElement* _tmp16_;
#line 286 "../lib/Items/DockContainer.vala"
				_tmp15_ = self->visible_elements;
#line 286 "../lib/Items/DockContainer.vala"
				_tmp16_ = item;
#line 286 "../lib/Items/DockContainer.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
#line 883 "DockContainer.c"
			}
#line 284 "../lib/Items/DockContainer.vala"
			_g_object_unref0 (item);
#line 887 "DockContainer.c"
		}
	}
#line 288 "../lib/Items/DockContainer.vala"
	_tmp17_ = gee_array_list_new (PLANK_TYPE_DOCK_ELEMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 288 "../lib/Items/DockContainer.vala"
	added_items = _tmp17_;
#line 289 "../lib/Items/DockContainer.vala"
	_tmp18_ = added_items;
#line 289 "../lib/Items/DockContainer.vala"
	_tmp19_ = self->visible_elements;
#line 289 "../lib/Items/DockContainer.vala"
	gee_array_list_add_all (_tmp18_, (GeeCollection*) _tmp19_);
#line 290 "../lib/Items/DockContainer.vala"
	_tmp20_ = added_items;
#line 290 "../lib/Items/DockContainer.vala"
	_tmp21_ = old_items;
#line 290 "../lib/Items/DockContainer.vala"
	gee_collection_remove_all ((GeeCollection*) _tmp20_, (GeeCollection*) _tmp21_);
#line 292 "../lib/Items/DockContainer.vala"
	_tmp22_ = old_items;
#line 292 "../lib/Items/DockContainer.vala"
	_tmp23_ = _g_object_ref0 (_tmp22_);
#line 292 "../lib/Items/DockContainer.vala"
	removed_items = _tmp23_;
#line 293 "../lib/Items/DockContainer.vala"
	_tmp24_ = removed_items;
#line 293 "../lib/Items/DockContainer.vala"
	_tmp25_ = self->visible_elements;
#line 293 "../lib/Items/DockContainer.vala"
	gee_collection_remove_all ((GeeCollection*) _tmp24_, (GeeCollection*) _tmp25_);
#line 295 "../lib/Items/DockContainer.vala"
	_tmp26_ = self->visible_elements;
#line 295 "../lib/Items/DockContainer.vala"
	_tmp27_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp26_);
#line 295 "../lib/Items/DockContainer.vala"
	_tmp28_ = _tmp27_;
#line 295 "../lib/Items/DockContainer.vala"
	if (_tmp28_ <= 0) {
#line 926 "DockContainer.c"
		GeeArrayList* _tmp29_;
		PlankPlaceholderDockItem* _tmp30_;
#line 296 "../lib/Items/DockContainer.vala"
		_tmp29_ = self->visible_elements;
#line 296 "../lib/Items/DockContainer.vala"
		_tmp30_ = plank_dock_container_placeholder_item;
#line 296 "../lib/Items/DockContainer.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp29_, (PlankDockElement*) _tmp30_);
#line 935 "DockContainer.c"
	}
#line 298 "../lib/Items/DockContainer.vala"
	_tmp32_ = added_items;
#line 298 "../lib/Items/DockContainer.vala"
	_tmp33_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp32_);
#line 298 "../lib/Items/DockContainer.vala"
	_tmp34_ = _tmp33_;
#line 298 "../lib/Items/DockContainer.vala"
	if (_tmp34_ > 0) {
#line 298 "../lib/Items/DockContainer.vala"
		_tmp31_ = TRUE;
#line 947 "DockContainer.c"
	} else {
		GeeArrayList* _tmp35_;
		gint _tmp36_;
		gint _tmp37_;
#line 298 "../lib/Items/DockContainer.vala"
		_tmp35_ = removed_items;
#line 298 "../lib/Items/DockContainer.vala"
		_tmp36_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp35_);
#line 298 "../lib/Items/DockContainer.vala"
		_tmp37_ = _tmp36_;
#line 298 "../lib/Items/DockContainer.vala"
		_tmp31_ = _tmp37_ > 0;
#line 960 "DockContainer.c"
	}
#line 298 "../lib/Items/DockContainer.vala"
	if (_tmp31_) {
#line 964 "DockContainer.c"
		GeeArrayList* _tmp38_;
		GeeArrayList* _tmp39_;
#line 299 "../lib/Items/DockContainer.vala"
		_tmp38_ = added_items;
#line 299 "../lib/Items/DockContainer.vala"
		_tmp39_ = removed_items;
#line 299 "../lib/Items/DockContainer.vala"
		g_signal_emit (self, plank_dock_container_signals[PLANK_DOCK_CONTAINER_ELEMENTS_CHANGED_SIGNAL], 0, (GeeList*) _tmp38_, (GeeList*) _tmp39_);
#line 973 "DockContainer.c"
	}
#line 275 "../lib/Items/DockContainer.vala"
	_g_object_unref0 (removed_items);
#line 275 "../lib/Items/DockContainer.vala"
	_g_object_unref0 (added_items);
#line 275 "../lib/Items/DockContainer.vala"
	_g_object_unref0 (old_items);
#line 981 "DockContainer.c"
}

void
plank_dock_container_update_visible_elements (PlankDockContainer* self)
{
	PlankDockContainerClass* _klass_;
#line 275 "../lib/Items/DockContainer.vala"
	g_return_if_fail (self != NULL);
#line 275 "../lib/Items/DockContainer.vala"
	_klass_ = PLANK_DOCK_CONTAINER_GET_CLASS (self);
#line 275 "../lib/Items/DockContainer.vala"
	if (_klass_->update_visible_elements) {
#line 275 "../lib/Items/DockContainer.vala"
		_klass_->update_visible_elements (self);
#line 996 "DockContainer.c"
	}
}

/**
 * Move an element to the position of another element.
 * This shifts all elements which are placed between these two elements.
 *
 * @param move the element to move
 * @param target the element of the new position
 * @return whether moving the element was successful
 */
static gboolean
plank_dock_container_real_move_to (PlankDockContainer* self,
                                   PlankDockElement* move,
                                   PlankDockElement* target)
{
	gint index_move = 0;
	gint index_target = 0;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp6_;
	gboolean _tmp7_ = FALSE;
	GeeArrayList* _tmp8_;
	gboolean result;
#line 310 "../lib/Items/DockContainer.vala"
	g_return_val_if_fail (move != NULL, FALSE);
#line 310 "../lib/Items/DockContainer.vala"
	g_return_val_if_fail (target != NULL, FALSE);
#line 312 "../lib/Items/DockContainer.vala"
	if (move == target) {
#line 313 "../lib/Items/DockContainer.vala"
		result = TRUE;
#line 313 "../lib/Items/DockContainer.vala"
		return result;
#line 1031 "DockContainer.c"
	}
#line 317 "../lib/Items/DockContainer.vala"
	_tmp0_ = self->internal_elements;
#line 317 "../lib/Items/DockContainer.vala"
	index_move = gee_abstract_list_index_of ((GeeAbstractList*) _tmp0_, move);
#line 317 "../lib/Items/DockContainer.vala"
	if (index_move < 0) {
#line 1039 "DockContainer.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 318 "../lib/Items/DockContainer.vala"
		_tmp1_ = plank_dock_element_get_Text (move);
#line 318 "../lib/Items/DockContainer.vala"
		_tmp2_ = _tmp1_;
#line 318 "../lib/Items/DockContainer.vala"
		g_critical ("DockContainer.vala:318: Element '%s' does not exist in this DockContai" \
"ner.", _tmp2_);
#line 319 "../lib/Items/DockContainer.vala"
		result = FALSE;
#line 319 "../lib/Items/DockContainer.vala"
		return result;
#line 1052 "DockContainer.c"
	}
#line 322 "../lib/Items/DockContainer.vala"
	_tmp3_ = self->internal_elements;
#line 322 "../lib/Items/DockContainer.vala"
	index_target = gee_abstract_list_index_of ((GeeAbstractList*) _tmp3_, target);
#line 322 "../lib/Items/DockContainer.vala"
	if (index_target < 0) {
#line 1060 "DockContainer.c"
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 323 "../lib/Items/DockContainer.vala"
		_tmp4_ = plank_dock_element_get_Text (target);
#line 323 "../lib/Items/DockContainer.vala"
		_tmp5_ = _tmp4_;
#line 323 "../lib/Items/DockContainer.vala"
		g_critical ("DockContainer.vala:323: Element '%s' does not exist in this DockContai" \
"ner.", _tmp5_);
#line 324 "../lib/Items/DockContainer.vala"
		result = FALSE;
#line 324 "../lib/Items/DockContainer.vala"
		return result;
#line 1073 "DockContainer.c"
	}
#line 327 "../lib/Items/DockContainer.vala"
	_tmp6_ = self->internal_elements;
#line 327 "../lib/Items/DockContainer.vala"
	plank_dock_container_move_element ((GeeList*) _tmp6_, index_move, index_target, NULL);
#line 329 "../lib/Items/DockContainer.vala"
	_tmp8_ = self->visible_elements;
#line 329 "../lib/Items/DockContainer.vala"
	index_move = gee_abstract_list_index_of ((GeeAbstractList*) _tmp8_, move);
#line 329 "../lib/Items/DockContainer.vala"
	if (index_move >= 0) {
#line 1085 "DockContainer.c"
		GeeArrayList* _tmp9_;
#line 330 "../lib/Items/DockContainer.vala"
		_tmp9_ = self->visible_elements;
#line 330 "../lib/Items/DockContainer.vala"
		index_target = gee_abstract_list_index_of ((GeeAbstractList*) _tmp9_, target);
#line 330 "../lib/Items/DockContainer.vala"
		_tmp7_ = index_target >= 0;
#line 1093 "DockContainer.c"
	} else {
#line 329 "../lib/Items/DockContainer.vala"
		_tmp7_ = FALSE;
#line 1097 "DockContainer.c"
	}
#line 329 "../lib/Items/DockContainer.vala"
	if (_tmp7_) {
#line 1101 "DockContainer.c"
		GeeArrayList* moved_items = NULL;
		GeeArrayList* _tmp10_;
		GeeArrayList* _tmp11_;
		GeeArrayList* _tmp12_;
		GeeArrayList* _tmp13_;
#line 331 "../lib/Items/DockContainer.vala"
		_tmp10_ = gee_array_list_new (PLANK_TYPE_DOCK_ELEMENT, NULL, NULL, NULL, NULL, NULL);
#line 331 "../lib/Items/DockContainer.vala"
		moved_items = _tmp10_;
#line 332 "../lib/Items/DockContainer.vala"
		_tmp11_ = self->visible_elements;
#line 332 "../lib/Items/DockContainer.vala"
		_tmp12_ = moved_items;
#line 332 "../lib/Items/DockContainer.vala"
		plank_dock_container_move_element ((GeeList*) _tmp11_, index_move, index_target, (GeeList*) _tmp12_);
#line 333 "../lib/Items/DockContainer.vala"
		_tmp13_ = moved_items;
#line 333 "../lib/Items/DockContainer.vala"
		g_signal_emit (self, plank_dock_container_signals[PLANK_DOCK_CONTAINER_POSITIONS_CHANGED_SIGNAL], 0, (GeeList*) _tmp13_);
#line 329 "../lib/Items/DockContainer.vala"
		_g_object_unref0 (moved_items);
#line 1123 "DockContainer.c"
	} else {
#line 335 "../lib/Items/DockContainer.vala"
		plank_dock_container_update_visible_elements (self);
#line 1127 "DockContainer.c"
	}
#line 338 "../lib/Items/DockContainer.vala"
	result = TRUE;
#line 338 "../lib/Items/DockContainer.vala"
	return result;
#line 1133 "DockContainer.c"
}

gboolean
plank_dock_container_move_to (PlankDockContainer* self,
                              PlankDockElement* move,
                              PlankDockElement* target)
{
	PlankDockContainerClass* _klass_;
#line 310 "../lib/Items/DockContainer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 310 "../lib/Items/DockContainer.vala"
	_klass_ = PLANK_DOCK_CONTAINER_GET_CLASS (self);
#line 310 "../lib/Items/DockContainer.vala"
	if (_klass_->move_to) {
#line 310 "../lib/Items/DockContainer.vala"
		return _klass_->move_to (self, move, target);
#line 1150 "DockContainer.c"
	}
#line 310 "../lib/Items/DockContainer.vala"
	return FALSE;
#line 1154 "DockContainer.c"
}

/**
 * Reset internal buffers of all elements.
 */
static void
plank_dock_container_real_reset_buffers (PlankDockElement* base)
{
	PlankDockContainer * self;
#line 344 "../lib/Items/DockContainer.vala"
	self = (PlankDockContainer*) base;
#line 1166 "DockContainer.c"
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp0_;
		gint _item_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _item_index = 0;
#line 346 "../lib/Items/DockContainer.vala"
		_tmp0_ = self->internal_elements;
#line 346 "../lib/Items/DockContainer.vala"
		_item_list = _tmp0_;
#line 346 "../lib/Items/DockContainer.vala"
		_tmp1_ = _item_list;
#line 346 "../lib/Items/DockContainer.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 346 "../lib/Items/DockContainer.vala"
		_tmp3_ = _tmp2_;
#line 346 "../lib/Items/DockContainer.vala"
		_item_size = _tmp3_;
#line 346 "../lib/Items/DockContainer.vala"
		_item_index = -1;
#line 346 "../lib/Items/DockContainer.vala"
		while (TRUE) {
#line 1191 "DockContainer.c"
			gint _tmp4_;
			gint _tmp5_;
			PlankDockElement* item = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			PlankDockElement* _tmp8_;
#line 346 "../lib/Items/DockContainer.vala"
			_item_index = _item_index + 1;
#line 346 "../lib/Items/DockContainer.vala"
			_tmp4_ = _item_index;
#line 346 "../lib/Items/DockContainer.vala"
			_tmp5_ = _item_size;
#line 346 "../lib/Items/DockContainer.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 346 "../lib/Items/DockContainer.vala"
				break;
#line 1208 "DockContainer.c"
			}
#line 346 "../lib/Items/DockContainer.vala"
			_tmp6_ = _item_list;
#line 346 "../lib/Items/DockContainer.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _item_index);
#line 346 "../lib/Items/DockContainer.vala"
			item = (PlankDockElement*) _tmp7_;
#line 347 "../lib/Items/DockContainer.vala"
			_tmp8_ = item;
#line 347 "../lib/Items/DockContainer.vala"
			plank_dock_element_reset_buffers (_tmp8_);
#line 346 "../lib/Items/DockContainer.vala"
			_g_object_unref0 (item);
#line 1222 "DockContainer.c"
		}
	}
}

static void
plank_dock_container_add_without_signaling (PlankDockContainer* self,
                                            PlankDockElement* element)
{
	gint64 add_time = 0LL;
	PlankDockContainer* container = NULL;
	PlankDockContainer* _tmp0_;
	GeeArrayList* _tmp13_;
#line 350 "../lib/Items/DockContainer.vala"
	g_return_if_fail (self != NULL);
#line 350 "../lib/Items/DockContainer.vala"
	g_return_if_fail (element != NULL);
#line 352 "../lib/Items/DockContainer.vala"
	add_time = g_get_monotonic_time ();
#line 354 "../lib/Items/DockContainer.vala"
	container = PLANK_IS_DOCK_CONTAINER (element) ? ((PlankDockContainer*) element) : NULL;
#line 355 "../lib/Items/DockContainer.vala"
	_tmp0_ = container;
#line 355 "../lib/Items/DockContainer.vala"
	if (_tmp0_ != NULL) {
#line 1247 "DockContainer.c"
		PlankDockContainer* _tmp1_;
#line 356 "../lib/Items/DockContainer.vala"
		_tmp1_ = container;
#line 356 "../lib/Items/DockContainer.vala"
		plank_dock_container_prepare (_tmp1_);
#line 1253 "DockContainer.c"
		{
			GeeArrayList* _e_list = NULL;
			PlankDockContainer* _tmp2_;
			GeeArrayList* _tmp3_;
			GeeArrayList* _tmp4_;
			gint _e_size = 0;
			GeeArrayList* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _e_index = 0;
#line 357 "../lib/Items/DockContainer.vala"
			_tmp2_ = container;
#line 357 "../lib/Items/DockContainer.vala"
			_tmp3_ = plank_dock_container_get_Elements (_tmp2_);
#line 357 "../lib/Items/DockContainer.vala"
			_tmp4_ = _tmp3_;
#line 357 "../lib/Items/DockContainer.vala"
			_e_list = _tmp4_;
#line 357 "../lib/Items/DockContainer.vala"
			_tmp5_ = _e_list;
#line 357 "../lib/Items/DockContainer.vala"
			_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 357 "../lib/Items/DockContainer.vala"
			_tmp7_ = _tmp6_;
#line 357 "../lib/Items/DockContainer.vala"
			_e_size = _tmp7_;
#line 357 "../lib/Items/DockContainer.vala"
			_e_index = -1;
#line 357 "../lib/Items/DockContainer.vala"
			while (TRUE) {
#line 1284 "DockContainer.c"
				gint _tmp8_;
				gint _tmp9_;
				PlankDockElement* e = NULL;
				GeeArrayList* _tmp10_;
				gpointer _tmp11_;
				PlankDockElement* _tmp12_;
#line 357 "../lib/Items/DockContainer.vala"
				_e_index = _e_index + 1;
#line 357 "../lib/Items/DockContainer.vala"
				_tmp8_ = _e_index;
#line 357 "../lib/Items/DockContainer.vala"
				_tmp9_ = _e_size;
#line 357 "../lib/Items/DockContainer.vala"
				if (!(_tmp8_ < _tmp9_)) {
#line 357 "../lib/Items/DockContainer.vala"
					break;
#line 1301 "DockContainer.c"
				}
#line 357 "../lib/Items/DockContainer.vala"
				_tmp10_ = _e_list;
#line 357 "../lib/Items/DockContainer.vala"
				_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _e_index);
#line 357 "../lib/Items/DockContainer.vala"
				e = (PlankDockElement*) _tmp11_;
#line 358 "../lib/Items/DockContainer.vala"
				_tmp12_ = e;
#line 358 "../lib/Items/DockContainer.vala"
				plank_dock_element_set_AddTime (_tmp12_, add_time);
#line 357 "../lib/Items/DockContainer.vala"
				_g_object_unref0 (e);
#line 1315 "DockContainer.c"
			}
		}
	}
#line 361 "../lib/Items/DockContainer.vala"
	_tmp13_ = self->internal_elements;
#line 361 "../lib/Items/DockContainer.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, element);
#line 363 "../lib/Items/DockContainer.vala"
	plank_dock_element_set_Container (element, self);
#line 364 "../lib/Items/DockContainer.vala"
	plank_dock_element_set_AddTime (element, add_time);
#line 365 "../lib/Items/DockContainer.vala"
	plank_dock_element_set_RemoveTime (element, (gint64) 0);
#line 366 "../lib/Items/DockContainer.vala"
	plank_dock_container_connect_element (self, element);
#line 1331 "DockContainer.c"
}

/**
 * Replace an element with another element.
 *
 * @param new_element the new element
 * @param old_element the element to be replaced
 * @return whether replacing the element was successful
 */
static gboolean
plank_dock_container_real_replace (PlankDockContainer* self,
                                   PlankDockElement* new_element,
                                   PlankDockElement* old_element)
{
	gint index = 0;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp3_;
	PlankDockContainer* _tmp6_;
	PlankDockContainer* _tmp7_;
	GeeArrayList* _tmp10_;
	gint64 _tmp11_;
	gint64 _tmp12_;
	gint64 _tmp13_;
	gint64 _tmp14_;
	GeeArrayList* _tmp15_;
	gboolean result;
#line 376 "../lib/Items/DockContainer.vala"
	g_return_val_if_fail (new_element != NULL, FALSE);
#line 376 "../lib/Items/DockContainer.vala"
	g_return_val_if_fail (old_element != NULL, FALSE);
#line 378 "../lib/Items/DockContainer.vala"
	if (new_element == old_element) {
#line 379 "../lib/Items/DockContainer.vala"
		result = TRUE;
#line 379 "../lib/Items/DockContainer.vala"
		return result;
#line 1368 "DockContainer.c"
	}
#line 383 "../lib/Items/DockContainer.vala"
	_tmp0_ = self->internal_elements;
#line 383 "../lib/Items/DockContainer.vala"
	index = gee_abstract_list_index_of ((GeeAbstractList*) _tmp0_, old_element);
#line 383 "../lib/Items/DockContainer.vala"
	if (index < 0) {
#line 1376 "DockContainer.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 384 "../lib/Items/DockContainer.vala"
		_tmp1_ = plank_dock_element_get_Text (old_element);
#line 384 "../lib/Items/DockContainer.vala"
		_tmp2_ = _tmp1_;
#line 384 "../lib/Items/DockContainer.vala"
		g_critical ("DockContainer.vala:384: Element '%s' does not exist in this DockContai" \
"ner.", _tmp2_);
#line 385 "../lib/Items/DockContainer.vala"
		result = FALSE;
#line 385 "../lib/Items/DockContainer.vala"
		return result;
#line 1389 "DockContainer.c"
	}
#line 388 "../lib/Items/DockContainer.vala"
	_tmp3_ = self->internal_elements;
#line 388 "../lib/Items/DockContainer.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp3_, new_element)) {
#line 1395 "DockContainer.c"
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 389 "../lib/Items/DockContainer.vala"
		_tmp4_ = plank_dock_element_get_Text (new_element);
#line 389 "../lib/Items/DockContainer.vala"
		_tmp5_ = _tmp4_;
#line 389 "../lib/Items/DockContainer.vala"
		g_critical ("DockContainer.vala:389: Element '%s' already exists in this DockContai" \
"ner.", _tmp5_);
#line 390 "../lib/Items/DockContainer.vala"
		result = FALSE;
#line 390 "../lib/Items/DockContainer.vala"
		return result;
#line 1408 "DockContainer.c"
	}
#line 393 "../lib/Items/DockContainer.vala"
	_tmp6_ = plank_dock_element_get_Container (new_element);
#line 393 "../lib/Items/DockContainer.vala"
	_tmp7_ = _tmp6_;
#line 393 "../lib/Items/DockContainer.vala"
	if (_tmp7_ != NULL) {
#line 1416 "DockContainer.c"
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 394 "../lib/Items/DockContainer.vala"
		_tmp8_ = plank_dock_element_get_Text (new_element);
#line 394 "../lib/Items/DockContainer.vala"
		_tmp9_ = _tmp8_;
#line 394 "../lib/Items/DockContainer.vala"
		g_critical ("DockContainer.vala:394: Element '%s' should be removed from its old Do" \
"ckContainer first.", _tmp9_);
#line 395 "../lib/Items/DockContainer.vala"
		result = FALSE;
#line 395 "../lib/Items/DockContainer.vala"
		return result;
#line 1429 "DockContainer.c"
	}
#line 400 "../lib/Items/DockContainer.vala"
	plank_dock_container_disconnect_element (self, old_element);
#line 402 "../lib/Items/DockContainer.vala"
	_tmp10_ = self->internal_elements;
#line 402 "../lib/Items/DockContainer.vala"
	gee_abstract_list_set ((GeeAbstractList*) _tmp10_, index, new_element);
#line 403 "../lib/Items/DockContainer.vala"
	plank_dock_element_set_Container (old_element, NULL);
#line 404 "../lib/Items/DockContainer.vala"
	plank_dock_element_set_Container (new_element, self);
#line 406 "../lib/Items/DockContainer.vala"
	_tmp11_ = plank_dock_element_get_AddTime (old_element);
#line 406 "../lib/Items/DockContainer.vala"
	_tmp12_ = _tmp11_;
#line 406 "../lib/Items/DockContainer.vala"
	plank_dock_element_set_AddTime (new_element, _tmp12_);
#line 407 "../lib/Items/DockContainer.vala"
	_tmp13_ = plank_dock_element_get_RemoveTime (old_element);
#line 407 "../lib/Items/DockContainer.vala"
	_tmp14_ = _tmp13_;
#line 407 "../lib/Items/DockContainer.vala"
	plank_dock_element_set_RemoveTime (new_element, _tmp14_);
#line 409 "../lib/Items/DockContainer.vala"
	plank_dock_container_connect_element (self, new_element);
#line 411 "../lib/Items/DockContainer.vala"
	_tmp15_ = self->visible_elements;
#line 411 "../lib/Items/DockContainer.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp15_, old_element)) {
#line 412 "../lib/Items/DockContainer.vala"
		plank_dock_container_update_visible_elements (self);
#line 1461 "DockContainer.c"
	}
#line 414 "../lib/Items/DockContainer.vala"
	result = TRUE;
#line 414 "../lib/Items/DockContainer.vala"
	return result;
#line 1467 "DockContainer.c"
}

gboolean
plank_dock_container_replace (PlankDockContainer* self,
                              PlankDockElement* new_element,
                              PlankDockElement* old_element)
{
	PlankDockContainerClass* _klass_;
#line 376 "../lib/Items/DockContainer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 376 "../lib/Items/DockContainer.vala"
	_klass_ = PLANK_DOCK_CONTAINER_GET_CLASS (self);
#line 376 "../lib/Items/DockContainer.vala"
	if (_klass_->replace) {
#line 376 "../lib/Items/DockContainer.vala"
		return _klass_->replace (self, new_element, old_element);
#line 1484 "DockContainer.c"
	}
#line 376 "../lib/Items/DockContainer.vala"
	return FALSE;
#line 1488 "DockContainer.c"
}

static void
plank_dock_container_remove_without_signaling (PlankDockContainer* self,
                                               PlankDockElement* element)
{
	gint64 remove_time = 0LL;
	PlankDockContainer* container = NULL;
	PlankDockContainer* _tmp0_;
	GeeArrayList* _tmp12_;
#line 417 "../lib/Items/DockContainer.vala"
	g_return_if_fail (self != NULL);
#line 417 "../lib/Items/DockContainer.vala"
	g_return_if_fail (element != NULL);
#line 419 "../lib/Items/DockContainer.vala"
	remove_time = g_get_monotonic_time ();
#line 421 "../lib/Items/DockContainer.vala"
	container = PLANK_IS_DOCK_CONTAINER (element) ? ((PlankDockContainer*) element) : NULL;
#line 422 "../lib/Items/DockContainer.vala"
	_tmp0_ = container;
#line 422 "../lib/Items/DockContainer.vala"
	if (_tmp0_ != NULL) {
#line 1511 "DockContainer.c"
		{
			GeeArrayList* _e_list = NULL;
			PlankDockContainer* _tmp1_;
			GeeArrayList* _tmp2_;
			GeeArrayList* _tmp3_;
			gint _e_size = 0;
			GeeArrayList* _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			gint _e_index = 0;
#line 423 "../lib/Items/DockContainer.vala"
			_tmp1_ = container;
#line 423 "../lib/Items/DockContainer.vala"
			_tmp2_ = plank_dock_container_get_Elements (_tmp1_);
#line 423 "../lib/Items/DockContainer.vala"
			_tmp3_ = _tmp2_;
#line 423 "../lib/Items/DockContainer.vala"
			_e_list = _tmp3_;
#line 423 "../lib/Items/DockContainer.vala"
			_tmp4_ = _e_list;
#line 423 "../lib/Items/DockContainer.vala"
			_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 423 "../lib/Items/DockContainer.vala"
			_tmp6_ = _tmp5_;
#line 423 "../lib/Items/DockContainer.vala"
			_e_size = _tmp6_;
#line 423 "../lib/Items/DockContainer.vala"
			_e_index = -1;
#line 423 "../lib/Items/DockContainer.vala"
			while (TRUE) {
#line 1542 "DockContainer.c"
				gint _tmp7_;
				gint _tmp8_;
				PlankDockElement* e = NULL;
				GeeArrayList* _tmp9_;
				gpointer _tmp10_;
				PlankDockElement* _tmp11_;
#line 423 "../lib/Items/DockContainer.vala"
				_e_index = _e_index + 1;
#line 423 "../lib/Items/DockContainer.vala"
				_tmp7_ = _e_index;
#line 423 "../lib/Items/DockContainer.vala"
				_tmp8_ = _e_size;
#line 423 "../lib/Items/DockContainer.vala"
				if (!(_tmp7_ < _tmp8_)) {
#line 423 "../lib/Items/DockContainer.vala"
					break;
#line 1559 "DockContainer.c"
				}
#line 423 "../lib/Items/DockContainer.vala"
				_tmp9_ = _e_list;
#line 423 "../lib/Items/DockContainer.vala"
				_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _e_index);
#line 423 "../lib/Items/DockContainer.vala"
				e = (PlankDockElement*) _tmp10_;
#line 424 "../lib/Items/DockContainer.vala"
				_tmp11_ = e;
#line 424 "../lib/Items/DockContainer.vala"
				plank_dock_element_set_RemoveTime (_tmp11_, remove_time);
#line 423 "../lib/Items/DockContainer.vala"
				_g_object_unref0 (e);
#line 1573 "DockContainer.c"
			}
		}
	}
#line 426 "../lib/Items/DockContainer.vala"
	plank_dock_element_set_RemoveTime (element, remove_time);
#line 427 "../lib/Items/DockContainer.vala"
	plank_dock_container_disconnect_element (self, element);
#line 429 "../lib/Items/DockContainer.vala"
	_tmp12_ = self->internal_elements;
#line 429 "../lib/Items/DockContainer.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp12_, element);
#line 430 "../lib/Items/DockContainer.vala"
	plank_dock_element_set_Container (element, NULL);
#line 1587 "DockContainer.c"
}

static void
plank_dock_container_real_connect_element (PlankDockContainer* self,
                                           PlankDockElement* element)
{
#line 433 "../lib/Items/DockContainer.vala"
	g_critical ("Type `%s' does not implement abstract method `plank_dock_container_connect_element'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 433 "../lib/Items/DockContainer.vala"
	return;
#line 1598 "DockContainer.c"
}

void
plank_dock_container_connect_element (PlankDockContainer* self,
                                      PlankDockElement* element)
{
	PlankDockContainerClass* _klass_;
#line 433 "../lib/Items/DockContainer.vala"
	g_return_if_fail (self != NULL);
#line 433 "../lib/Items/DockContainer.vala"
	_klass_ = PLANK_DOCK_CONTAINER_GET_CLASS (self);
#line 433 "../lib/Items/DockContainer.vala"
	if (_klass_->connect_element) {
#line 433 "../lib/Items/DockContainer.vala"
		_klass_->connect_element (self, element);
#line 1614 "DockContainer.c"
	}
}

static void
plank_dock_container_real_disconnect_element (PlankDockContainer* self,
                                              PlankDockElement* element)
{
#line 435 "../lib/Items/DockContainer.vala"
	g_critical ("Type `%s' does not implement abstract method `plank_dock_container_disconnect_element'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 435 "../lib/Items/DockContainer.vala"
	return;
#line 1626 "DockContainer.c"
}

void
plank_dock_container_disconnect_element (PlankDockContainer* self,
                                         PlankDockElement* element)
{
	PlankDockContainerClass* _klass_;
#line 435 "../lib/Items/DockContainer.vala"
	g_return_if_fail (self != NULL);
#line 435 "../lib/Items/DockContainer.vala"
	_klass_ = PLANK_DOCK_CONTAINER_GET_CLASS (self);
#line 435 "../lib/Items/DockContainer.vala"
	if (_klass_->disconnect_element) {
#line 435 "../lib/Items/DockContainer.vala"
		_klass_->disconnect_element (self, element);
#line 1642 "DockContainer.c"
	}
}

void
plank_dock_container_move_element (GeeList* elements,
                                   gint from,
                                   gint to,
                                   GeeList* moved)
{
	gint size = 0;
	gint _tmp0_;
	gint _tmp1_;
	PlankDockElement* item = NULL;
	gpointer _tmp2_;
	PlankDockElement* _tmp17_;
#line 437 "../lib/Items/DockContainer.vala"
	g_return_if_fail (elements != NULL);
#line 439 "../lib/Items/DockContainer.vala"
	_vala_assert (from >= 0, "from >= 0");
#line 440 "../lib/Items/DockContainer.vala"
	_vala_assert (to >= 0, "to >= 0");
#line 441 "../lib/Items/DockContainer.vala"
	_vala_assert (from != to, "from != to");
#line 442 "../lib/Items/DockContainer.vala"
	_tmp0_ = gee_collection_get_size ((GeeCollection*) elements);
#line 442 "../lib/Items/DockContainer.vala"
	_tmp1_ = _tmp0_;
#line 442 "../lib/Items/DockContainer.vala"
	size = _tmp1_;
#line 443 "../lib/Items/DockContainer.vala"
	_vala_assert (from < size, "from < size");
#line 444 "../lib/Items/DockContainer.vala"
	_vala_assert (to < size, "to < size");
#line 446 "../lib/Items/DockContainer.vala"
	_tmp2_ = gee_list_get (elements, from);
#line 446 "../lib/Items/DockContainer.vala"
	item = (PlankDockElement*) _tmp2_;
#line 447 "../lib/Items/DockContainer.vala"
	if (from < to) {
#line 1682 "DockContainer.c"
		{
			gint i = 0;
#line 448 "../lib/Items/DockContainer.vala"
			i = from;
#line 1687 "DockContainer.c"
			{
				gboolean _tmp3_ = FALSE;
#line 448 "../lib/Items/DockContainer.vala"
				_tmp3_ = TRUE;
#line 448 "../lib/Items/DockContainer.vala"
				while (TRUE) {
#line 1694 "DockContainer.c"
					gpointer _tmp5_;
					PlankDockElement* _tmp6_;
#line 448 "../lib/Items/DockContainer.vala"
					if (!_tmp3_) {
#line 1699 "DockContainer.c"
						gint _tmp4_;
#line 448 "../lib/Items/DockContainer.vala"
						_tmp4_ = i;
#line 448 "../lib/Items/DockContainer.vala"
						i = _tmp4_ + 1;
#line 1705 "DockContainer.c"
					}
#line 448 "../lib/Items/DockContainer.vala"
					_tmp3_ = FALSE;
#line 448 "../lib/Items/DockContainer.vala"
					if (!(i < to)) {
#line 448 "../lib/Items/DockContainer.vala"
						break;
#line 1713 "DockContainer.c"
					}
#line 449 "../lib/Items/DockContainer.vala"
					_tmp5_ = gee_list_get (elements, i + 1);
#line 449 "../lib/Items/DockContainer.vala"
					_tmp6_ = (PlankDockElement*) _tmp5_;
#line 449 "../lib/Items/DockContainer.vala"
					gee_list_set (elements, i, _tmp6_);
#line 449 "../lib/Items/DockContainer.vala"
					_g_object_unref0 (_tmp6_);
#line 450 "../lib/Items/DockContainer.vala"
					if (moved != NULL) {
#line 1725 "DockContainer.c"
						gpointer _tmp7_;
						PlankDockElement* _tmp8_;
#line 451 "../lib/Items/DockContainer.vala"
						_tmp7_ = gee_list_get (elements, i);
#line 451 "../lib/Items/DockContainer.vala"
						_tmp8_ = (PlankDockElement*) _tmp7_;
#line 451 "../lib/Items/DockContainer.vala"
						gee_collection_add ((GeeCollection*) moved, _tmp8_);
#line 451 "../lib/Items/DockContainer.vala"
						_g_object_unref0 (_tmp8_);
#line 1736 "DockContainer.c"
					}
				}
			}
		}
#line 453 "../lib/Items/DockContainer.vala"
		if (moved != NULL) {
#line 1743 "DockContainer.c"
			PlankDockElement* _tmp9_;
#line 454 "../lib/Items/DockContainer.vala"
			_tmp9_ = item;
#line 454 "../lib/Items/DockContainer.vala"
			gee_collection_add ((GeeCollection*) moved, _tmp9_);
#line 1749 "DockContainer.c"
		}
	} else {
#line 456 "../lib/Items/DockContainer.vala"
		if (moved != NULL) {
#line 1754 "DockContainer.c"
			PlankDockElement* _tmp10_;
#line 457 "../lib/Items/DockContainer.vala"
			_tmp10_ = item;
#line 457 "../lib/Items/DockContainer.vala"
			gee_collection_add ((GeeCollection*) moved, _tmp10_);
#line 1760 "DockContainer.c"
		}
		{
			gint i = 0;
#line 458 "../lib/Items/DockContainer.vala"
			i = from;
#line 1766 "DockContainer.c"
			{
				gboolean _tmp11_ = FALSE;
#line 458 "../lib/Items/DockContainer.vala"
				_tmp11_ = TRUE;
#line 458 "../lib/Items/DockContainer.vala"
				while (TRUE) {
#line 1773 "DockContainer.c"
					gpointer _tmp13_;
					PlankDockElement* _tmp14_;
#line 458 "../lib/Items/DockContainer.vala"
					if (!_tmp11_) {
#line 1778 "DockContainer.c"
						gint _tmp12_;
#line 458 "../lib/Items/DockContainer.vala"
						_tmp12_ = i;
#line 458 "../lib/Items/DockContainer.vala"
						i = _tmp12_ - 1;
#line 1784 "DockContainer.c"
					}
#line 458 "../lib/Items/DockContainer.vala"
					_tmp11_ = FALSE;
#line 458 "../lib/Items/DockContainer.vala"
					if (!(i > to)) {
#line 458 "../lib/Items/DockContainer.vala"
						break;
#line 1792 "DockContainer.c"
					}
#line 459 "../lib/Items/DockContainer.vala"
					_tmp13_ = gee_list_get (elements, i - 1);
#line 459 "../lib/Items/DockContainer.vala"
					_tmp14_ = (PlankDockElement*) _tmp13_;
#line 459 "../lib/Items/DockContainer.vala"
					gee_list_set (elements, i, _tmp14_);
#line 459 "../lib/Items/DockContainer.vala"
					_g_object_unref0 (_tmp14_);
#line 460 "../lib/Items/DockContainer.vala"
					if (moved != NULL) {
#line 1804 "DockContainer.c"
						gpointer _tmp15_;
						PlankDockElement* _tmp16_;
#line 461 "../lib/Items/DockContainer.vala"
						_tmp15_ = gee_list_get (elements, i);
#line 461 "../lib/Items/DockContainer.vala"
						_tmp16_ = (PlankDockElement*) _tmp15_;
#line 461 "../lib/Items/DockContainer.vala"
						gee_collection_add ((GeeCollection*) moved, _tmp16_);
#line 461 "../lib/Items/DockContainer.vala"
						_g_object_unref0 (_tmp16_);
#line 1815 "DockContainer.c"
					}
				}
			}
		}
	}
#line 464 "../lib/Items/DockContainer.vala"
	_tmp17_ = item;
#line 464 "../lib/Items/DockContainer.vala"
	gee_list_set (elements, to, _tmp17_);
#line 437 "../lib/Items/DockContainer.vala"
	_g_object_unref0 (item);
#line 1827 "DockContainer.c"
}

GeeArrayList*
plank_dock_container_get_VisibleElements (PlankDockContainer* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 59 "../lib/Items/DockContainer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "../lib/Items/DockContainer.vala"
	_tmp0_ = self->visible_elements;
#line 60 "../lib/Items/DockContainer.vala"
	result = _tmp0_;
#line 60 "../lib/Items/DockContainer.vala"
	return result;
#line 1843 "DockContainer.c"
}

GeeArrayList*
plank_dock_container_get_Elements (PlankDockContainer* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 68 "../lib/Items/DockContainer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 69 "../lib/Items/DockContainer.vala"
	_tmp0_ = self->internal_elements;
#line 69 "../lib/Items/DockContainer.vala"
	result = _tmp0_;
#line 69 "../lib/Items/DockContainer.vala"
	return result;
#line 1859 "DockContainer.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 26 "../lib/Items/DockContainer.vala"
	g_return_if_fail (n_param_values == 3);
#line 26 "../lib/Items/DockContainer.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 26 "../lib/Items/DockContainer.vala"
		data1 = closure->data;
#line 26 "../lib/Items/DockContainer.vala"
		data2 = param_values->data[0].v_pointer;
#line 1884 "DockContainer.c"
	} else {
#line 26 "../lib/Items/DockContainer.vala"
		data1 = param_values->data[0].v_pointer;
#line 26 "../lib/Items/DockContainer.vala"
		data2 = closure->data;
#line 1890 "DockContainer.c"
	}
#line 26 "../lib/Items/DockContainer.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 26 "../lib/Items/DockContainer.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 1896 "DockContainer.c"
}

static GObject *
plank_dock_container_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankDockContainer * self;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	PlankPlaceholderDockItem* _tmp2_;
#line 84 "../lib/Items/DockContainer.vala"
	parent_class = G_OBJECT_CLASS (plank_dock_container_parent_class);
#line 84 "../lib/Items/DockContainer.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 84 "../lib/Items/DockContainer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DOCK_CONTAINER, PlankDockContainer);
#line 86 "../lib/Items/DockContainer.vala"
	_tmp0_ = gee_array_list_new (PLANK_TYPE_DOCK_ELEMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 86 "../lib/Items/DockContainer.vala"
	_g_object_unref0 (self->visible_elements);
#line 86 "../lib/Items/DockContainer.vala"
	self->visible_elements = _tmp0_;
#line 87 "../lib/Items/DockContainer.vala"
	_tmp1_ = gee_array_list_new (PLANK_TYPE_DOCK_ELEMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 87 "../lib/Items/DockContainer.vala"
	_g_object_unref0 (self->internal_elements);
#line 87 "../lib/Items/DockContainer.vala"
	self->internal_elements = _tmp1_;
#line 89 "../lib/Items/DockContainer.vala"
	_tmp2_ = plank_dock_container_placeholder_item;
#line 89 "../lib/Items/DockContainer.vala"
	plank_dock_container_connect_element (self, (PlankDockElement*) _tmp2_);
#line 84 "../lib/Items/DockContainer.vala"
	return obj;
#line 1934 "DockContainer.c"
}

static void
plank_dock_container_class_init (PlankDockContainerClass * klass,
                                 gpointer klass_data)
{
	PlankPlaceholderDockItem* _tmp0_;
#line 26 "../lib/Items/DockContainer.vala"
	plank_dock_container_parent_class = g_type_class_peek_parent (klass);
#line 26 "../lib/Items/DockContainer.vala"
	((PlankDockContainerClass *) klass)->prepare = (void (*) (PlankDockContainer*)) plank_dock_container_real_prepare;
#line 26 "../lib/Items/DockContainer.vala"
	((PlankDockContainerClass *) klass)->update_visible_elements = (void (*) (PlankDockContainer*)) plank_dock_container_real_update_visible_elements;
#line 26 "../lib/Items/DockContainer.vala"
	((PlankDockContainerClass *) klass)->move_to = (gboolean (*) (PlankDockContainer*, PlankDockElement*, PlankDockElement*)) plank_dock_container_real_move_to;
#line 26 "../lib/Items/DockContainer.vala"
	((PlankDockElementClass *) klass)->reset_buffers = (void (*) (PlankDockElement*)) plank_dock_container_real_reset_buffers;
#line 26 "../lib/Items/DockContainer.vala"
	((PlankDockContainerClass *) klass)->replace = (gboolean (*) (PlankDockContainer*, PlankDockElement*, PlankDockElement*)) plank_dock_container_real_replace;
#line 26 "../lib/Items/DockContainer.vala"
	((PlankDockContainerClass *) klass)->connect_element = (void (*) (PlankDockContainer*, PlankDockElement*)) plank_dock_container_real_connect_element;
#line 26 "../lib/Items/DockContainer.vala"
	((PlankDockContainerClass *) klass)->disconnect_element = (void (*) (PlankDockContainer*, PlankDockElement*)) plank_dock_container_real_disconnect_element;
#line 26 "../lib/Items/DockContainer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_dock_container_get_property;
#line 26 "../lib/Items/DockContainer.vala"
	G_OBJECT_CLASS (klass)->constructor = plank_dock_container_constructor;
#line 26 "../lib/Items/DockContainer.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_dock_container_finalize;
#line 1964 "DockContainer.c"
	/**
	 * The ordered list of the visible dock elements.
	 */
#line 26 "../lib/Items/DockContainer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_CONTAINER_VISIBLE_ELEMENTS_PROPERTY, plank_dock_container_properties[PLANK_DOCK_CONTAINER_VISIBLE_ELEMENTS_PROPERTY] = g_param_spec_object ("VisibleElements", "VisibleElements", "VisibleElements", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1970 "DockContainer.c"
	/**
	 * The list of the all containing dock elements.
	 */
#line 26 "../lib/Items/DockContainer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_DOCK_CONTAINER_ELEMENTS_PROPERTY, plank_dock_container_properties[PLANK_DOCK_CONTAINER_ELEMENTS_PROPERTY] = g_param_spec_object ("Elements", "Elements", "Elements", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1976 "DockContainer.c"
	/**
	 * Triggered when the collection of elements has changed.
	 *
	 * @param added the list of added elements
	 * @param removed the list of removed elements
	 */
#line 26 "../lib/Items/DockContainer.vala"
	plank_dock_container_signals[PLANK_DOCK_CONTAINER_ELEMENTS_CHANGED_SIGNAL] = g_signal_new ("elements-changed", PLANK_TYPE_DOCK_CONTAINER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEE_TYPE_LIST, GEE_TYPE_LIST);
#line 1985 "DockContainer.c"
	/**
	 * Triggered when the state of an element changes.
	 */
#line 26 "../lib/Items/DockContainer.vala"
	plank_dock_container_signals[PLANK_DOCK_CONTAINER_STATES_CHANGED_SIGNAL] = g_signal_new ("states-changed", PLANK_TYPE_DOCK_CONTAINER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1991 "DockContainer.c"
	/**
	 * Triggered anytime element-positions were changed.
	 *
	 * @param elements the list of moved elements
	 */
#line 26 "../lib/Items/DockContainer.vala"
	plank_dock_container_signals[PLANK_DOCK_CONTAINER_POSITIONS_CHANGED_SIGNAL] = g_signal_new ("positions-changed", PLANK_TYPE_DOCK_CONTAINER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_LIST);
#line 32 "../lib/Items/DockContainer.vala"
	_tmp0_ = plank_placeholder_dock_item_new ();
#line 32 "../lib/Items/DockContainer.vala"
	_g_object_unref0 (plank_dock_container_placeholder_item);
#line 32 "../lib/Items/DockContainer.vala"
	plank_dock_container_placeholder_item = _tmp0_;
#line 2005 "DockContainer.c"
}

static void
plank_dock_container_instance_init (PlankDockContainer * self,
                                    gpointer klass)
{
}

static void
plank_dock_container_finalize (GObject * obj)
{
	PlankDockContainer * self;
	PlankPlaceholderDockItem* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeHashSet* elements = NULL;
	GeeHashSet* _tmp2_;
	GeeHashSet* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp12_;
#line 26 "../lib/Items/DockContainer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_DOCK_CONTAINER, PlankDockContainer);
#line 94 "../lib/Items/DockContainer.vala"
	_tmp0_ = plank_dock_container_placeholder_item;
#line 94 "../lib/Items/DockContainer.vala"
	plank_dock_container_disconnect_element (self, (PlankDockElement*) _tmp0_);
#line 96 "../lib/Items/DockContainer.vala"
	_tmp1_ = self->visible_elements;
#line 96 "../lib/Items/DockContainer.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
#line 98 "../lib/Items/DockContainer.vala"
	_tmp2_ = gee_hash_set_new (PLANK_TYPE_DOCK_ELEMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 98 "../lib/Items/DockContainer.vala"
	elements = _tmp2_;
#line 99 "../lib/Items/DockContainer.vala"
	_tmp3_ = elements;
#line 99 "../lib/Items/DockContainer.vala"
	_tmp4_ = self->internal_elements;
#line 99 "../lib/Items/DockContainer.vala"
	gee_collection_add_all ((GeeCollection*) _tmp3_, (GeeCollection*) _tmp4_);
#line 2045 "DockContainer.c"
	{
		GeeIterator* _element_it = NULL;
		GeeHashSet* _tmp5_;
		GeeIterator* _tmp6_;
#line 100 "../lib/Items/DockContainer.vala"
		_tmp5_ = elements;
#line 100 "../lib/Items/DockContainer.vala"
		_tmp6_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp5_);
#line 100 "../lib/Items/DockContainer.vala"
		_element_it = _tmp6_;
#line 100 "../lib/Items/DockContainer.vala"
		while (TRUE) {
#line 2058 "DockContainer.c"
			GeeIterator* _tmp7_;
			PlankDockElement* element = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			PlankDockElement* _tmp10_;
			PlankDockElement* _tmp11_;
#line 100 "../lib/Items/DockContainer.vala"
			_tmp7_ = _element_it;
#line 100 "../lib/Items/DockContainer.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 100 "../lib/Items/DockContainer.vala"
				break;
#line 2071 "DockContainer.c"
			}
#line 100 "../lib/Items/DockContainer.vala"
			_tmp8_ = _element_it;
#line 100 "../lib/Items/DockContainer.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 100 "../lib/Items/DockContainer.vala"
			element = (PlankDockElement*) _tmp9_;
#line 101 "../lib/Items/DockContainer.vala"
			_tmp10_ = element;
#line 101 "../lib/Items/DockContainer.vala"
			plank_dock_container_remove_without_signaling (self, _tmp10_);
#line 102 "../lib/Items/DockContainer.vala"
			_tmp11_ = element;
#line 102 "../lib/Items/DockContainer.vala"
			plank_dock_element_set_Container (_tmp11_, NULL);
#line 100 "../lib/Items/DockContainer.vala"
			_g_object_unref0 (element);
#line 2089 "DockContainer.c"
		}
#line 100 "../lib/Items/DockContainer.vala"
		_g_object_unref0 (_element_it);
#line 2093 "DockContainer.c"
	}
#line 104 "../lib/Items/DockContainer.vala"
	_tmp12_ = self->internal_elements;
#line 104 "../lib/Items/DockContainer.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp12_);
#line 26 "../lib/Items/DockContainer.vala"
	_g_object_unref0 (elements);
#line 73 "../lib/Items/DockContainer.vala"
	_g_object_unref0 (self->visible_elements);
#line 74 "../lib/Items/DockContainer.vala"
	_g_object_unref0 (self->internal_elements);
#line 26 "../lib/Items/DockContainer.vala"
	G_OBJECT_CLASS (plank_dock_container_parent_class)->finalize (obj);
#line 2107 "DockContainer.c"
}

/**
 * A container and controller class for managing dock elements on a dock.
 */
static GType
plank_dock_container_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankDockContainerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_dock_container_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankDockContainer), 0, (GInstanceInitFunc) plank_dock_container_instance_init, NULL };
	GType plank_dock_container_type_id;
	plank_dock_container_type_id = g_type_register_static (PLANK_TYPE_DOCK_ELEMENT, "PlankDockContainer", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return plank_dock_container_type_id;
}

GType
plank_dock_container_get_type (void)
{
	static volatile gsize plank_dock_container_type_id__once = 0;
	if (g_once_init_enter (&plank_dock_container_type_id__once)) {
		GType plank_dock_container_type_id;
		plank_dock_container_type_id = plank_dock_container_get_type_once ();
		g_once_init_leave (&plank_dock_container_type_id__once, plank_dock_container_type_id);
	}
	return plank_dock_container_type_id__once;
}

static void
_vala_plank_dock_container_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	PlankDockContainer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_DOCK_CONTAINER, PlankDockContainer);
#line 26 "../lib/Items/DockContainer.vala"
	switch (property_id) {
#line 26 "../lib/Items/DockContainer.vala"
		case PLANK_DOCK_CONTAINER_VISIBLE_ELEMENTS_PROPERTY:
#line 26 "../lib/Items/DockContainer.vala"
		g_value_set_object (value, plank_dock_container_get_VisibleElements (self));
#line 26 "../lib/Items/DockContainer.vala"
		break;
#line 26 "../lib/Items/DockContainer.vala"
		case PLANK_DOCK_CONTAINER_ELEMENTS_PROPERTY:
#line 26 "../lib/Items/DockContainer.vala"
		g_value_set_object (value, plank_dock_container_get_Elements (self));
#line 26 "../lib/Items/DockContainer.vala"
		break;
#line 2156 "DockContainer.c"
		default:
#line 26 "../lib/Items/DockContainer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../lib/Items/DockContainer.vala"
		break;
#line 2162 "DockContainer.c"
	}
}

